/* ----------------------------- DEFINICE TYP ----------------------------- */

/* Pro cross-set mnoiny */
/* pro 'lo' poloku */
#define ONES                    (unsigned int)0xffffffff /* 32 bit */
/* pro 'hi' poloku */
#define ONES2                   (unsigned int)0x1ffff    /* prvnch 17 vpravo */

/* Struktura pro ukldn crosscheck mnoin -- psmen, kter jsou
   platn pro slova utvoen vertikln (resp. otoen o 90 stup).
*/
typedef struct {                /*  76543210765432107654321076543210  */ 
    unsigned int lo;            /* "rqponmlkjihgfedcba" */
    unsigned int hi;            /* "00000000000000?zyxwvuts" */
} tcross;

typedef tcross vcross[2];	/* [0]=ZD [1]=SD */

typedef struct { /* Pro ukldn pozic [x,y] */
    unsigned int x;
    unsigned int y;
} tpozice;

typedef tpozice Pos; /* Alias */

typedef enum eorientace { ZD, SD } torientace; /* ZD - Zleva Doprava */
                                               /* SD - Shora Dol    */
#define KOLMO(o)	((o==ZD) ? SD : ZD )
#define PRED(p,o)	((o == ZD) ? (Pos){p.x, p.y-1} : (Pos) {p.x-1, p.y})
#define ZA(p,o)		((o == ZD) ? (Pos){p.x, p.y+1} : (Pos) {p.x+1, p.y})
#define OKRAJ(p) 	(p.x == 0 || p.y == 0 || p.x == 16 || p.y == 16)
#define PISMENO(p) 	(board[p.x][p.y].znak)
#define HODNOTA(p) 	(board[p.x][p.y].hodnota)


/* --------------------- DEFINICE GLOBALNCH PROMNNCH --------------------- */

EXPORT vcross cross[MAX_ROZMER][MAX_ROZMER];
EXPORT void cross_resetuj_struktury(void);
EXPORT void aktualizuj_cross_set(int horiz);
EXPORT boolean je_v_cross_set(tpozice p, torientace o, char pismeno);
EXPORT boolean JEPISMENO(tpozice p);

/* -------------- PLN FUNKN PROTOTYPY EXPORTOVANCH FUNKC ------------- */
