#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "gui_okno.h"
#include "cross.h"
#include "vacek.h"
#include "konverze.h"

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void gui_zobraz_cetnosti(void);
GLOBAL void gui_zobraz_cetnosti_zbylych(void);

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* -------------------------------------------------------------------------- */
/* ---------------------- OKNO S ETNOSTMI PSMEN --------------------------- */
/* -------------------------------------------------------------------------- */

/* Zobraz CList s etnostmi psmen pro hru */
GLOBAL void gui_zobraz_cetnosti(void) {

    GtkWidget *dialog;
    GtkWidget *label;
    GtkWidget *scroll_okno;
    GtkWidget *freq_clist;

    int reply;

    int i;    
    
    gchar *hlavicka[3] = { "Psmeno", "Body", "Poet" };
    char *radek[3];
    
    char znak[5] = "";
    char body[10] = "";
    char pocet[10] = "";
  
    dialog = gnome_dialog_new("etnosti psmen", GNOME_STOCK_BUTTON_OK, NULL); 
    gnome_dialog_set_parent(GNOME_DIALOG (dialog), GTK_WINDOW (app));
    gnome_dialog_set_default (GNOME_DIALOG (dialog), GNOME_OK);
    gnome_dialog_close_hides(GNOME_DIALOG (dialog), FALSE);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
   
    
    label = gtk_label_new("etnosti psmen");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	               label, FALSE, FALSE, 5);
	
    scroll_okno = gtk_scrolled_window_new (NULL, NULL);
    gtk_widget_set_usize(scroll_okno, 170, 395);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_okno),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	               scroll_okno, FALSE, FALSE, 3);
   
    freq_clist = gtk_clist_new_with_titles(3, hlavicka); 
    gtk_clist_set_shadow_type(GTK_CLIST(freq_clist), GTK_SHADOW_OUT);
    gtk_clist_set_column_width (GTK_CLIST(freq_clist), 0, 50);
    gtk_clist_set_column_width (GTK_CLIST(freq_clist), 1, 30);
    gtk_clist_set_column_width (GTK_CLIST(freq_clist), 2, 25);
    gtk_container_add(GTK_CONTAINER(scroll_okno), freq_clist);
   
    for(i=0;i<vacek_pocet_ruznych_kamenu();i++) {

	znak[0] = sada_cetnosti[i].znak; znak[1] = '\0';
	sprintf(body, "%d", sada_cetnosti[i].hodnota);
	sprintf(pocet, "%d", sada_cetnosti[i].pocet);

	radek[0] = znak;
	radek[1] = body;
	radek[2] = pocet;
	
	/* "Nasypej to do oknka */
	gtk_clist_append(GTK_CLIST(freq_clist), radek);
	
    }/* end for */
    
    gtk_widget_show_all(dialog);

    reply = gnome_dialog_run_and_close(GNOME_DIALOG(dialog));
    
}/* end of gui_zobraz_cetnosti() */

/* -------------------------------------------------------------------------- */
/* ----------------- OKNO S ETNOSTMI ZBYLCH PSMEN VE VKU --------------- */
/* -------------------------------------------------------------------------- */

/* Zobraz CList s etnostmi zbylch psmen pro hru 
 * (ty, co jsou jet ve vku). 
*/
GLOBAL void gui_zobraz_cetnosti_zbylych(void) {

    GtkWidget *dialog;
    GtkWidget *label;
    GtkWidget *scroll_okno;
    GtkWidget *freq_clist;

    int reply;

    int i, j;
    gchar *hlavicka[2] = { "Psmeno", "Poet" };
    char *radek[2];
    
    char znak[5] = "";
    char pocet[10] = "";

    int vektor[MAX_VEL_ABECEDY];		/* Pro zbyl psmena */

    dialog = gnome_dialog_new("etnosti zbylch psmen ve vku", 
	    GNOME_STOCK_BUTTON_OK, NULL); 
    gnome_dialog_set_parent(GNOME_DIALOG (dialog), GTK_WINDOW (app));
    gnome_dialog_set_default (GNOME_DIALOG (dialog), GNOME_OK);
    gnome_dialog_close_hides(GNOME_DIALOG (dialog), FALSE);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);

    label = gtk_label_new("etnosti zbylch psmen\n ve vku");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	               label, FALSE, FALSE, 5);
	
    scroll_okno = gtk_scrolled_window_new (NULL, NULL);
    gtk_widget_set_usize(scroll_okno, 80, 395);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_okno),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	               scroll_okno, FALSE, FALSE, 3);
   
    freq_clist = gtk_clist_new_with_titles(2, hlavicka); 
    gtk_clist_set_shadow_type(GTK_CLIST(freq_clist), GTK_SHADOW_OUT);
    gtk_clist_set_column_width (GTK_CLIST(freq_clist), 0, 50);
    gtk_clist_set_column_width (GTK_CLIST(freq_clist), 1, 25);
    gtk_container_add(GTK_CONTAINER(scroll_okno), freq_clist);
 
    /* dn zbyl psmena */
    for(i=0;i<MAX_VEL_ABECEDY;i++)
       vektor[i] = 0;	
    
    /* Od aktuln pozice pro dal tahy psmen a do konce. */
    for(i=vacek_dej_pozici_ve_vacku();i<vacek_pocet_kamenu();i++) {
	
	/* Pozice do pole 'sada_kamenu[]' */
	j = vacek[i].poradi;

	/* sada_kamenu[j].znak je znak na pozici 'i' ve vku */
	vektor[znak2index(sada_kamenu[j].znak)]++;
	
    }/* end for */

    /* v poli 'vektor[]' jsou nyn etnosti zbylch psmen ve vku */

    /* Projdeme cel vektor a zobrazme nenulov poloky */
    for(i=0; i<MAX_VEL_ABECEDY; i++) {

	if (vektor[i]) {
	    
	    znak[0] = index2znak(i); znak[1] = '\0';
	    sprintf(pocet, "%d", vektor[i]);
	    
	    radek[0] = znak;
	    radek[1] = pocet;	    
	    	    
	    /* Nasypej to do oknka */
	    if (vektor[i] > 0)
		gtk_clist_append(GTK_CLIST(freq_clist), radek);
	    
	}/* end if */
	
    }/* end for */
    
    gtk_widget_show_all(dialog);

    reply = gnome_dialog_run_and_close(GNOME_DIALOG(dialog));
    
}/* end of zobraz_cetnosti_zbylych() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_cetnosti.c */
