#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "gui_okno.h"
#include "gui_deska.h"
#include "hra.h"
#include "util.h"
#include "logovani.h"

/* --------------------- DEFINICE GLOBALNCH PROMNNCH --------------------- */

/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

LOCAL GtkWidget *checkbox;

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void gui_logovani_zobraz_dialog(void);
GLOBAL void gui_logovani_chyba(GtkWindow *okno);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

LOCAL gint gui_logovani_vyber_soubor_callback(GtkWidget *w, gpointer data);
LOCAL gint gui_logovani_vyber_std_callback(GtkWidget *w, gpointer data);

/* -------------------------------------------------------------------------- */

/* Reaguje na checkbox v okn  */
LOCAL void gui_logovani_checkbox_callback(gpointer cbox) {

    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(cbox)) == TRUE)
	logovat_prubeh |= 1;
    else
	logovat_prubeh = logovat_prubeh & ~1;

}/* end of gui_logovani_checkbox_callback() */

/* -------------------------------------------------------------------------- */

/* Zobraz dialogov okno s monost vybrn kam budou
 * smrovny informace o prbhu hry (logovn).
*/
GLOBAL void gui_logovani_zobraz_dialog(void) {

    GtkWidget *label;
    GtkWidget *vyber_b;
    GtkWidget *std_b;

    GtkWidget *dialog; 
    GtkWidget *dialog_hbox;

    dialog = gnome_dialog_new("Logovn prbhu hry.", 
	                      GNOME_STOCK_BUTTON_OK, NULL);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(app));

    label = gtk_label_new("Logovn prbhu hry.");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
		       label, FALSE, FALSE, 0);

    /* hbox rozdl okno na 2 plky, v lev bude okno se seznamem
     * a v prav buttonky.
    */
    dialog_hbox = gtk_hbox_new(FALSE, 10);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
		       dialog_hbox, FALSE, FALSE, 0);

    vyber_b = gtk_button_new_with_label("Vyber soubor");
    set_tooltip(vyber_b, "Vybere soubor, do kterho se bude ukldat.");
    gtk_box_pack_start(GTK_BOX(dialog_hbox), vyber_b, FALSE, FALSE, 0);
    gtk_signal_connect (GTK_OBJECT(vyber_b), "clicked",
                        GTK_SIGNAL_FUNC(gui_logovani_vyber_soubor_callback), 
			(gpointer) dialog);
    
    std_b = gtk_button_new_with_label("Zvol standardn zpsob.");
    set_tooltip(std_b, "Bude ukldat do implicitnho souboru "
	               "'~/.scarabeus/scarabeus-DD-MM-RRRR-HH-MM.log'.");
    gtk_box_pack_start(GTK_BOX(dialog_hbox), std_b, FALSE, FALSE, 0);
    gtk_signal_connect (GTK_OBJECT(std_b), "clicked",
                        GTK_SIGNAL_FUNC(gui_logovani_vyber_std_callback), 
			(gpointer) dialog);

    checkbox = gtk_check_button_new_with_label("Pouvat logovn.");
    gtk_signal_connect (GTK_OBJECT(checkbox), "toggled",
                        GTK_SIGNAL_FUNC(gui_logovani_checkbox_callback), 
			(gpointer) checkbox);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), checkbox,
                        FALSE, FALSE, 0);

    /* Zakrtni checkbox podle volby 'pouzit_zakazana' */
    gtk_widget_set_sensitive(GTK_WIDGET(checkbox), FALSE);
    if (logovat_prubeh & 1)
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), TRUE);
    else
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), FALSE);

    gtk_widget_set_sensitive(GTK_WIDGET(checkbox), TRUE);
    
    gtk_widget_show_all(dialog);

    gnome_dialog_run_and_close(GNOME_DIALOG(dialog));

    /* Ulo aktuln nastaven checkboxu */
    gnome_config_push_prefix(GuiPrefix);
    gnome_config_set_int("LOGOVAT_PRUBEH", logovat_prubeh);

    /* Jen pokud byl vybrn soubor */
    if (logovat_prubeh == 3)
	gnome_config_set_string("LOGOVANI_SOUBOR", LOGOVANI_SOUBOR);
	
    gnome_config_pop_prefix();
    gnome_config_sync();
    
}/* end of gui_logovani_zobraz_dialog() */

/* -------------------------------------------------------------------------- */

/* Vybere soubor, do kterho povedou logovac hlky */
LOCAL gint gui_logovani_vyber_soubor_callback(GtkWidget *w, gpointer data) {

    GtkWidget *label;
    GtkWidget *dialog;
    GtkWidget *file_entry;
    GtkWidget *hsep;

    char *cesta = NULL;         /* Cesta k automatu */

    int reply;

    if (game_mode != STOP_MODE)
	return(TRUE);

    dialog = gnome_dialog_new(N_("Vbr souboru pro logovn."),
                            GNOME_STOCK_BUTTON_OK,
                            GNOME_STOCK_BUTTON_CANCEL,
                            NULL);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(data));
    gtk_window_set_title(GTK_WINDOW(data), "Vbr souboru pro logovn.");

    label = gtk_label_new("Vyberte soubor, kam se bude ukldat prbh hry.");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
            label, FALSE, FALSE, 0);

    hsep = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
            hsep, FALSE, FALSE, 0);

    file_entry = gnome_file_entry_new(NULL, 
		"Vyberte soubor, kam se bude ukldat prbh hry.");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
            file_entry, FALSE, FALSE, 0);

    /* Zobraz dialog */
    gtk_widget_show_all(dialog);

    /* Stisknuto 'OK' nebo 'CANCEL' */
    reply = gnome_dialog_run(GNOME_DIALOG(dialog));


    if (reply == GNOME_OK) {
        cesta = gnome_file_entry_get_full_path(
		    GNOME_FILE_ENTRY(file_entry), FALSE);

	/* Przdn textentry zpsob error! */
	if (cesta)
	    strcpy(LOGOVANI_SOUBOR, cesta);
	else {
	    gui_logovani_chyba(GTK_WINDOW(data));
	    
	    /* Zakrtni checkbox podle volby 'pouzit_zakazana' */
	    gtk_widget_set_sensitive(GTK_WIDGET(checkbox), FALSE);
	    if (logovat_prubeh & 1)
	      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), TRUE);
	    else
	      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), FALSE);
	    gtk_widget_set_sensitive(GTK_WIDGET(checkbox), TRUE);
	}

    }/* end if */

    /* Uklidme po sob */
    if (cesta) 
        g_free((gpointer) cesta);

    
    logovat_prubeh |= 2;

    gtk_widget_destroy(dialog);

    return(TRUE);

}/* end of gui_logovani_vyber_soubor_callback() */

/* -------------------------------------------------------------------------- */

/* Nastav LOGOVANI_SOUBOR na defaultn hodnotu, tj. nzev souboru
 * s logem bude vypadat nsledovn:
 * 'scarabeus-DD-MM-RRRR-HH-MM.log'
*/
LOCAL gint gui_logovani_vyber_std_callback(GtkWidget *w, gpointer data) {

    logovani_nastav_std_nazev();

    logovat_prubeh = logovat_prubeh & ~2;
    
    return(TRUE);
    
}/* end of gui_logovani_vyber_std_callback() */

/* -------------------------------------------------------------------------- */

/* Zobraz chybov okno, e nelze zapisovat do souboru a 
 * e nebude dle probhat logovn.
*/
GLOBAL void gui_logovani_chyba(GtkWindow *okno) {

    show_warning_window(GTK_WINDOW(okno),
	    "Nedefinovn soubor pro ukldn!.\n"
	    "Logovn nebude provdno.");
    logovat_prubeh = FALSE;

}/* end of gui_logovani_chyba() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_logovani.c */
