#include<stdlib.h>
#include<ctype.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "gui_nastaveni.h"
#include "config.h"
#include "gui_okno.h"
#include "gui_deska.h"
#include "gui_util.h"
#include "cross.h"
#include "konverze.h"
#include "util.h"
#include "slovniky.h"

/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

LOCAL gchar sada[DMAX];				/* Psmena do comba */
LOCAL int sada_delka;
LOCAL GtkWidget *sada_clist;
LOCAL GtkWidget *slov_clist;

LOCAL GtkWidget *property_box;			/* Dialog pro Nastaven */

LOCAL GtkWidget *tlacitka[MAX_ROZMER][MAX_ROZMER];

LOCAL GtkWidget *cp1, *cp2, *cp3, *cp4, *cp5; 		/* Buttonky s barvami */
LOCAL GtkWidget *fentry1, *fentry2, *fentry3, *fentry4; /* font entries */
LOCAL GtkWidget *dentry1, *dentry2, *dentry3, *dentry4; /* deska entries */
LOCAL GtkWidget *bentry1, *bentry2, *bentry3, *bentry4; /* bonus entries */

LOCAL boolean upr_odeber = FALSE;	   /* TRUE = lze upravovat/mazat */
LOCAL boolean slov_upr_odeber = FALSE;	   /* Tot pro slovnky */

LOCAL int selected_row;		 /* Vybran dek v sada_clistu */
LOCAL int slov_selected_row;	 /* Tot pro slov_clist */

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void zobraz_nastaveni(void);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */
LOCAL void color_picked_callback(GtkWidget *w, 
	   guint r, guint g, guint b, guint a, gpointer data);
LOCAL void font_set_callback(GnomeFontPicker *fontpicker,
                             gchar *selected,
                             gpointer user_data);

LOCAL void set_bonus_button_callback(GtkWidget *w, gpointer data);
LOCAL void reset_button_callback(GtkWidget *w, gpointer data);
LOCAL void bonus_button_callback(GtkWidget *w, gpointer data);

LOCAL void pridej_button_callback(GtkWidget *w, gpointer data);
LOCAL void uprav_button_callback(GtkWidget *w, gpointer data);
LOCAL void odeber_button_callback(GtkWidget *w, gpointer data);
LOCAL void vymaz_button_callback(GtkWidget *w, gpointer data);
LOCAL void default_button_callback(GtkWidget *w, gpointer data);
LOCAL void sada_clist_callback(GtkWidget *w, gint row, gint column,
			       GdkEventButton *event, gpointer data);

LOCAL void slov_pridej_button_callback(GtkWidget *w, gpointer data);
LOCAL void slov_odeber_button_callback(GtkWidget *w, gpointer data);
LOCAL void slov_clist_callback(GtkWidget *w, gint row, gint column,
                               GdkEventButton *event, gpointer data);
LOCAL void slov_info_button_callback(GtkWidget *w, gpointer data);
LOCAL gint f_clist_porovnej(GtkCList *clist, 
			    gconstpointer ptr1, gconstpointer ptr2);

LOCAL void nastaveni_napln_bonus_pole(void);
LOCAL void nastaveni_napln_slov_list(tpreference *p);
LOCAL void nastaveni_napln_nove_nastaveni(void);
LOCAL boolean nastaveni_nastaly_zmeny(void);
LOCAL void nastaveni_show_info_restart(void);
LOCAL void nastaveni_checkbox_callback(void);
LOCAL void nastaveni_vymen_akt_nov(void);
LOCAL boolean nastaveni_jsou_platna_pole_desky(void);
LOCAL boolean nastaveni_jsou_platna_pole_bonusu(void);

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* Porovnvac funkce pro clist.
 * Vrac:  0 <=> a==b
 *        -1 <=> a > b
 *        +1 <=> a < b
*/
LOCAL gint f_clist_porovnej(GtkCList *clist, 
			    gconstpointer ptr1, gconstpointer ptr2) {

    char *text1 = NULL;
    char *text2 = NULL;

    int i, j;

    GtkCListRow *a = (GtkCListRow *) ptr1;
    GtkCListRow *b = (GtkCListRow *) ptr2;

    text1 = GTK_CELL_TEXT(a->cell[0])->text;
    text2 = GTK_CELL_TEXT(b->cell[0])->text;

    i = znak2index(text1[0]);
    j = znak2index(text2[0]); 
    
    if ( i > j )
	return(1);
    if ( i == j )
	return(0);
    else 
	return(-1);
    
    
}/* end of f_clist_porovnej() */

/* -------------------------------------------------------------------------- */

/* Ve z nastaven 'nov' penes do 'akt' */
LOCAL void nastaveni_vymen_akt_nov(void) {

    /* Fonty */
    strcpy(akt.KAMEN_FONT, nov.KAMEN_FONT);
    strcpy(akt.HODNOTA_FONT, nov.HODNOTA_FONT);
    strcpy(akt.POPIS_FONT, nov.POPIS_FONT);
    strcpy(akt.BONUS_FONT, nov.BONUS_FONT);

    /* Deska */
    akt.POC_KAMENU_SIRKA = nov.POC_KAMENU_SIRKA;
    akt.POC_KAMENU_VYSKA = nov.POC_KAMENU_VYSKA;
    akt.MAX_PISMEN_PRIHRADKA = nov.MAX_PISMEN_PRIHRADKA;
    akt.VEL_KAMENE = nov.VEL_KAMENE;

    /* Barvy */
    akt.BARVA1 = nov.BARVA1;
    akt.BARVA2 = nov.BARVA2;
    akt.BARVA3 = nov.BARVA3;
    akt.BARVA4 = nov.BARVA4;
    akt.BARVA5 = nov.BARVA5;

    /* Hrac kameny */
    akt.PISMX2 = nov.PISMX2;
    akt.PISMX3 = nov.PISMX3;
    akt.SLOVOX2 = nov.SLOVOX2;
    akt.SLOVOX3 = nov.SLOVOX3;
   
    /* Bonusov pole */ 
    strcpy(akt.PISMENO2POLE, nov.PISMENO2POLE);
    strcpy(akt.PISMENO3POLE, nov.PISMENO3POLE);
    strcpy(akt.SLOVO2POLE, nov.SLOVO2POLE);
    strcpy(akt.SLOVO3POLE, nov.SLOVO3POLE);
   
    /* Sada psmen */ 
    strcpy(akt.SADA_PISMEN, nov.SADA_PISMEN);

    /* Extern slovnky */
    strcpy(akt.SLOVNIKY, nov.SLOVNIKY);
    
}/* nastaveni_vymen_akt_nov() */

/* -------------------------------------------------------------------------- */

/* Vrt TRUE, pokud dolo v konfiguranm okn k njakm zmnm */
LOCAL boolean nastaveni_nastaly_zmeny(void) {


    /* Njak zmna font? */
    if ((strcmp(akt.KAMEN_FONT, nov.KAMEN_FONT)) != 0)
	return(TRUE);
    if ((strcmp(akt.HODNOTA_FONT, nov.HODNOTA_FONT)) != 0)
	return(TRUE);
    if ((strcmp(akt.HODNOTA_FONT, nov.HODNOTA_FONT)) != 0)
	return(TRUE);
    if ((strcmp(akt.BONUS_FONT, nov.BONUS_FONT)) != 0) 
	return(TRUE);
    

    /* Zmny na desce? */
    if (akt.MAX_PISMEN_PRIHRADKA != nov.MAX_PISMEN_PRIHRADKA)
	return(TRUE);
    if (akt.POC_KAMENU_SIRKA != nov.POC_KAMENU_SIRKA)
	return(TRUE);
    if (akt.POC_KAMENU_VYSKA != nov.POC_KAMENU_VYSKA)
	return(TRUE);
    if (akt.VEL_KAMENE != nov.VEL_KAMENE)
	return(TRUE);
    
    /* Zmny barev? */
    if (akt.BARVA1 != nov.BARVA1)
	return(TRUE);
    if (akt.BARVA2 != nov.BARVA2)
	return(TRUE);
    if (akt.BARVA3 != nov.BARVA3)
	return(TRUE);
    if (akt.BARVA4 != nov.BARVA4)
	return(TRUE);
    if (akt.BARVA5 != nov.BARVA5)
	return(TRUE);

    /* Zmny definovanch kamen */
    if (akt.SLOVOX2 != nov.SLOVOX2)
	return(TRUE);
    if (akt.SLOVOX3 != nov.SLOVOX3)
	return(TRUE);
    if (akt.PISMX2 != nov.PISMX2)
	return(TRUE);
    if (akt.PISMX3 != nov.PISMX3)
	return(TRUE);
    
    if ((strcmp(akt.SLOVO2POLE, nov.SLOVO2POLE)) != 0)
	return(TRUE);
    if ((strcmp(akt.SLOVO3POLE, nov.SLOVO3POLE)) != 0)
	return(TRUE);
    if ((strcmp(akt.PISMENO2POLE, nov.PISMENO2POLE)) != 0)
	return(TRUE);
    if ((strcmp(akt.PISMENO3POLE, nov.PISMENO3POLE)) != 0)
	return(TRUE);

    /* Sada psmen */
    if ((strcmp(akt.SADA_PISMEN, nov.SADA_PISMEN)) != 0)
	return(TRUE);

    /* Extern slovnky */
    if ((strcmp(akt.SLOVNIKY, nov.SLOVNIKY)) != 0)
	return(TRUE);

    return(FALSE); 

}/* end of nastaveni_nastaly_zmeny() */

/* -------------------------------------------------------------------------- */

/* Nastav hodnoty nastaven na hodnoty pro klasick Scrabble */
LOCAL void default_button_callback(GtkWidget *w, gpointer data) {

  char s[5];
  guint8 r, g, b, a;

  /* Fonty */
  strcpy(nov.KAMEN_FONT,
	  "-adobe-times-bold-r-normal--20-*-*-*-*-*-iso8859-2");
  strcpy(nov.HODNOTA_FONT, 
	  "-adobe-times-bold-r-normal--10-*-*-*-*-*-iso8859-2");
  strcpy(nov.POPIS_FONT,
	  "-adobe-times-bold-r-normal--12-*-*-*-*-*-iso8859-2");
  strcpy(nov.BONUS_FONT,
	  "-*-helvetica-bold-r-normal--12-*-*-*-*-*-iso8859-2");

  gtk_entry_set_text(GTK_ENTRY(fentry1), nov.KAMEN_FONT);
  gtk_entry_set_text(GTK_ENTRY(fentry2), nov.HODNOTA_FONT);
  gtk_entry_set_text(GTK_ENTRY(fentry3), nov.POPIS_FONT);
  gtk_entry_set_text(GTK_ENTRY(fentry4), nov.BONUS_FONT);

  /* Deska */
  nov.POC_KAMENU_SIRKA = 15; nov.POC_KAMENU_VYSKA = 15;
  nov.MAX_PISMEN_PRIHRADKA = 7; nov.VEL_KAMENE = 32;

  sprintf(s, "%d", nov.POC_KAMENU_SIRKA);
  gtk_entry_set_text(GTK_ENTRY(dentry1), s);
  
  sprintf(s, "%d", nov.POC_KAMENU_VYSKA);
  gtk_entry_set_text(GTK_ENTRY(dentry2), s);
  
  sprintf(s, "%d", nov.VEL_KAMENE);
  gtk_entry_set_text(GTK_ENTRY(dentry3), s);
  
  sprintf(s, "%d", nov.MAX_PISMEN_PRIHRADKA);
  gtk_entry_set_text(GTK_ENTRY(dentry4), s);

  /* Barvy */
  nov.BARVA1 = 0x5BBD29FF; /* green */
  nov.BARVA2 = 0xA5D7EFFF; /* cyan */
  nov.BARVA3 = 0x00B4DFFF; /* blue */
  nov.BARVA4 = 0xF7BB83FF; /* pink */
  nov.BARVA5 = 0xE97117FF; /* red */

    r = (nov.BARVA1 & 0xFF000000) % 0x00FFFFFF;
    g = (nov.BARVA1 & 0x00FF0000) % 0xFFFF;
    b = (nov.BARVA1 & 0x0000FF00) % 0xFF;
    a = 0xFF;
  gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp1), r, g, b, a);
    r = (nov.BARVA2 & 0xFF000000) % 0x00FFFFFF;
    g = (nov.BARVA2 & 0x00FF0000) % 0xFFFF;
    b = (nov.BARVA2 & 0x0000FF00) % 0xFF;
    a = 0xFF;
  gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp2), r, g, b, a);
    r = (nov.BARVA3 & 0xFF000000) % 0x00FFFFFF;
    g = (nov.BARVA3 & 0x00FF0000) % 0xFFFF;
    b = (nov.BARVA3 & 0x0000FF00) % 0xFF;
    a = 0xFF;
  gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp3), r, g, b, a);
    r = (nov.BARVA4 & 0xFF000000) % 0x00FFFFFF;
    g = (nov.BARVA4 & 0x00FF0000) % 0xFFFF;
    b = (nov.BARVA4 & 0x0000FF00) % 0xFF;
    a = 0xFF;
  gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp4), r, g, b, a);
    r = (nov.BARVA5 & 0xFF000000) % 0x00FFFFFF;
    g = (nov.BARVA5 & 0x00FF0000) % 0xFFFF;
    b = (nov.BARVA5 & 0x0000FF00) % 0xFF;
    a = 0xFF;
  gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp5), r, g, b, a);

  /* Kameny */
  nov.SLOVOX2 = 2; nov.SLOVOX3 = 3; nov.PISMX2 = 2; nov.PISMX3 = 3;

  sprintf(s, "%d", nov.PISMX2); gtk_entry_set_text(GTK_ENTRY(bentry1), s);
  sprintf(s, "%d", nov.PISMX3); gtk_entry_set_text(GTK_ENTRY(bentry2), s);
  sprintf(s, "%d", nov.SLOVOX2); gtk_entry_set_text(GTK_ENTRY(bentry3), s);
  sprintf(s, "%d", nov.SLOVOX3); gtk_entry_set_text(GTK_ENTRY(bentry4), s);

  strcpy(nov.SLOVO2POLE, 
	  "2,2;2,14;3,3;3,13;4,4;4,12;5,5;5,11;8,8;11,5;11,11;12,4;12,12;13,3;13,13;14,2;14,14;");
  strcpy(nov.SLOVO3POLE,
	  "1,1;1,8;1,15;8,1;8,15;15,1;15,8;15,15;");
  strcpy(nov.PISMENO2POLE,
	  "1,4;1,12;3,7;3,9;4,1;4,8;4,15;7,3;7,7;7,9;7,13;8,4;8,12;9,3;9,7;9,9;9,13;12,1;12,8;12,15;13,7;13,9;15,4;15,12;");
  strcpy(nov.PISMENO3POLE,
	 "2,6;2,10;6,2;6,6;6,10;6,14;10,2;10,6;10,10;10,14;14,6;14,10;"); 

  strcpy(nov.SADA_PISMEN,
	 "a,1,5;,2,2;b,3,2;c,2,3;,4,1;d,1,3;,8,1;e,1,5;,3,2;,3,2;f,5,1;g,5,1;h,2,3;i,1,4;,2,3;j,2,2;k,1,3;l,1,3;m,2,3;n,1,5;,6,1;o,1,6;,7,1;p,1,3;r,1,3;,4,2;s,1,4;,4,2;t,1,4;,7,1;u,2,3;,5,1;,4,1;v,1,4;x,10,1;y,2,2;,4,2;z,2,2;,4,1;?,0,2;");
  
  /* Prasrna, ale nutn */
  uprav_button_callback(NULL, NULL);

  if (nastaveni_nastaly_zmeny() == FALSE) 
    return;

  /* Vym nastaven z nov na akt (akt<->nov) */
  nastaveni_vymen_akt_nov();

  /* Na tohle jsem ekal 3 dny :-) Uff. */
  config_uloz_nastaveni(&nov);
  
}/* end of default_button_callback() */

/* -------------------------------------------------------------------------- */

/* Reaguje na checkbox v informanm okn */
LOCAL void nastaveni_checkbox_callback(void) {

    zobr_info = (zobr_info == TRUE) ? FALSE : TRUE;

}/* end of nastaveni_checkbox_callback() */

/* -------------------------------------------------------------------------- */

/* Zobraz okno s informac, e zmny se projev a po restartu aplikace.
 * Dle nabdne checkbox s monost dalho nezobrazovn tohoto dialogu.
*/ 
LOCAL void nastaveni_show_info_restart(void) {

    GtkWidget *dialog;
    GtkWidget *checkbox;
    int button;

    dialog = 
    gnome_message_box_new("Konfigurace uloena.\n"
	                   "Zmny se projev po restartu aplikace.",
             GNOME_MESSAGE_BOX_INFO, "OK", NULL);

    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(property_box));
    gnome_dialog_close_hides(GNOME_DIALOG (dialog), FALSE);

    checkbox = gtk_check_button_new_with_label("Pt toto okno nezobrazovat");
    gtk_signal_connect (GTK_OBJECT(checkbox), "toggled",
                        GTK_SIGNAL_FUNC(nastaveni_checkbox_callback), NULL);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), checkbox,
                        FALSE, FALSE, 0);

    gtk_widget_show_all(dialog);

    button = gnome_dialog_run_and_close(GNOME_DIALOG(dialog));

}/* end of nastaveni_show_info_restart() */

/* -------------------------------------------------------------------------- */

/* Napln pole nov.{SLOVO2POLE, SLOVO3POLE, PISMENO2POLE, PISMENO3POLE}
 * hodnotami z tlatek.
*/
LOCAL void nastaveni_napln_bonus_pole(void) {
 
    int h, i, j; 
    int sirka, vyska;

    char popis[10];
    char x[5];
    char y[5];
    char *polozka;

    sirka = atoi(gtk_entry_get_text(GTK_ENTRY(dentry1)));
    vyska = atoi(gtk_entry_get_text(GTK_ENTRY(dentry2)));
   
    /* Nastav aktuln hodnoty nsobk */ 
    nov.PISMX2 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry1))); 
    nov.PISMX3 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry2))); 
    nov.SLOVOX2 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry3))); 
    nov.SLOVOX3 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry4)));

    strcpy(nov.SLOVO2POLE, "");   strcpy(nov.SLOVO3POLE, "");
    strcpy(nov.PISMENO2POLE, ""); strcpy(nov.PISMENO3POLE, "");
    
    for(i=1;i<=sirka;i++) {

	for(j=1;j<=vyska;j++) {

	    /* Zskej label z tlatka [aP,bP,cS,dS], a<>b<>c<>d */
	    strcpy(popis, GTK_LABEL(GTK_BIN(tlacitka[i][j])->child)->label);
	    /* Budeme plnit etzce souadnicemi */	    
	    sprintf(x, "%d", i); sprintf(y, "%d", j); h = (int) popis[0] - '0';

#ifdef PREFERENCES_DEBUG
	    printf("[%d,%d] = %d ('%c')\n", i, j, h, popis[1]);
#endif
	    
		polozka = g_strconcat(x, ",", y, ";", NULL);

		/* Psmenn bonus? */
		if (popis[1] == 'P') {
		    
		    /* 2P nebo 3P? */
		    if (h == nov.PISMX2)   
			strcat(nov.PISMENO2POLE, polozka);	
		    else
			strcat(nov.PISMENO3POLE, polozka);
		    
		}/* end if */
		
		/* Slovn bonus */
		if (popis[1] == 'S') {

		    /* 2S nebo 3S? */
		    if (h == nov.SLOVOX2)
			strcat(nov.SLOVO2POLE, polozka);
		    else
			strcat(nov.SLOVO3POLE, polozka);
		    
		}/* end else */
		
		g_free((gpointer) polozka);

	}/* end for (j) */

    }/* end for (i) */

#ifdef PREFERENCES_DEBUG    
    printf("%d) '%s'\n", nov.PISMX2,  nov.PISMENO2POLE); 
    printf("%d) '%s'\n", nov.PISMX3,  nov.PISMENO3POLE); 
    printf("%d) '%s'\n", nov.SLOVOX2, nov.SLOVO2POLE); 
    printf("%d) '%s'\n", nov.SLOVOX3, nov.SLOVO3POLE); 
#endif

}/* end of nastaveni_napln_bonus_pole() */

/* -------------------------------------------------------------------------- */

/* Napln strukturu 'nov' s aktulnm stavem PropertyBoxu */
LOCAL void nastaveni_napln_nove_nastaveni(void) {

    int i;
    char *bunka1 = NULL;
    char *bunka2 = NULL;
    char *bunka3 = NULL;
    char *polozka = NULL;
    char *s = NULL;

    /* Fonty */
    strcpy(nov.KAMEN_FONT, gtk_entry_get_text(GTK_ENTRY(fentry1)));
    strcpy(nov.HODNOTA_FONT, gtk_entry_get_text(GTK_ENTRY(fentry2)));
    strcpy(nov.POPIS_FONT, gtk_entry_get_text(GTK_ENTRY(fentry3)));
    strcpy(nov.BONUS_FONT, gtk_entry_get_text(GTK_ENTRY(fentry4)));

    /* Deska */
    nov.POC_KAMENU_SIRKA = atoi(gtk_entry_get_text(GTK_ENTRY(dentry1)));
    nov.POC_KAMENU_VYSKA = atoi(gtk_entry_get_text(GTK_ENTRY(dentry2)));
    nov.VEL_KAMENE = atoi(gtk_entry_get_text(GTK_ENTRY(dentry3)));
    nov.MAX_PISMEN_PRIHRADKA = atoi(gtk_entry_get_text(GTK_ENTRY(dentry4)));

    /* Barvy jsou ji nastaveny */   

    /* Bonusov pole takt */
    nov.PISMX2 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry1)));
    nov.PISMX3 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry2)));
    nov.SLOVOX2 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry3)));
    nov.SLOVOX3 = atoi(gtk_entry_get_text(GTK_ENTRY(bentry4)));

    /* Vysosme sadu psmen ze sada_clist */

    strcpy(nov.SADA_PISMEN, "");

    for(i=0;i<sada_delka;i++) {
	gtk_clist_get_text(GTK_CLIST(sada_clist), i, 0, &bunka1); /* Psmeno */
	gtk_clist_get_text(GTK_CLIST(sada_clist), i, 1, &bunka2); /* Body */
	gtk_clist_get_text(GTK_CLIST(sada_clist), i, 2, &bunka3); /* Poet */
	
	/* Vytvo korektn zznam */
	polozka = g_strconcat(bunka1, ",", bunka2, ",", bunka3, ";", NULL);
	strcat(nov.SADA_PISMEN, polozka);

	g_free((gpointer) polozka);
	
    }/* end for */

#ifdef PREFERENCES_DEBUG
    printf("SADA_PISMEN = '%s'\n", nov.SADA_PISMEN);
#endif

    /* Extern slovnky */
    strcpy(nov.SLOVNIKY, "");
    for(i=0;i<slovniky_dej_pocet();i++) {
	s = slovniky_dej_slovnik(i);
	polozka = g_strconcat(s, ";", NULL);
	strcat(nov.SLOVNIKY, polozka);
	g_free((gpointer) polozka);
    }/* end for */
    
#ifdef PREFERENCES_DEBUG
    printf("SLOVNIKY = '%s'\n", nov.SLOVNIKY);
#endif

}/* end of nastaveni_napln_nove_nastaveni() */

/* -------------------------------------------------------------------------- */

/* Napln slov_clist slovnky naten (a platn) z konfiguranho souboru */
LOCAL void nastaveni_napln_slov_list(tpreference *p) {

    int i;
    char *s;
    char *popis = NULL;
    char *cesta = NULL;
    char *radek[1];
    char chyba[MAX_ROZMER] = "-- Chyba: Soubor neobsahuje popis slovnku! --";

    for(i=0;i<slovniky_dej_pocet();i++) {
    
	cesta = slovniky_dej_slovnik(i);
	s = g_strconcat(cesta, ".inf", NULL);
	popis = slovniky_ziskej_popis(s);
	
	if (popis) {
	    radek[0] = popis;
	    gtk_clist_append(GTK_CLIST(slov_clist), radek);
	}
	else {
	    radek[0] = chyba;
	    gtk_clist_append(GTK_CLIST(slov_clist), radek);
	}

	g_free((gpointer) popis);
	g_free((gpointer) s);
	
    }/* end for */

    
}/* end of nastaveni_napln_slov_list() */

/* -------------------------------------------------------------------------- */

/* Ovlada signlu "color-set" */
LOCAL void color_picked_callback(GtkWidget *w, 
			    guint r, guint g, guint b, guint a, gpointer data)
{

    guint32 barva = 0x00;
    boolean zmena = FALSE;

    r &= 0xFF; g &= 0xFF; b &= 0xFF; a &= 0xFF;

#ifdef PREFERENCES_DEBUG
    g_print("BARVA = %d ", (int) data);
    g_print("User selected color (rgba): %X %X %X %X\n", r, g, b, a);
#endif

    barva = (r*(1<<24)) + (g*(1<<16)) + (b*(1<<8)) + a;
    
#ifdef PREFERENCES_DEBUG
    printf("Barva = %X\n", barva);
#endif

    switch( (int) data) {

	case 1:	nov.BARVA1 = barva; break;
	case 2:	nov.BARVA2 = barva; break;
	case 3:	nov.BARVA3 = barva; break;
	case 4:	nov.BARVA4 = barva; break;
	case 5:	nov.BARVA5 = barva; break;
		
    }/* end switch */
   
    if (akt.BARVA1 != nov.BARVA1)
	zmena = TRUE;
    else if (akt.BARVA2 != nov.BARVA2)
	zmena = TRUE;
    else if (akt.BARVA3 != nov.BARVA3)
	zmena = TRUE;
    else if (akt.BARVA4 != nov.BARVA4)
	zmena = TRUE;
    else if (akt.BARVA5 != nov.BARVA5)
	zmena = TRUE;
    
    /* Vybrnm barvy vznikla zmna v konfiguraci */
    if (zmena == TRUE)
	gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));

}/* end of color_picked_callback() */

/* -------------------------------------------------------------------------- */

/* Ovlada signlu "font-set" */
LOCAL void font_set_callback(GnomeFontPicker *fontpicker,
                             gchar *selected,
                             gpointer user_data)
{
    switch( (int) user_data) {
	case 1:		strcpy(nov.KAMEN_FONT, selected);
			gtk_entry_set_text(GTK_ENTRY(fentry1), selected);
		     	break;
	case 2:		strcpy(nov.HODNOTA_FONT, selected);
			gtk_entry_set_text(GTK_ENTRY(fentry2), selected);
		       	break;
	case 3:		strcpy(nov.POPIS_FONT, selected);
			gtk_entry_set_text(GTK_ENTRY(fentry3), selected);
		     	break;
	case 4:		strcpy(nov.BONUS_FONT, selected); 
			gtk_entry_set_text(GTK_ENTRY(fentry4), selected);
			break;
    }/* end switch */

#ifdef PREFERENCES_DEBUG
    g_print("d = %d = User selected : %s\n", (int) user_data, selected);
#endif
    
    gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));

}/* end of font_set_callback() */

/* -------------------------------------------------------------------------- */

/* Umon/znemon  odebrn/pravu dku v clistu */
LOCAL void sada_clist_callback(GtkWidget *w, gint row, gint column,
                               GdkEventButton *event, gpointer data) {

    /* Unselect dku - znemoni odebrn/pravu */
    if ((int) data == 1)
	upr_odeber = FALSE;
    else {
	upr_odeber = TRUE;
	selected_row = row;
    }

}/* end of sada_clist_callback() */

/* -------------------------------------------------------------------------- */

/* Umon/znemon  odebrn/pravu dku v clistu pro slovnky */
LOCAL void slov_clist_callback(GtkWidget *w, gint row, gint column,
                               GdkEventButton *event, gpointer data) {

    /* Unselect dku - znemoni odebrn/pravu */
    if ((int) data == 1)
	slov_upr_odeber = FALSE;
    else {
	slov_upr_odeber = TRUE;
	slov_selected_row = row;
    }

}/* end of slov_clist_callback() */

/* -------------------------------------------------------------------------- */

/* Odebere dan dek v clistu, ale jen tehdy, je-li
 * nco vybrno.  */
LOCAL void odeber_button_callback(GtkWidget *w, gpointer data) {

    char *ptr;
    int i;

    if (upr_odeber == FALSE) {
	show_warning_window(GTK_WINDOW(data), "Nic nen vybrno!");
	return;
    }

    gtk_clist_get_text(GTK_CLIST(sada_clist), selected_row, 0, &ptr);
    
    /* Odebrn dku - musme opt 'povolit' definici odebranho psmene */
    i = znak2index(ptr[0]);
    sada[i] = ptr[0];

    /* Vlastn odebrn z 'clistu' */
    gtk_clist_remove(GTK_CLIST(sada_clist), selected_row);
    sada_delka--;

    /* Odebrnm vznikla 'zmna' */
    gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));

}/* end of odeber_button_callback() */

/* -------------------------------------------------------------------------- */

/* Odebere dan dek v clistu pro slovnky, ale jen tehdy, je-li
 * nco vybrno.  */
LOCAL void slov_odeber_button_callback(GtkWidget *w, gpointer data) {

    char *ptr;

    if (slov_upr_odeber == FALSE) {
	show_warning_window(GTK_WINDOW(data), "Nic nen vybrno!");
	return;
    }

    gtk_clist_get_text(GTK_CLIST(slov_clist), slov_selected_row, 0, &ptr);
    
    /* Vlastn odebrn z 'clistu' */
    gtk_clist_remove(GTK_CLIST(slov_clist), slov_selected_row);
    slovniky_odeber_slovnik(slov_selected_row);

    /* Odebrnm vznikla 'zmna' */
    gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));

}/* end of slov_odeber_button_callback() */

/* -------------------------------------------------------------------------- */

/* Nate aktuln sadu psmen do clistu */
LOCAL void uprav_button_callback(GtkWidget *w, gpointer data) {

    int i, j, k;
    char pos[10];

    char pis;
    char pismeno[2] = " \0";
    int poc;
    char pocet[5];
    int bod;
    char body[5];

    char *radek[3];

    strcpy(sada, ABECEDA);

    gtk_clist_clear(GTK_CLIST(sada_clist));
    sada_delka = 0;

    i = 0;
    while(i<strlen(akt.SADA_PISMEN)) {

	j = 0;

	/* v 'pos' je ve do znaku ';' */
        while(akt.SADA_PISMEN[i] != ';')
            pos[j++] = akt.SADA_PISMEN[i++];
        pos[j] = '\0';
        i++;

        sscanf(pos, "%c,%d,%d", &pis, &bod, &poc); /* Vysekej hodnoty */

	/* Naten nepovolme mnit */
	k = znak2index(pis);
	sada[k] = '-';	

	pismeno[0] = pis; pismeno[1] = '\0';
	radek[0] = pismeno;
	sprintf(pocet, "%d", poc);
	radek[2] = pocet;
	sprintf(body, "%d", bod);
	radek[1] = body;

	/* Nasypej do okna */
	gtk_clist_append(GTK_CLIST(sada_clist), radek);
	sada_delka++;

    }/* end while */

}/* end of uprav_button_callback() */

/* -------------------------------------------------------------------------- */

/* Vymae seznam definovanch psmen */
LOCAL void vymaz_button_callback(GtkWidget *w, gpointer data) {

    int i;
    
    gtk_clist_clear(GTK_CLIST(sada_clist));
    sada_delka = 0;

    /* Umoni definovat opt vechna psmena */
    for(i=0;i<MAX_VEL_ABECEDY-1;i++)
	sada[i] = ABECEDA[i];

    upr_odeber = FALSE;	/* Nelze odebrat */

    /* Vznikla 'zmna' v konfiguraci */
    gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));

}/* end of vymaz_button_callback() */
    
/* -------------------------------------------------------------------------- */

/* Zobraz okno s monost vbru psmene, potu a bod */
LOCAL void pridej_button_callback(GtkWidget *w, gpointer data) {
    
    GtkWidget *label;
    GtkWidget *dialog;
    GtkWidget *hbox;
    GtkWidget *hsep;
    GtkWidget *combo;
    GtkWidget *poc_entry;
    GtkWidget *bod_entry;
    GList *letters = NULL;
    char *str;
    char *pis;
    char *radek[3];

    int reply;
    int i, kolik;

    kolik = 0;
    /* Pidme do comba jen ta psmena, kter nejsou jet definovna */
    for(i=0;i<MAX_VEL_ABECEDY-1;i++)
	if (sada[i] != '-') {
	    kolik++;
	    str = (char *) malloc (2*sizeof(char));
	    str[0] = sada[i]; str[1] = '\0';
	    letters = g_list_append(letters, (gpointer) str);
    	}/* end if */


    /* Je co vybrat? Ne? Vysko */
    if (!kolik) {
	show_warning_window(GTK_WINDOW(data), "Vyerpna vechna psmena!");
	return;
    }
	
    dialog = gnome_dialog_new(N_("Pidn psmene do sady kamen"), 
                            GNOME_STOCK_BUTTON_OK,
                            GNOME_STOCK_BUTTON_CANCEL,
                            NULL);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(data));
    gtk_window_set_title(GTK_WINDOW(data), "Definice psmene");

    label = gtk_label_new("Definujte psmeno, poet a bodov ohodnocen");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	    label, FALSE, FALSE, 0);

    hsep = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
	    hsep, FALSE, FALSE, 0);
  
    /* Combo, poc_entry, bod_entry */ 
    
    hbox = gtk_hbox_new(FALSE, 0); 
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
	    hbox, FALSE, FALSE, 0);
    
    label = gtk_label_new("Vyberte psmeno: ");
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
    
    combo = gtk_combo_new();	    
    gtk_widget_set_usize(combo, 40, 20);
    gtk_entry_set_max_length(GTK_ENTRY(GTK_COMBO(combo)->entry), 1);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(combo)->entry), FALSE);
    gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 5);
    gtk_combo_set_popdown_strings(GTK_COMBO(combo), letters);
    
    label = gtk_label_new("Poet: ");
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
    
    poc_entry = gtk_entry_new_with_max_length(2);
    gtk_entry_set_text(GTK_ENTRY(poc_entry), "1");
    gtk_widget_set_usize(poc_entry, 25, 20);
    gtk_box_pack_start(GTK_BOX(hbox), poc_entry, FALSE, FALSE, 5);

    label = gtk_label_new("Body: ");
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
    
    bod_entry = gtk_entry_new_with_max_length(2);
    gtk_entry_set_text(GTK_ENTRY(bod_entry), "1");
    gtk_widget_set_usize(bod_entry, 25, 20);
    gtk_box_pack_start(GTK_BOX(hbox), bod_entry, FALSE, FALSE, 5);
    

    /* Zobraz dialog */
    gtk_widget_show_all(dialog);

    /* Stisknuto 'OK' nebo 'CANCEL' */
    reply = gnome_dialog_run(GNOME_DIALOG(dialog));

    if (reply == GNOME_OK) {

	pis = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo)->entry));
	i = znak2index(pis[0]);
	sada[i] = '-';		/* Pt u nen mon nastavit */
	
	radek[0] = pis;
	radek[1] = gtk_entry_get_text(GTK_ENTRY(bod_entry));
	radek[2] = gtk_entry_get_text(GTK_ENTRY(poc_entry));

	/* Je-li nkter pole neplatn */
	if ( (gui_util_validni_pole(GTK_ENTRY(bod_entry)) == FALSE) ||
	   (gui_util_validni_pole(GTK_ENTRY(poc_entry)) == FALSE) ) {

	    gui_util_invalid_okno(GTK_WINDOW(dialog), 
		    "Chybn vyplnn body nebo poet!");
	}
	else {
	    gtk_clist_append(GTK_CLIST(sada_clist), radek);
	    sada_delka++;

	    /* Vznikla 'zmna' v konfiguraci */
	    gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));
	}

    }/* end if GNOME_OK */

    /* Uklidme po sob */
    g_list_free(letters);
    gtk_widget_destroy(dialog);

}/* end of pridej_button_callback() */

/* -------------------------------------------------------------------------- */

/* Zobraz okno s monost vbru psmene, potu a bod */
LOCAL void slov_pridej_button_callback(GtkWidget *w, gpointer data) {

    GtkWidget *label;
    GtkWidget *dialog;
    GtkWidget *file_entry;
    GtkWidget *hsep;

    char *cesta = NULL;		/* Cesta k automatu */
    char *cesta_inf = NULL;	/* Cesta k jeho popisu */
    char *popis = NULL;
    char *radek[1];
    

    int reply;

    dialog = gnome_dialog_new(N_("Pidn externho slovnku"), 
                            GNOME_STOCK_BUTTON_OK,
                            GNOME_STOCK_BUTTON_CANCEL,
                            NULL);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(data));
    gtk_window_set_title(GTK_WINDOW(data), "Pidn slovnku");

    label = gtk_label_new("Vyberte soubor se slovnkem");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	    label, FALSE, FALSE, 0);

    hsep = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
	    hsep, FALSE, FALSE, 0);

    file_entry = gnome_file_entry_new(NULL, "Vyberte soubor se slovnkem");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
	    file_entry, FALSE, FALSE, 0);
  

    /* Zobraz dialog */
    gtk_widget_show_all(dialog);

    /* Stisknuto 'OK' nebo 'CANCEL' */
    reply = gnome_dialog_run(GNOME_DIALOG(dialog));

    if (reply == GNOME_OK) {
	cesta = gnome_file_entry_get_full_path(
			    GNOME_FILE_ENTRY(file_entry), TRUE);
	
	if ( cesta && (slovniky_cesta_je_platna(cesta) == TRUE) ) {

	    cesta_inf = g_strconcat(cesta, ".inf", NULL);

	    if (util_soubor_existuje(cesta_inf) == TRUE) {

		if ((popis = slovniky_ziskej_popis(cesta_inf)) != NULL) 
		    radek[0] = popis;
		else {
		    popis = (char *) malloc(DMAX * sizeof(char));
		    strcpy(popis, 
			"-- Chyba: Soubor neobsahuje popis slovnku! --");
		    radek[0] = popis;
		}

		/* Pidej do okna i seznamu */
		gtk_clist_append(GTK_CLIST(slov_clist), radek);
		slovniky_pridej_slovnik(cesta);
	
		/* Vznikla 'zmna' v konfiguraci */
		gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));
		
	    }/* .inf existuje */
	    else
		show_warning_window(GTK_WINDOW(dialog),
			"Chyb soubor s popisem! ('.mat.inf' soubor)");
	    
	}/*end if cesta_je_platna() */
	else 
	    show_warning_window(GTK_WINDOW(dialog), 
		    "Nen souborem se slovnkem! ('.mat' soubor)");
	    
    }/* end if GNOME_OK */

    /* Uklidme po sob */
    if (cesta)
	g_free((gpointer) cesta);
    
    if (cesta_inf)
	g_free((gpointer) cesta_inf);
	    
    if (popis)
	g_free((gpointer) popis);

    gtk_widget_destroy(dialog);

}/* end of slov_pridej_button_callback() */

/* -------------------------------------------------------------------------- */

/* Zobraz okno s cestou ke slovnku (data) */
LOCAL void slov_info_button_callback(GtkWidget *w, gpointer data) {

    char *cesta = NULL;

    GtkWidget *dialog;
    GtkWidget *label;
    GtkWidget *textentry;
    GtkWidget *hbox;

    int reply;

    if (slov_upr_odeber == FALSE) {
	show_warning_window(GTK_WINDOW(data), "Nic nen vybrno!");
	return;
    }

    cesta = slovniky_dej_slovnik(slov_selected_row);

#ifdef PREFERENCES_DEBUG
    printf("cesta %d = '%s'\n", slov_selected_row, cesta);
#endif

    dialog = gnome_dialog_new(_("Zobrazen cesty ke slovnku"), 
				GNOME_STOCK_BUTTON_OK, NULL);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_close_hides(GNOME_DIALOG (dialog), FALSE);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(data));
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);

    label = gtk_label_new("Informace o slovnku");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
                     label, TRUE, TRUE, GNOME_PAD);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
                     hbox, TRUE, TRUE, GNOME_PAD);
    
    label = gtk_label_new("Cesta:");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, GNOME_PAD);

    textentry = gtk_entry_new_with_max_length(DMAX);
    gtk_widget_set_usize(textentry, 400, 20);
    gtk_entry_set_text(GTK_ENTRY(textentry), cesta);
    gtk_entry_set_editable(GTK_ENTRY(textentry), FALSE);
    gtk_box_pack_start(GTK_BOX(hbox), textentry, TRUE, TRUE, GNOME_PAD);

    gtk_widget_show_all(dialog);

    reply = gnome_dialog_run_and_close(GNOME_DIALOG(dialog));


}/* end of slov_info_button_callback() */

/* -------------------------------------------------------------------------- */

/* Ovlada buttonku pro bonus pole, zobrazme okno s monost
 * vbru jeho jeho hodnoty (nsobku).
*/
LOCAL void set_bonus_button_callback(GtkWidget *w, gpointer data) {
    
    int reply;

    GSList *list;
    GtkWidget *label;
    GtkWidget *dialog;
    GtkWidget *hbox;
    GtkWidget *hsep;
    GtkWidget *rb1, *rb2, *rb3, *rb4, *rb5;
    char pom[10] = "";


    dialog = gnome_dialog_new(N_("Vyberte typ bonusovho pole"), 
                            GNOME_STOCK_BUTTON_OK,
                            GNOME_STOCK_BUTTON_CANCEL,
                            NULL);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(data));
    gtk_window_set_title(GTK_WINDOW(data), "Typ bonus pole");
    
    label = gtk_label_new("Vyberte typ bonusovho pole");
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	    label, FALSE, FALSE, 0);
    
    hsep = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
	    hsep, FALSE, FALSE, 0);

    hbox = gtk_hbox_new(FALSE, 0); 
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	    hbox, FALSE, FALSE, 0);

    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry1))); strcat(pom, "P");
    rb1 = gtk_radio_button_new_with_label(NULL, pom);
    list = gtk_radio_button_group(GTK_RADIO_BUTTON (rb1));
    gtk_box_pack_start(GTK_BOX(hbox), rb1, FALSE, FALSE, 0);
    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry2))); strcat(pom, "P");
    rb2 = gtk_radio_button_new_with_label(list, pom);
    list = gtk_radio_button_group(GTK_RADIO_BUTTON (rb2));
    gtk_box_pack_start(GTK_BOX(hbox), rb2, FALSE, FALSE, 0);
    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry3))); strcat(pom, "S");
    rb3 = gtk_radio_button_new_with_label(list, pom);
    list = gtk_radio_button_group(GTK_RADIO_BUTTON (rb3));
    gtk_box_pack_start(GTK_BOX(hbox), rb3, FALSE, FALSE, 0);
    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry4))); strcat(pom, "S");
    rb4 = gtk_radio_button_new_with_label(list, pom);
    list = gtk_radio_button_group(GTK_RADIO_BUTTON (rb4));
    gtk_box_pack_start(GTK_BOX(hbox), rb4, FALSE, FALSE, 0);
    rb5 = gtk_radio_button_new_with_label(list, "1X");
    list = gtk_radio_button_group(GTK_RADIO_BUTTON (rb5));
    gtk_box_pack_start(GTK_BOX(hbox), rb5, FALSE, FALSE, 0);
    
    /* Zobraz dialog */
    gtk_widget_show_all(dialog);

    /* Stisknuto 'OK' nebo 'CANCEL' */
    reply = gnome_dialog_run(GNOME_DIALOG(dialog));

    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb1)) == TRUE) {
	strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry1))); strcat(pom, "P");
    }
    else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb2)) == TRUE) {
        strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry2))); strcat(pom, "P");
    }
    else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb3)) == TRUE) {
        strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry3))); strcat(pom, "S");
    }
    else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb4)) == TRUE) {
	strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry4))); strcat(pom, "S");
    }
    else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb5)) == TRUE) {
	strcpy(pom, "  ");
    }
    

    if (reply == GNOME_OK) {
	
	 /* Me dojt k situaci, e budou mt 2 bonusy stejn nsobek.
	  * Tedy nelze nsobkem odliit typ bonusu.
	 */
	 gtk_widget_set(w, "label", (gchar *) pom, NULL);
    
	/* Vznikla 'zmna' v konfiguraci */
	gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));

        /* Uklidme po sob */
    }
    else
        printf("Bonus2 CANCEL\n");

    gtk_widget_destroy(dialog);

}/* end of set_bonus_button_callback() */

/* -------------------------------------------------------------------------- */

/* Ovlada tlatka 'reset_button'. Nastav vechna pole na '1x' */
LOCAL void reset_button_callback(GtkWidget *w, gpointer data) {

    int i, j; 
    int sirka, vyska;

    sirka = atoi(gtk_entry_get_text(GTK_ENTRY(dentry1)));
    vyska = atoi(gtk_entry_get_text(GTK_ENTRY(dentry2)));
	
    for(i=1;i<=sirka;i++)
	for(j=1;j<=vyska;j++) 
	    gtk_widget_set(tlacitka[i][j], "label", (gchar *) "    ", NULL);
   
    /* Vznikla 'zmna' v konfiguraci */
    gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));
    
}/* end of reset_button_callback() */

/* -------------------------------------------------------------------------- */

/* Ovlada signlu "clicked" buttonu pro nastaven bonusovch pol */
LOCAL void bonus_button_callback(GtkWidget *w, gpointer data) {

    int i, j;
    int sirka, vyska;
    int phod, shod;
    int reply;
    char pom[10];
   
    GtkWidget *frame;
    GtkWidget *dialog;
    GtkWidget *tabulka;
    GtkWidget *reset_button;

    /* Chybn vyplnn hodnoty bonusovch pol */
    if (!nastaveni_jsou_platna_pole_bonusu()) {
	gui_util_invalid_okno(GTK_WINDOW(property_box),
		"Nkter z hodnot bonusovch pol je neplatn!\n"
		"Prosm, opravte zadan hodnoty.");
	return;
    }

    /* Chybn hodnoty velikosti desky */
    if ( (!gui_util_validni_pole(GTK_ENTRY(dentry1))) ||
         (!gui_util_validni_pole(GTK_ENTRY(dentry1))) )  {
	
	gui_util_invalid_okno(GTK_WINDOW(property_box),
		"Hodnoty velikosti desky jsou neplatn!\n"
		"Prosm, opravte zadan hodnoty.");
	return;
    }
	   
    dialog = gnome_dialog_new(N_("Definice bonusovch pol"), 
                            GNOME_STOCK_BUTTON_OK,
                            GNOME_STOCK_BUTTON_CANCEL,
                            NULL);
    gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(data));
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gtk_window_set_title(GTK_WINDOW(data), "Definice bonusovch pol");

    frame = gtk_frame_new("Definice bonusovch pol");
    gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	    frame, FALSE, FALSE, 0);
    
    sirka = atoi(gtk_entry_get_text(GTK_ENTRY(dentry1)));
    vyska = atoi(gtk_entry_get_text(GTK_ENTRY(dentry2)));

    /* Tabulku prosm! */
    tabulka = gtk_table_new(sirka-1, vyska-1, TRUE);
    gtk_container_set_border_width(GTK_CONTAINER(tabulka), 5);
    gtk_container_add(GTK_CONTAINER(frame), tabulka);

    /* Nejdv psmenn bonusy */
    for(i=1;i<=sirka;i++)
	for(j=1;j<=vyska;j++) {

	    phod = pismmult[i][j]; 
	    shod = slovmult[i][j];

	    if (i>POC_KAMENU_SIRKA || j>POC_KAMENU_VYSKA) {
		phod = 1; shod = 1;
	    }

	    if (phod == 1 && shod == 1)
		tlacitka[i][j] = gtk_button_new_with_label("   ");
	    else if (phod == 1) {
		if (shod == akt.SLOVOX2) {	/* je to 2S */
		    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry3)));
		    strcat(pom, "S");   
		    tlacitka[i][j] = gtk_button_new_with_label(pom);
		}
		else {				/* je to 3S */
		    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry4)));
		    strcat(pom, "S");   
		    tlacitka[i][j] = gtk_button_new_with_label(pom);
		}
	    }/* end else if */
	    else {
		if (phod == akt.PISMX2) {
		    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry1)));
		    strcat(pom, "P");   
		    tlacitka[i][j] = gtk_button_new_with_label(pom);
		}
		else {
		    strcpy(pom, gtk_entry_get_text(GTK_ENTRY(bentry2)));
		    strcat(pom, "P");   
		    tlacitka[i][j] = gtk_button_new_with_label(pom);
		}
	    }/* end else */
    
		gtk_signal_connect(GTK_OBJECT(tlacitka[i][j]), "clicked",
			GTK_SIGNAL_FUNC(set_bonus_button_callback), 
				       GTK_WINDOW(dialog));
	
	    gtk_table_attach_defaults(GTK_TABLE(tabulka), 
		              tlacitka[i][j], i-1, i, j-1, j);	    
	}/* end for */
    

    reset_button = gtk_button_new_with_label("Nastav vechna pole na '1X'");
    gtk_signal_connect(GTK_OBJECT(reset_button), "clicked",
                GTK_SIGNAL_FUNC(reset_button_callback), NULL);

    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
	    reset_button, FALSE, FALSE, 0);



    /* Zobraz dialog */
    gtk_widget_show_all(dialog);

    /* Stisknuto 'OK' nebo 'CANCEL' */
    reply = gnome_dialog_run(GNOME_DIALOG(dialog));

    if (reply == GNOME_OK) {
	printf("Bonus OK\n");

	/* Vytvo etzce popisujc msta na desce, kde budou
	 * definovan bonusy. Poslou porovnn akt <-> nov nastaven.
	*/
	nastaveni_napln_bonus_pole();
					   
	/* Vznikla 'zmna' v konfiguraci */
	gnome_property_box_changed(GNOME_PROPERTY_BOX(property_box));

    }
    else
	printf("Bonus CANCEL\n");

    /* Uklidme po sob */
    gtk_widget_destroy(dialog);

}/* end of bonus_button_callback() */

/* -------------------------------------------------------------------------- */
/* ------------------------- OKNO S NASTAVENMI ----------------------------- */
/* -------------------------------------------------------------------------- */

/* Jsou vyplnn 4 pole v sekci Deska OK? */
LOCAL boolean nastaveni_jsou_platna_pole_desky(void) {

    /* Chybn vyplnn hodnoty u Desky */
    if ( (!gui_util_validni_pole(GTK_ENTRY(dentry1))) ||
       (!gui_util_validni_pole(GTK_ENTRY(dentry2))) ||
       (!gui_util_validni_pole(GTK_ENTRY(dentry3))) ||
       (!gui_util_validni_pole(GTK_ENTRY(dentry4))) )

	    return(FALSE);

    return(TRUE);

}/* end of nastaveni_jsou_platna_pole_desky() */

/* -------------------------------------------------------------------------- */
	
/* Jsou platn hodnoty v sekci bonusy? */
LOCAL boolean nastaveni_jsou_platna_pole_bonusu(void) {

    /* Chybn vyplnn hodnoty bonusovch pol */
    if ( (!gui_util_validni_pole(GTK_ENTRY(bentry1))) ||
       (!gui_util_validni_pole(GTK_ENTRY(bentry2))) ||
       (!gui_util_validni_pole(GTK_ENTRY(bentry3))) ||
       (!gui_util_validni_pole(GTK_ENTRY(bentry4))) )

	    return(FALSE);

    return(TRUE);

}/* end nastaveni_jsou_platna_pole_bonusu() */

/* -------------------------------------------------------------------------- */

/* Prove zmny po stisku 'Pout' / 'OK' */
void
property_box_apply_callback(GnomePropertyBox *b, gint stranka) {

    /* Test tu je kvli tomu, e pi stisku 'Pout' se
     * emituj 'apply' signly pro kadou strnku NoteBooku a
     * nakonec se emituje 'apply' s 'stranka'  == -1.
    */
    if (stranka != -1)
	return;


    /* Podvme se, nejsou-li chyby v textovch polch */
    if (nastaveni_jsou_platna_pole_desky() == FALSE) {

	gui_util_invalid_okno(GTK_WINDOW(property_box),
		"Nkter z hodnot v sekci 'Deska' v\n"
	        "zloce 'Prosted' jsou neplatn!");
	return;
		
    }
    
    /* Jsou platn hodnoty bonusovch pol? */
    if (nastaveni_jsou_platna_pole_bonusu() == FALSE) {

	gui_util_invalid_okno(GTK_WINDOW(property_box),
		"Nkter z hodnot v zloce 'Bonusov pole'\n"
	        "jsou neplatn! Prosm opravte hodnoty.");
	return;
		
    }

    /* Napl pole pro nastaven 'nov' z pol v PropertyBoxu */
    nastaveni_napln_nove_nastaveni();
   
    if (nastaveni_nastaly_zmeny() == FALSE) 
	return;

    /* Vym nastaven z old na akt (akt<->nov) */
    nastaveni_vymen_akt_nov();

    /* Na tohle jsem ekal 3 dny :-) Uff. */
    config_uloz_nastaveni(&nov);
    
    if (zobr_info)    
	nastaveni_show_info_restart();
    
}/* end of property_box_apply_callback() */

/* -------------------------------------------------------------------------- */

/* Zobraz okno s jednotlivmi nastavenmi */
GLOBAL void zobraz_nastaveni(void) {

    char str[DMAX];
  
    const int MAX_FW = 170; /* velikost textentry pro fontname */
    const int MAX_TW = 300; /* velikost labelu pro fonty */
    const int MAX_EW =  25; /* velikost textentry u voleb Desky */
    const int MAX_BW = 150; /* velikost labelu pro hodnoty bonus */

    const int MAX_BT_LEN = 2;

    const char HLASKA[DMAX] = "Poznmka: hodnoty obou psmennch (slovnch)\n"
			      "bonus mus bt od sebe rzn, aby jejich\n"
			      "vznam nesplynul.";

    GtkWidget *label, *label2;
    GtkWidget *frame, *frame2;
    GtkWidget *button;
    GtkWidget *def_button;
    GtkWidget *page_vbox, *page_vbox2;
    GtkWidget *page_hbox;
    GtkWidget *fp;		/* FontPicker */
    GtkWidget *hsep;		/* Horizontln oddlova */
    
    GtkWidget *uprav_b;	
    GtkWidget *odeber_b;
    GtkWidget *vymaz_b; 	/* Tlatka v zloce 'sada' */
    GtkWidget *pridej_b;
    GtkWidget *sada_okno;
    GtkWidget *sada_hbox;
    GtkWidget *slov_okno;
    GtkWidget *slov_hbox;
    GtkWidget *slov_info_b;
    gchar *sada_nadpisy[3] = { "Psmeno", "Body", "Poet" };
    gchar *slov_nadpisy[1] = { "Popis slovnku" };
    
    guint8 r, g, b, a;

    property_box = gnome_property_box_new();
    gnome_dialog_set_parent(GNOME_DIALOG(property_box), GTK_WINDOW(app));
    gnome_dialog_close_hides(GNOME_DIALOG(property_box), FALSE);

    gtk_window_set_modal(GTK_WINDOW(property_box), TRUE);
    gtk_window_set_title(GTK_WINDOW(property_box), "Konfigurace");

    def_button = gtk_button_new_with_label("Hodnoty pro klasick Scrabble");
    gtk_button_set_relief(GTK_BUTTON(def_button), GTK_RELIEF_NORMAL);
    gtk_signal_connect(GTK_OBJECT(def_button), "clicked",
			    GTK_SIGNAL_FUNC(default_button_callback), NULL);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(property_box)->vbox),
            def_button, FALSE, FALSE, 0);

    /* ZLOKA 'Prosted' */ 
    label = gtk_label_new("Prosted");
    
    frame = gtk_frame_new(NULL);
    gtk_container_set_border_width(GTK_CONTAINER (frame), 5);
    
    page_vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), page_vbox);


    /* --- Obsah zloky 'Prosted --- */
    
    /* Frame se 4 dky pro vbr font */
    frame2 = gtk_frame_new("Fonty");     
    gtk_container_set_border_width(GTK_CONTAINER(frame2), 5);
    gtk_box_pack_start(GTK_BOX(page_vbox), frame2, FALSE, FALSE, 0);

    page_vbox2 = gtk_vbox_new(FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER(page_vbox2), 5);
    gtk_container_add(GTK_CONTAINER(frame2), page_vbox2), 
   
    /* 1. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    /* Pro psmeno na kameni */	    
    label2 = gtk_label_new("Psmeno na kameni: ");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);

    fentry1 = gtk_entry_new();
    gtk_widget_set_usize(fentry1, MAX_TW, 20);
    gtk_entry_set_text(GTK_ENTRY(fentry1), akt.KAMEN_FONT);
    gtk_signal_connect_object(GTK_OBJECT(fentry1), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), fentry1, FALSE, FALSE, 0);

    label2 = gtk_label_new("Vyber font");
    fp = gnome_font_picker_new();
    gnome_font_picker_set_mode(GNOME_FONT_PICKER(fp), 
		       GNOME_FONT_PICKER_MODE_USER_WIDGET);
    gnome_font_picker_uw_set_widget(GNOME_FONT_PICKER(fp), label2);
    gnome_font_picker_set_font_name(GNOME_FONT_PICKER(fp), akt.KAMEN_FONT);
    gtk_signal_connect(GTK_OBJECT(fp), "font_set",
		       GTK_SIGNAL_FUNC(font_set_callback), (gpointer) 1);
    gtk_box_pack_start(GTK_BOX(page_hbox), fp, FALSE, FALSE, 0);

    /* 2. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    /* Pro hodnotu psmene na kameni */	    
    label2 = gtk_label_new("Hodnota psmene na kameni: ");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    fentry2 = gtk_entry_new();
    gtk_widget_set_usize(fentry2, MAX_TW, 20);
    gtk_entry_set_text(GTK_ENTRY(fentry2), akt.HODNOTA_FONT);
    gtk_signal_connect_object(GTK_OBJECT(fentry2), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), fentry2, FALSE, FALSE, 0);
    
    label2 = gtk_label_new("Vyber font");
    fp = gnome_font_picker_new();
    gnome_font_picker_set_mode(GNOME_FONT_PICKER(fp), 
		       GNOME_FONT_PICKER_MODE_USER_WIDGET);
    gnome_font_picker_uw_set_widget(GNOME_FONT_PICKER(fp), label2);
    gnome_font_picker_set_font_name(GNOME_FONT_PICKER(fp), akt.HODNOTA_FONT);
    gtk_signal_connect(GTK_OBJECT(fp), "font_set",
		       GTK_SIGNAL_FUNC(font_set_callback), (gpointer) 2);
    gtk_box_pack_start(GTK_BOX(page_hbox), fp, FALSE, FALSE, 0);

    /* 3. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    /* Pro popis souadnic na kameni */	    
    label2 = gtk_label_new("Souadnice: ");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    fentry3 = gtk_entry_new();
    gtk_widget_set_usize(fentry3, MAX_TW, 20);
    gtk_entry_set_text(GTK_ENTRY(fentry3), akt.POPIS_FONT);
    gtk_signal_connect_object(GTK_OBJECT(fentry3), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), fentry3, FALSE, FALSE, 0);
    
    label2 = gtk_label_new("Vyber font");
    fp = gnome_font_picker_new();
    gnome_font_picker_set_mode(GNOME_FONT_PICKER(fp), 
		       GNOME_FONT_PICKER_MODE_USER_WIDGET);
    gnome_font_picker_uw_set_widget(GNOME_FONT_PICKER(fp), label2);
    gnome_font_picker_set_font_name(GNOME_FONT_PICKER(fp), akt.POPIS_FONT);
    gtk_signal_connect(GTK_OBJECT(fp), "font_set",
		       GTK_SIGNAL_FUNC(font_set_callback), (gpointer) 3);
    gtk_box_pack_start(GTK_BOX(page_hbox), fp, FALSE, FALSE, 0);

    /* 4. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    /* Pro popis bonusovch kamen */	    
    label2 = gtk_label_new("Popis bonusovch pol: ");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    fentry4 = gtk_entry_new();
    gtk_widget_set_usize(fentry4, MAX_TW, 20);
    gtk_entry_set_text(GTK_ENTRY(fentry4), akt.BONUS_FONT);
    gtk_signal_connect_object(GTK_OBJECT(fentry4), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), fentry4, FALSE, FALSE, 0);
    
    label2 = gtk_label_new("Vyber font");
    fp = gnome_font_picker_new();
    gnome_font_picker_set_mode(GNOME_FONT_PICKER(fp), 
		       GNOME_FONT_PICKER_MODE_USER_WIDGET);
    gnome_font_picker_uw_set_widget(GNOME_FONT_PICKER(fp), label2);
    gnome_font_picker_set_font_name(GNOME_FONT_PICKER(fp), akt.BONUS_FONT);
    gtk_signal_connect(GTK_OBJECT(fp), "font_set",
		       GTK_SIGNAL_FUNC(font_set_callback), (gpointer) 4);
    gtk_box_pack_start(GTK_BOX(page_hbox), fp, FALSE, FALSE, 0);

    /* Frame s monost nastaven desky */
    frame2 = gtk_frame_new("Deska");     
    gtk_container_set_border_width(GTK_CONTAINER(frame2), 5);
    gtk_box_pack_start(GTK_BOX(page_vbox), frame2, FALSE, FALSE, 0);
    
    page_vbox2 = gtk_vbox_new(FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER(page_vbox2), 5);
    gtk_container_add(GTK_CONTAINER(frame2), page_vbox2), 
    
    /* 1. dek */
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);
    
    label2 = gtk_label_new("Poet pol (ka):");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);

    dentry1 = gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(dentry1, MAX_EW, 20);
    sprintf(str, "%d", akt.POC_KAMENU_SIRKA);
    gtk_entry_set_text(GTK_ENTRY(dentry1), str);
    gtk_signal_connect_object(GTK_OBJECT(dentry1), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), dentry1, FALSE, FALSE, 0);
    
    label2 = gtk_label_new("Poet pol (vka):");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);

    dentry2 = gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(dentry2, MAX_EW, 20);
    sprintf(str, "%d", akt.POC_KAMENU_VYSKA);
    gtk_entry_set_text(GTK_ENTRY(dentry2), str);
    gtk_signal_connect_object(GTK_OBJECT(dentry2), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), dentry2, FALSE, FALSE, 0);
    
    /* 2. dek */
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    label2 = gtk_label_new("Velikost kamene (v bodech):");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);

    dentry3 = gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(dentry3, MAX_EW, 20);
    sprintf(str, "%d", akt.VEL_KAMENE);
    gtk_entry_set_text(GTK_ENTRY(dentry3), str);
    gtk_signal_connect_object(GTK_OBJECT(dentry3), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), dentry3, FALSE, FALSE, 0);
    
    label2 = gtk_label_new("Poet kamen v pihrdce:");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);

    dentry4 = gtk_entry_new_with_max_length(2);
    gtk_widget_set_usize(dentry4, MAX_EW, 20);
    sprintf(str, "%d", akt.MAX_PISMEN_PRIHRADKA);
    gtk_entry_set_text(GTK_ENTRY(dentry4), str);
    gtk_signal_connect_object(GTK_OBJECT(dentry4), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), dentry4, FALSE, FALSE, 0);
    
    /* Frame s barvou zkladnho nebonusovho kamene */
    frame2 = gtk_frame_new("Barvy");     
    gtk_container_set_border_width(GTK_CONTAINER(frame2), 5);
    gtk_box_pack_start(GTK_BOX(page_vbox), frame2, FALSE, FALSE, 0);
    
    page_vbox2 = gtk_vbox_new(FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER(page_vbox2), 5);
    gtk_container_add(GTK_CONTAINER(frame2), page_vbox2), 

    /* dek s barvou zkladnho kamene */ 
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    label2 = gtk_label_new("Barva normlnho kamene:");
    gtk_widget_set_usize(label2, MAX_FW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    r = (akt.BARVA1 & 0xFF000000) % 0x00FFFFFF;
    g = (akt.BARVA1 & 0x00FF0000) % 0xFFFF;
    b = (akt.BARVA1 & 0x0000FF00) % 0xFF;
    a = 0xFF;

    cp1 = gnome_color_picker_new();
    set_tooltip(cp1, "Zvolte barvu");
    gnome_color_picker_set_title(GNOME_COLOR_PICKER(cp1), "Vyber barvu");
    gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp1), r, g, b, a);
    gtk_signal_connect(GTK_OBJECT(cp1), "color_set",
		       GTK_SIGNAL_FUNC(color_picked_callback), (gpointer) 1);
    gtk_box_pack_start(GTK_BOX(page_hbox), cp1, FALSE, FALSE, 0);
    
    /* Pidej prvn strnku do okna */ 
    gnome_property_box_append_page(
	    GNOME_PROPERTY_BOX(property_box), frame, label);

    /* ---------------------------------------------------- */
    
    /* ZLOKA 'Bonusov pole' */ 
    label = gtk_label_new("Bonusov pole");
    
    frame = gtk_frame_new(NULL);
    gtk_container_set_border_width(GTK_CONTAINER (frame), 5);
    
    page_vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), page_vbox);
  
    /* --- Obsah zloky 'Bonusov pole' --- */
    
    /* Frame se 4 dky pro hodnoty bonusovch pol */
    frame2 = gtk_frame_new("Hodnoty (krt X) a barvy");     
    gtk_container_set_border_width(GTK_CONTAINER(frame2), 5);
    gtk_box_pack_start(GTK_BOX(page_vbox), frame2, FALSE, FALSE, 0);

    page_vbox2 = gtk_vbox_new(FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER(page_vbox2), 5);
    gtk_container_add(GTK_CONTAINER(frame2), page_vbox2), 
   
    /* 1. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    label2 = gtk_label_new("1. psmenn bonus:");
    gtk_widget_set_usize(label2, MAX_BW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    bentry1 = gtk_entry_new_with_max_length(MAX_BT_LEN);
    gtk_widget_set_usize(bentry1, MAX_EW, 20);
    sprintf(str, "%d", akt.PISMX2);
    gtk_entry_set_text(GTK_ENTRY(bentry1), str);
    gtk_signal_connect_object(GTK_OBJECT(bentry1), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), bentry1, FALSE, FALSE, 0);
   
    r = (akt.BARVA2 & 0xFF000000) % 0x00FFFFFF;
    g = (akt.BARVA2 & 0x00FF0000) % 0xFFFF;
    b = (akt.BARVA2 & 0x0000FF00) % 0xFF;
    a = 0xFF;

    cp2 = gnome_color_picker_new();
    set_tooltip(cp2, "Zvolte barvu");
    gnome_color_picker_set_title(GNOME_COLOR_PICKER(cp2), "Vyber barvu");
    gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp2), r, g, b, a);
    gtk_signal_connect(GTK_OBJECT(cp2), "color_set",
		       GTK_SIGNAL_FUNC(color_picked_callback), (gpointer) 2);
    gtk_box_pack_start(GTK_BOX(page_hbox), cp2, FALSE, FALSE, 0);
    
    /* 2. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    label2 = gtk_label_new("2. psmenn bonus:");
    gtk_widget_set_usize(label2, MAX_BW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    bentry2 = gtk_entry_new_with_max_length(MAX_BT_LEN);
    gtk_widget_set_usize(bentry2, MAX_EW, 20);
    sprintf(str, "%d", akt.PISMX3);
    gtk_entry_set_text(GTK_ENTRY(bentry2), str);
    gtk_signal_connect_object(GTK_OBJECT(bentry2), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), bentry2, FALSE, FALSE, 0);
    
    r = (akt.BARVA3 & 0xFF000000) % 0x00FFFFFF;
    g = (akt.BARVA3 & 0x00FF0000) % 0xFFFF;
    b = (akt.BARVA3 & 0x0000FF00) % 0xFF;
    a = 0xFF;

    cp3 = gnome_color_picker_new();
    set_tooltip(cp3, "Zvolte barvu");
    gnome_color_picker_set_title(GNOME_COLOR_PICKER(cp3), "Vyber barvu");
    gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp3), r, g, b, a);
    gtk_signal_connect(GTK_OBJECT(cp3), "color_set",
		       GTK_SIGNAL_FUNC(color_picked_callback), (gpointer) 3);
    gtk_box_pack_start(GTK_BOX(page_hbox), cp3, FALSE, FALSE, 0);
    
    /* 3. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    label2 = gtk_label_new("1. slovn bonus:");
    gtk_widget_set_usize(label2, MAX_BW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    bentry3 = gtk_entry_new_with_max_length(MAX_BT_LEN);
    gtk_widget_set_usize(bentry3, MAX_EW, 20);
    sprintf(str, "%d", akt.SLOVOX2);
    gtk_entry_set_text(GTK_ENTRY(bentry3), str);
    gtk_signal_connect_object(GTK_OBJECT(bentry3), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), bentry3, FALSE, FALSE, 0);
    
    r = (akt.BARVA4 & 0xFF000000) % 0x00FFFFFF;
    g = (akt.BARVA4 & 0x00FF0000) % 0xFFFF;
    b = (akt.BARVA4 & 0x0000FF00) % 0xFF;
    a = 0xFF;

    cp4 = gnome_color_picker_new();
    set_tooltip(cp4, "Zvolte barvu");
    gnome_color_picker_set_title(GNOME_COLOR_PICKER(cp4), "Vyber barvu");
    gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp4), r, g, b, a);
    gtk_signal_connect(GTK_OBJECT(cp4), "color_set",
		       GTK_SIGNAL_FUNC(color_picked_callback), (gpointer) 4);
    gtk_box_pack_start(GTK_BOX(page_hbox), cp4, FALSE, FALSE, 0);
    
    /* 4. dek */ 
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    label2 = gtk_label_new("2. slovn bonus:");
    gtk_widget_set_usize(label2, MAX_BW, 10);
    gtk_box_pack_start(GTK_BOX(page_hbox), label2, FALSE, FALSE, 0);
    
    bentry4 = gtk_entry_new_with_max_length(MAX_BT_LEN);
    gtk_widget_set_usize(bentry4, MAX_EW, 20);
    sprintf(str, "%d", akt.SLOVOX3);
    gtk_entry_set_text(GTK_ENTRY(bentry4), str);
    gtk_signal_connect_object(GTK_OBJECT(bentry4), "changed",
			    GTK_SIGNAL_FUNC (gnome_property_box_changed),
			    GTK_OBJECT(property_box));
    gtk_box_pack_start(GTK_BOX(page_hbox), bentry4, FALSE, FALSE, 0);
    
    r = (akt.BARVA5 & 0xFF000000) % 0x00FFFFFF;
    g = (akt.BARVA5 & 0x00FF0000) % 0xFFFF;
    b = (akt.BARVA5 & 0x0000FF00) % 0xFF;
    a = 0xFF;

    cp5 = gnome_color_picker_new();
    set_tooltip(cp5, "Zvolte barvu");
    gnome_color_picker_set_title(GNOME_COLOR_PICKER(cp5), "Vyber barvu");
    gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cp5), r, g, b, a);
    gtk_signal_connect(GTK_OBJECT(cp5), "color_set",
		       GTK_SIGNAL_FUNC(color_picked_callback), (gpointer) 5);
    gtk_box_pack_start(GTK_BOX(page_hbox), cp5, FALSE, FALSE, 0);
    
    /* 5. dek = button pro definici */ 
    page_hbox = gtk_hbox_new(FALSE, 5);
    gtk_box_pack_start(GTK_BOX(page_vbox2), page_hbox, FALSE, FALSE, 0);

    hsep = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(page_vbox2), hsep, FALSE, FALSE, 5);
     
    button = gtk_button_new_with_label("Definice bonusovch pol na desce"); 
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
	    GTK_SIGNAL_FUNC(bonus_button_callback), (gpointer) property_box);
    gtk_box_pack_start(GTK_BOX(page_vbox2), button, FALSE, FALSE, 0);

    /* 76777777777777777 */
    label2 = gtk_label_new(HLASKA);
    /* gtk_label_set_justify(GTK_LABEL(label2), GTK_JUSTIFY_LEFT);  */
    gtk_box_pack_start(GTK_BOX(page_vbox), label2, FALSE, FALSE, 0);
    
    /* Pidej druhou strnku do okna */ 
    gnome_property_box_append_page(
	    GNOME_PROPERTY_BOX(property_box), frame, label);

    /* ---------------------------------------------------- */
    
    /* ZLOKA 'Sada psmen' */ 
    label = gtk_label_new("Sada psmen");

    frame = gtk_frame_new(NULL);
    gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
    
    page_vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), page_vbox);
  
    /* --- Obsah zloky 'Sada psmen' --- */
    
    frame2 = gtk_frame_new("Sada psmen");     
    gtk_container_set_border_width(GTK_CONTAINER(frame2), 5);
    gtk_box_pack_start(GTK_BOX(page_vbox), frame2, FALSE, FALSE, 0);

    /* bude obsahovat scrolled_window */
    sada_okno = gtk_scrolled_window_new(NULL, NULL);
    gtk_container_add(GTK_CONTAINER(frame2), sada_okno);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sada_okno),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
    sada_delka = 0; 
    sada_clist = gtk_clist_new_with_titles(3, sada_nadpisy); 
    gtk_container_add(GTK_CONTAINER(sada_okno), sada_clist);
    gtk_signal_connect(GTK_OBJECT(sada_clist), "select-row",
             GTK_SIGNAL_FUNC(sada_clist_callback), (gpointer) 0);
    gtk_signal_connect(GTK_OBJECT(sada_clist), "unselect-row",
             GTK_SIGNAL_FUNC(sada_clist_callback), (gpointer) 1);
    gtk_clist_set_shadow_type(GTK_CLIST(sada_clist), GTK_SHADOW_ETCHED_OUT);
    gtk_clist_set_column_width(GTK_CLIST(sada_clist), 0, 50);
    gtk_clist_set_column_width(GTK_CLIST(sada_clist), 1, 40);
    gtk_clist_set_column_width(GTK_CLIST(sada_clist), 2, 40);
    /* Bude se automaticky tdit */
    gtk_clist_set_sort_column(GTK_CLIST(sada_clist), 0);
    gtk_clist_set_compare_func(GTK_CLIST(sada_clist), 
	                      (GtkCListCompareFunc) f_clist_porovnej);
    gtk_clist_set_auto_sort(GTK_CLIST(sada_clist), TRUE);

    gtk_widget_set_usize(sada_clist, 190, 230);

    sada_hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(page_vbox), sada_hbox, FALSE, FALSE, 5);

    strcpy(sada, ABECEDA);

    /* Prasrna */
    uprav_button_callback(NULL, NULL);

    pridej_b = gtk_button_new_with_label("Pidej"); 
    gtk_box_pack_start(GTK_BOX(sada_hbox), pridej_b, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(pridej_b), "clicked",
             GTK_SIGNAL_FUNC(pridej_button_callback), (gpointer) property_box);
    odeber_b = gtk_button_new_with_label("Odeber"); 
    gtk_box_pack_start(GTK_BOX(sada_hbox), odeber_b, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(odeber_b), "clicked",
             GTK_SIGNAL_FUNC(odeber_button_callback), (gpointer) property_box);
    uprav_b = gtk_button_new_with_label("Nati aktuln pouvanou"); 
    gtk_box_pack_start(GTK_BOX(sada_hbox), uprav_b, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(uprav_b), "clicked",
             GTK_SIGNAL_FUNC(uprav_button_callback), (gpointer) property_box);
    vymaz_b = gtk_button_new_with_label("Nov sada"); 
    gtk_box_pack_start(GTK_BOX(sada_hbox), vymaz_b, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(vymaz_b), "clicked",
             GTK_SIGNAL_FUNC(vymaz_button_callback), (gpointer) property_box);
	
    /* Pidej tet strnku do okna */ 
    gnome_property_box_append_page(
	    GNOME_PROPERTY_BOX(property_box), frame, label);
    
    /* ---------------------------------------------------- */
    
    /* ZLOKA 'Slovnky' */ 
    label = gtk_label_new("Slovnky");
    
    frame = gtk_frame_new(NULL);
    gtk_container_set_border_width(GTK_CONTAINER (frame), 5);
    
    page_vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), page_vbox);
  
    /* --- Obsah zloky 'Slovnky' --- */
    
    frame2 = gtk_frame_new("Extern slovnky (*.mat)");     
    gtk_container_set_border_width(GTK_CONTAINER(frame2), 5);
    gtk_box_pack_start(GTK_BOX(page_vbox), frame2, FALSE, FALSE, 0);

    /* bude tak obsahovat scrolled_window s jednm */
    slov_okno = gtk_scrolled_window_new(NULL, NULL);
    gtk_container_add(GTK_CONTAINER(frame2), slov_okno);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(slov_okno),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  
    slov_clist = gtk_clist_new_with_titles(1, slov_nadpisy); 
    gtk_container_add(GTK_CONTAINER(slov_okno), slov_clist);
    gtk_signal_connect(GTK_OBJECT(slov_clist), "select-row",
             GTK_SIGNAL_FUNC(slov_clist_callback), (gpointer) 0);
    gtk_signal_connect(GTK_OBJECT(slov_clist), "unselect-row",
             GTK_SIGNAL_FUNC(slov_clist_callback), (gpointer) 1);
    gtk_clist_set_shadow_type(GTK_CLIST(slov_clist), GTK_SHADOW_ETCHED_OUT);
    gtk_clist_set_column_width(GTK_CLIST(slov_clist), 0, 50);
    gtk_clist_set_column_width(GTK_CLIST(slov_clist), 1, 40);
    gtk_clist_set_column_width(GTK_CLIST(slov_clist), 2, 40);
    gtk_widget_set_usize(slov_clist, 190, 100);

    nastaveni_napln_slov_list(&akt);	/* Napl natenmi slovnky */

    slov_hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(page_vbox), slov_hbox, FALSE, FALSE, 5);

    pridej_b = gtk_button_new_with_label("Pidej"); 
    gtk_box_pack_start(GTK_BOX(slov_hbox), pridej_b, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(pridej_b), "clicked",
		       GTK_SIGNAL_FUNC(slov_pridej_button_callback), 
	               (gpointer) property_box);
    odeber_b = gtk_button_new_with_label("Odeber"); 
    gtk_box_pack_start(GTK_BOX(slov_hbox), odeber_b, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(odeber_b), "clicked",
		       GTK_SIGNAL_FUNC(slov_odeber_button_callback), 
		       (gpointer) property_box);
    slov_info_b = gtk_button_new_with_label("Zobraz cestu ke slovnku"); 
    gtk_box_pack_start(GTK_BOX(slov_hbox), slov_info_b, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(slov_info_b), "clicked",
		       GTK_SIGNAL_FUNC(slov_info_button_callback), 
		       (gpointer) property_box);
    
    /* Pidej ptou strnku do okna */ 
    gnome_property_box_append_page(
	    GNOME_PROPERTY_BOX(property_box), frame, label);
    
    /* ---------------------------------------------------- */
    
    /* Ovlada 'apply-signlu' */ 
    gtk_signal_connect (GTK_OBJECT(property_box), "apply",
	                GTK_SIGNAL_FUNC(property_box_apply_callback), NULL);
     
    gtk_widget_show_all(GTK_WIDGET(property_box)); 
    
}/* end of zobraz_nastaveni() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE nastaveni.c */
