#include <ctype.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "vacek.h"
#include "prihradka.h"
#include "gui_menu.h"
#include "gui_deska.h"
#include "gui_nastaveni.h"
#include "gui_ovladace.h"
#include "hra.h"

LOCAL GnomeCanvas *board_canvas;
LOCAL GnomeCanvas *rack_canvas;
LOCAL GnomeCanvas *bonus_canvas;
LOCAL GnomeCanvasGroup *boardgroup = NULL;
LOCAL GnomeCanvasGroup *rack_group = NULL;

/* Definice promnnch pro GnomeCanvas */
GLOBAL GnomeApp* app;

GLOBAL GtkWidget *done_button;
GLOBAL GtkWidget *pass_button;
GLOBAL GtkWidget *change_button;
GLOBAL GtkWidget *evaluate_button;
GLOBAL GtkWidget *help_button;
GLOBAL GtkWidget *poloz_button;
GLOBAL GtkWidget *prubeh_clist;
GLOBAL GtkWidget *pomoc_clist;

GLOBAL GtkWidget *cbox1;
GLOBAL GtkWidget *cbox2;

GLOBAL GtkWidget *pomoc_frame;

GLOBAL GtkWidget *player1_name;
GLOBAL GtkWidget *player2_name;
GLOBAL GtkWidget *player1_score;
GLOBAL GtkWidget *player2_score;

GLOBAL GtkWidget *tah_status;
GLOBAL GtkWidget *hrac_status;
GLOBAL GtkWidget *zbyva_status;
GLOBAL GtkWidget *slovnik_status;

/* -------------------------------------------------------------------------- */
/* 	  	          DEKLARACE GLOBLNCH FUNKC                         */
/* -------------------------------------------------------------------------- */

GLOBAL GnomeApp* create_window(void);
GLOBAL void draw_rack(void);
GLOBAL void draw_background(void);
GLOBAL void gui_okno_znehybni_widgety(void);

/* -------------------------------------------------------------------------- */
/* 	  	           DEKLARACE LOCLNCH FUNKC                         */
/* -------------------------------------------------------------------------- */

LOCAL void draw_borders(void);
LOCAL void draw_bonus_canvas(void);

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* -------------------------------------------------------------------------- */
	       /* VYTVO CEL OKNO APLIKACE SE VEMI WIDGETY */
/* -------------------------------------------------------------------------- */

GLOBAL GnomeApp* create_window(void)
{
  GtkWidget *app; /* cel Gnome aplikace */
  GtkWidget *w;	  /* status bar */
  GtkWidget *bc;  /* board canvas */
  GtkWidget *rc;  /* rack canvas */
  GtkWidget *ic;  /* info s hodnotami bonusovch polek */
  GtkWidget *hbox, *hboxr, *hboxfill;
  GtkWidget *vbox, *vboxr, *vboxr2, *vbox2, *vpomocbox;
  GtkWidget *pbox, *pbox2, *pboxb;
  GtkWidget *frame, *frame2, *frame3, *frame4;
  GtkWidget *scrolled_window;
  GtkWidget *scrolled_helpwindow;
  GtkWidget *status_hbox;
  GtkWidget *status_frame;

  gchar *nadpisy[5] = { "Tah", "Hr", "Body", "Sou.", "Slovo" };
  gchar *helpsloupce[3] = { "Body", "Sou.", "Slovo" };
  guint con_id1, con_id2;

  gint x, y;

  /* Rozthneme se na cel okno */
  x = gdk_screen_width() - 5; 
  y = gdk_screen_height() - 20;
  
  app = gnome_app_new("scarabeus", "Scarabeus");
  gtk_window_set_default_size(GTK_WINDOW(app), x, y); 
  gtk_window_set_position(GTK_WINDOW(app), GTK_WIN_POS_CENTER);
  gtk_signal_connect(GTK_OBJECT(app), "delete_event", 
		     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
      
  /* Pidej jednotliv menu k hlavnmu oknu */
  menu_pripoj_menu(app);

  /* Vytvme status bar */
  status_hbox = gtk_hbox_new(FALSE, 0); 
  gtk_container_border_width(GTK_CONTAINER(status_hbox), 0);

  /* Status bar pro hinty k menu */ 
  w = gnome_appbar_new(FALSE, TRUE, GNOME_PREFERENCES_USER);
  gtk_box_pack_start(GTK_BOX(status_hbox), w, TRUE, TRUE, 0);
  
  /* Zobrazme slo tahu */
  status_frame = gtk_frame_new(NULL);
  gtk_box_pack_start(GTK_BOX(status_hbox), status_frame, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type(GTK_FRAME(status_frame), GTK_SHADOW_IN);

  tah_status = gtk_label_new(" Tah .: ");
  gtk_container_add(GTK_CONTAINER(status_frame), tah_status);
  
  /* Zobrazme aktulnho hre */
  status_frame = gtk_frame_new(NULL);
  gtk_box_pack_start(GTK_BOX(status_hbox), status_frame, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type(GTK_FRAME(status_frame), GTK_SHADOW_IN);

  hrac_status = gtk_label_new(" Hraje: ");
  gtk_container_add(GTK_CONTAINER(status_frame), hrac_status);
  
  /* Zobrazme poet zbylch kamen ve vku */
  status_frame = gtk_frame_new(NULL);
  gtk_box_pack_start(GTK_BOX(status_hbox), status_frame, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type(GTK_FRAME(status_frame), GTK_SHADOW_IN);

  zbyva_status = gtk_label_new(" Zbv kamen: ");
  gtk_container_add(GTK_CONTAINER(status_frame), zbyva_status);
 
  status_frame = gtk_frame_new(NULL); 
  gtk_frame_set_shadow_type(GTK_FRAME(status_frame), GTK_SHADOW_IN);
  gtk_widget_set_usize(status_frame, 200, 20);
  gtk_box_pack_start(GTK_BOX(status_hbox), status_frame, FALSE, FALSE, 0);
  
  /* Zobrazme aktuln slovnk */
  status_frame = gtk_frame_new(NULL);
  gtk_box_pack_start(GTK_BOX(status_hbox), status_frame, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type(GTK_FRAME(status_frame), GTK_SHADOW_IN);

  slovnik_status = gtk_label_new(" Slovnk: ");
  gtk_container_add(GTK_CONTAINER(status_frame), slovnik_status);

  /* Pidej widget (hbox) jako status box dan aplikaci */
  gnome_app_set_statusbar(GNOME_APP(app), status_hbox);

  /* A zobrazuj menu hinty do lev sti status baru */
  menu_pripoj_hinty(w);
  
  /* Zavolej pslun funkce pro vytvoen canvasu */
  bc = gnome_canvas_new();
  rc = gnome_canvas_new();
  ic = gnome_canvas_new();
  set_tooltip(ic, "Bonusov pole jsou msta na desce, kde je hodnota "
	          "psmene/slova bodov zvhodnna.");
  
  board_canvas = GNOME_CANVAS(bc);
  rack_canvas  = GNOME_CANVAS(rc);
  bonus_canvas = GNOME_CANVAS(ic);


  /* PRO BOARD CANVAS */ 

  /* Nainstaluj handler udlost pro BOARD */
  gtk_signal_connect(GTK_OBJECT(bc),"event",
		     GTK_SIGNAL_FUNC(board_event_handler),
		     NULL);
 
  /* Velikost uiteln sti BOARDu v bodech */ 
  gnome_canvas_set_scroll_region(board_canvas, 0.0, 0.0,
	       VEL_CANVAS_SIRKA, VEL_CANVAS_VYSKA);
  /* Nastav velikost BOARDu v bodech */
  gtk_widget_set_usize(bc, VEL_CANVAS_SIRKA, VEL_CANVAS_VYSKA);

  draw_borders(); /* Zobraz okraje desky */
  
  /* PRO RACK CANVAS */
  
  /* Ovlada signlu zachycujc udlosti v RACKu */
  gtk_signal_connect(GTK_OBJECT(rc),"event",
		     GTK_SIGNAL_FUNC(rack_event_handler),
		     NULL);
  
  /* Jak velkou st z RACK CANVASu v bodech bude pouiteln (cel) */
  gnome_canvas_set_scroll_region(rack_canvas, 0.0, 0.0,
	                VEL_RACK_SIRKA, VEL_RACK_VYSKA);

  /* Nastav velikost RACK CANVASu v bodech */
  gtk_widget_set_usize(rc, VEL_RACK_SIRKA, VEL_RACK_VYSKA);


  /* PRO BONUS CANVAS */
  
  /* Jak velkou st z BONUS CANVASu v bodech bude pouiteln (cel) */
  gnome_canvas_set_scroll_region(bonus_canvas, 0.0, 0.0,
	                9*VEL_BONUS_POLE, 5*VEL_BONUS_POLE+(VEL_BONUS_POLE/3));

  /* Nastav velikost RACK CANVASu v bodech */
  gtk_widget_set_usize(ic,9*VEL_BONUS_POLE,5*VEL_BONUS_POLE+(VEL_BONUS_POLE/3));

  /* 4 oknka pro popis bonusovch pol */
  draw_bonus_canvas();

  /* Naplnme vechny VBOXY, HBOXY a vytvome hlavn panel */
 
  /* hbox = 2 sloupce - v levm je board, v pravm jsou infos */   
  hbox =  gtk_hbox_new (FALSE, 0); 
  /* a do kadho sloupce pipojujeme objekty */
  vbox =  gtk_vbox_new (FALSE, 0); 
 
/* -------------------------------------------------------------------------- */
/* --------------------------- LEVA PULKA OKNA ------------------------------ */
/* -------------------------------------------------------------------------- */

  /* Frame s deskou */
  hboxr = gtk_hbox_new(FALSE, 0);
  vboxr = gtk_hbox_new(FALSE, 0);
  frame2 = gtk_frame_new(NULL);
  gtk_widget_set_usize(frame2, 
	               VEL_CANVAS_SIRKA+5, VEL_CANVAS_VYSKA+2);
  gtk_frame_set_shadow_type(GTK_FRAME(frame2), GTK_SHADOW_NONE);
  gtk_box_pack_start(GTK_BOX(vboxr), bc, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame2), vboxr);
  gtk_container_border_width(GTK_CONTAINER(vboxr), 0);
  gtk_box_pack_start(GTK_BOX(hboxr), frame2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hboxr, FALSE, FALSE, 2);

  /* Done-RACK-Pass hbox */
  pbox = gtk_hbox_new(FALSE, 0);
  done_button = gtk_button_new_with_label("Hotovo");
  set_tooltip(done_button, "Potvrzuje tah nebo vmnu kamen");

  /* Pipoj handler na toto tlatko */
  gtk_signal_connect (GTK_OBJECT(done_button), "clicked",
                      GTK_SIGNAL_FUNC(done_button_handler), NULL);
      
  gtk_widget_set_usize(done_button, 3*VEL_KAMENE+1, VEL_KAMENE+1);
  gtk_box_pack_start(GTK_BOX(pbox), done_button, FALSE, FALSE, VEL_KAMENE);
  
  gtk_box_pack_start(GTK_BOX (pbox), rc, FALSE, FALSE, 0);
  
  pass_button = gtk_button_new_with_label("Pass");
  set_tooltip(pass_button, "Provd PASS (vzdn se tahu)");
  gtk_signal_connect (GTK_OBJECT(pass_button), "clicked",
                      GTK_SIGNAL_FUNC(pass_button_handler), NULL);

  gtk_widget_set_usize(pass_button, 3*VEL_KAMENE+1, VEL_KAMENE+1);
  gtk_box_pack_start(GTK_BOX(pbox), pass_button, FALSE, FALSE, VEL_KAMENE);
  
  /* pridej Done-RACK-Pass hbox do vboxu */
  gtk_box_pack_start(GTK_BOX(vbox), pbox, FALSE, FALSE, 0);

  pbox2 = gtk_hbox_new(FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(pbox2), VEL_KAMENE/2); 

  /* Vytvo jen vpl */
  hboxfill = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(pbox2), hboxfill, FALSE, FALSE, 
	    (int) ((4+MAX_PISMEN_PRIHRADKA-7)/2)*VEL_KAMENE + VEL_KAMENE/4);

  change_button = gtk_button_new_with_label("Vym kameny");
  set_tooltip(change_button, "Umon vmnu kamen");

  /* Pipoj handler na toto tlatko */
  gtk_signal_connect(GTK_OBJECT(change_button), "clicked",
                      GTK_SIGNAL_FUNC(change_button_handler), NULL);

  gtk_widget_set_usize(change_button, 4*VEL_KAMENE+1, VEL_KAMENE+1);
  gtk_box_pack_start(GTK_BOX(pbox2), change_button, FALSE, FALSE,  0);

  evaluate_button = gtk_button_new_with_label("Spoti body");
  set_tooltip(evaluate_button, "Spote body za dan rozmstn kamen.");

  /* Pipoj handler na toto tlatko */
  gtk_signal_connect(GTK_OBJECT(evaluate_button), "clicked",
                      GTK_SIGNAL_FUNC(evaluate_button_handler), NULL);

  gtk_widget_set_usize(evaluate_button, 3*VEL_KAMENE+1, VEL_KAMENE+1);
  gtk_box_pack_start(GTK_BOX(pbox2), evaluate_button, FALSE, FALSE, 0);

  gtk_box_pack_start(GTK_BOX(vbox), pbox2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 0);

/* -------------------------------------------------------------------------- */
/* -------------------------- PRAVA PULKA OKNA ------------------------------ */
/* -------------------------------------------------------------------------- */
  
  vbox2 = gtk_vbox_new(FALSE, 10); 
  
  /* Frame s popisem bonusovch pol */
  hboxr = gtk_hbox_new(FALSE, 0);
  vboxr = gtk_hbox_new(FALSE, 0);
  frame2 = gtk_frame_new("Bonusov pole");
  gtk_widget_set_usize(frame2, 
	               12*VEL_BONUS_POLE,
		       7*VEL_BONUS_POLE+(VEL_BONUS_POLE/3));
  gtk_box_pack_start(GTK_BOX(vboxr), ic, FALSE, FALSE, 10);
  gtk_container_add(GTK_CONTAINER(frame2), vboxr);
  gtk_container_border_width(GTK_CONTAINER(vboxr), 5);
  gtk_box_pack_start(GTK_BOX(hboxr), frame2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox2), hboxr, FALSE, FALSE, 10);

  /* Jmno, skre a volba potae */
  hboxr = gtk_hbox_new(FALSE, 5);

  /* FRAME se JMENY hr */
  frame3 = gtk_frame_new("Jmno"); /* Do nj 1. vboxr */
  vboxr = gtk_vbox_new(FALSE, 0); /* Do nj pjdou 2 textentry pro jmno */
  
  player1_name = gtk_entry_new();
  gtk_widget_set_usize(player1_name, 4*VEL_KAMENE, 20);
  gtk_entry_set_text(GTK_ENTRY(player1_name), PLAYER1_TEXT);
  gtk_entry_set_max_length(GTK_ENTRY(player1_name), 15);
  gtk_box_pack_start(GTK_BOX(vboxr), player1_name, FALSE, FALSE, 0);
  
  player2_name = gtk_entry_new();
  gtk_widget_set_usize(player2_name, 4*VEL_KAMENE, 20);
  gtk_entry_set_text(GTK_ENTRY(player2_name), PLAYER2_TEXT);
  gtk_entry_set_max_length(GTK_ENTRY(player2_name), 15);
  gtk_box_pack_start(GTK_BOX(vboxr), player2_name, FALSE, FALSE, 0);

  gtk_container_add(GTK_CONTAINER(frame3), vboxr);/* Zatm 2 dky se jmny */
  gtk_box_pack_start(GTK_BOX(hboxr), frame3, FALSE, FALSE, 0);
  
  /* FRAME s Body */
  frame4 = gtk_frame_new("Skre"); /* Do nj 2. vboxr */
  vboxr2 = gtk_vbox_new(FALSE, 0); /* Do nj pjdou 2 textentry */
  
  player1_score = gtk_entry_new();
  gtk_widget_set_usize(player1_score, 40, 20);
  gtk_entry_set_editable(GTK_ENTRY(player1_score), FALSE);
  gtk_entry_set_max_length(GTK_ENTRY(player1_score), 5);
  gtk_entry_set_text(GTK_ENTRY(player1_score), "0");
  gtk_box_pack_start(GTK_BOX(vboxr2), player1_score, FALSE, FALSE, 0);
  
  player2_score = gtk_entry_new();
  gtk_widget_set_usize(player2_score, 40, 20);
  gtk_entry_set_editable(GTK_ENTRY(player2_score), FALSE);
  gtk_entry_set_max_length(GTK_ENTRY(player2_score), 5);
  gtk_entry_set_text(GTK_ENTRY(player2_score), "0");
  gtk_box_pack_start(GTK_BOX(vboxr2), player2_score, FALSE, FALSE, 0);
  
  gtk_container_add(GTK_CONTAINER(frame4), vboxr2);/* Dal 2 se skore */
  gtk_box_pack_start(GTK_BOX(hboxr), frame4, FALSE, FALSE, 0);
  
  /* FRAME se 2 checboxy (PC) */
  frame4 = gtk_frame_new("PC"); /* Do nj 2. vboxr */
  vboxr2 = gtk_vbox_new(FALSE, 0); /* Do nj pjdou 2 checkboxy */
  
  cbox1 = gtk_check_button_new();
  set_tooltip(cbox1, "Nastav hre .1 jako pota.");
  con_id1 = gtk_signal_connect(GTK_OBJECT(cbox1), "toggled",
		            GTK_SIGNAL_FUNC(checkbox_button1_handler), NULL);
  gtk_box_pack_start(GTK_BOX(vboxr2), cbox1, FALSE, FALSE, 0);
  cbox2 = gtk_check_button_new();
  set_tooltip(cbox2, "Nastav hre .2 jako pota.");
  con_id2 = gtk_signal_connect(GTK_OBJECT(cbox2), "toggled",
			    GTK_SIGNAL_FUNC(checkbox_button2_handler), NULL);
  
  gui_ovladace_ziskej_konexe(con_id1, con_id2);
  
  gtk_box_pack_start(GTK_BOX(vboxr2), cbox2, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame4), vboxr2);
  gtk_box_pack_start(GTK_BOX(hboxr), frame4, FALSE, FALSE, 0);

  /* pipoj hboxr k vboxu prav strany */
  gtk_box_pack_start(GTK_BOX(vbox2), hboxr, FALSE, FALSE, 0);
  
  /* Pidej okno s prbhem hry */  
  hboxr = gtk_hbox_new(FALSE, 5);
  gtk_box_pack_start(GTK_BOX(vbox2), hboxr, FALSE, FALSE, 0);

  frame = gtk_frame_new("Prbh hry");
  gtk_widget_set_usize(frame, 260, 235);
 
  /* bude ve scrolled_window */
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
                                  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_container_add(GTK_CONTAINER(frame), scrolled_window);

  /* a bude to column seznam */ 
  prubeh_clist = gtk_clist_new_with_titles( 5, nadpisy); 
  gtk_clist_set_shadow_type (GTK_CLIST(prubeh_clist), GTK_SHADOW_ETCHED_OUT);
  gtk_clist_set_column_width (GTK_CLIST(prubeh_clist), 0, 20);
  gtk_clist_set_column_width (GTK_CLIST(prubeh_clist), 1, 50);
  gtk_clist_set_column_width (GTK_CLIST(prubeh_clist), 2, 27);
  gtk_clist_set_column_width (GTK_CLIST(prubeh_clist), 3, 28);
  gtk_clist_set_column_width (GTK_CLIST(prubeh_clist), 4, 55);
  gtk_container_add(GTK_CONTAINER(scrolled_window), prubeh_clist);
	  
  gtk_box_pack_start(GTK_BOX(hboxr), frame, FALSE, FALSE, 0);


  vpomocbox = gtk_vbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hboxr), vpomocbox, FALSE, FALSE, 0);
  
  pomoc_frame = gtk_frame_new("Pomoc");
  gtk_box_pack_start(GTK_BOX(vpomocbox), pomoc_frame, FALSE, FALSE, 0);
 
  
  /* Bude ve frame a bude obsahovat button a okno */
  pboxb = gtk_vbox_new(FALSE, 0); 
  gtk_container_add(GTK_CONTAINER(pomoc_frame), pboxb);
  
  help_button = gtk_button_new_with_label("Najdi slova");
  set_tooltip(help_button, "Nalezne vechny tahy."
	                   " Umon tm 'podvdt' ve he "
			   "proti potai." );
  /* Pipoj handler na tlatko 'NAJDI SLOVA'*/
  gtk_signal_connect (GTK_OBJECT(help_button), "clicked",
                      GTK_SIGNAL_FUNC(help_button_handler), NULL);
  gtk_box_pack_start(GTK_BOX(pboxb), help_button, FALSE, FALSE, 0);

  /* bude ve scrolled_window */
  scrolled_helpwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_set_usize(scrolled_helpwindow, 190, 235);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scrolled_helpwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_box_pack_start(GTK_BOX(pboxb), scrolled_helpwindow, FALSE, FALSE, 0);
  
  pomoc_clist = gtk_clist_new_with_titles(3, helpsloupce);
  gtk_signal_connect(GTK_OBJECT(pomoc_clist), "select-row",
             GTK_SIGNAL_FUNC(pomoc_clist_callback), (gpointer) 0);
  gtk_signal_connect(GTK_OBJECT(pomoc_clist), "unselect-row",
             GTK_SIGNAL_FUNC(pomoc_clist_callback), (gpointer) 1);

  gtk_clist_set_shadow_type (GTK_CLIST(pomoc_clist), GTK_SHADOW_ETCHED_OUT);
  gtk_clist_set_column_width (GTK_CLIST(pomoc_clist), 0, 30);
  gtk_clist_set_column_width (GTK_CLIST(pomoc_clist), 1, 30);
  gtk_clist_set_column_width (GTK_CLIST(pomoc_clist), 2, 65);
  gtk_container_add(GTK_CONTAINER(scrolled_helpwindow), pomoc_clist);


  poloz_button = gtk_button_new_with_label("Polo na desku");
  gtk_signal_connect (GTK_OBJECT(poloz_button), "clicked",
                      GTK_SIGNAL_FUNC(poloz_button_handler), NULL);
  set_tooltip(poloz_button, "Polo kameny nalezenho tahu na desku.");
  
  gtk_box_pack_start(GTK_BOX(vpomocbox), poloz_button, TRUE, FALSE, 0);
  
  
  /* pripoj pravou stranu k hboxu */
  gtk_box_pack_start(GTK_BOX (hbox), vbox2, FALSE, FALSE, 0);

  /* cel to zobraz */
  gtk_widget_show_all(hbox);

  /* a cel to pipoj k oknu aplikace */
  gnome_app_set_contents(GNOME_APP(app), hbox);
 
  /* Tlatka mono pout a pi startu hry */ 
  gtk_widget_set_sensitive(GTK_WIDGET(done_button), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(pass_button), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(change_button), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(evaluate_button), FALSE);
  
  return GNOME_APP(app);
}

/* -------------------------------------------------------------------------- */

/* Zobraz linie okolo hrac plochy */
LOCAL void draw_borders(void) {

  int i;
  char cislo[5];
  char pism[2] = "0\0";

  /* white background for rack*/
  gnome_canvas_item_new(gnome_canvas_root(rack_canvas),
            gnome_canvas_rect_get_type(),
            "x1",(double) 0,
            "y1",(double) 0,
            "x2",(double) MAX_PISMEN_PRIHRADKA*VEL_KAMENE,
            "y2",(double) VEL_KAMENE,
            "fill_color_rgba", white_clr,
            NULL);
 
  /* PRO BOARD */ 
  /* vodorovn ern ry jako okraje kamen */
  for(i=0;i<=POC_KAMENU_VYSKA;i++) {
    draw_a_line(gnome_canvas_root(board_canvas),
          VEL_OKRAJ_DESKY,
          VEL_OKRAJ_DESKY + i*VEL_KAMENE,
          VEL_OKRAJ_DESKY + POC_KAMENU_SIRKA*VEL_KAMENE,
          VEL_OKRAJ_DESKY + i*VEL_KAMENE,
          "black");
  } 

  /* vertikln oznaen dk (1-15) */  
  for(i=1;i<=POC_KAMENU_VYSKA;i++) {
      sprintf(cislo, "%d", i);
      gnome_canvas_item_new(gnome_canvas_root(board_canvas),
   			    gnome_canvas_text_get_type(),
			  "x", (double) VEL_OKRAJ_DESKY - VEL_KAMENE/2 + TVYPLN,
			  "y", (double) VEL_OKRAJ_DESKY +
			                (i-1)*VEL_KAMENE + VEL_KAMENE/2,
			  "anchor", GTK_ANCHOR_CENTER,
			  "font", POPIS_FONT,
			  "fill_color_rgba", black_clr,
			  "text", cislo,
			  NULL);
      gnome_canvas_item_new(gnome_canvas_root(board_canvas),
   			    gnome_canvas_text_get_type(),
			  "x", (double) VEL_OKRAJ_DESKY + 
			                VEL_DESKA_SIRKA +
					VEL_KAMENE/2,
			  "y", (double) VEL_OKRAJ_DESKY +
			                (i-1)*VEL_KAMENE + VEL_KAMENE/2,
			  "anchor", GTK_ANCHOR_EAST,
			  "font", POPIS_FONT,
			  "fill_color_rgba", black_clr,
			  "text", cislo,
			  NULL);
   }/* end for */
  
  
  /* vertikln ern ary jako okraje kamen */
  for(i=0;i<=POC_KAMENU_SIRKA;i++) {
    draw_a_line(gnome_canvas_root(board_canvas),
          VEL_OKRAJ_DESKY + i*VEL_KAMENE,
          VEL_OKRAJ_DESKY,
          VEL_OKRAJ_DESKY + i*VEL_KAMENE,
          VEL_OKRAJ_DESKY + POC_KAMENU_VYSKA*VEL_KAMENE,
          "black");
  }
 
  /* psmenn oznaen jednotlivch sloupc (A-N) */
  for(i=1;i<=POC_KAMENU_SIRKA;i++) {
    pism[0] = (char) i+64;
    gnome_canvas_item_new(gnome_canvas_root(board_canvas),
			  gnome_canvas_text_get_type(),
			  "x", (double) VEL_OKRAJ_DESKY + 
			                (i-1)*VEL_KAMENE + VEL_KAMENE/2,
			  "y", (double) VEL_OKRAJ_DESKY - VEL_KAMENE/2 + TVYPLN,
			  "anchor", GTK_ANCHOR_CENTER,
			  "font", POPIS_FONT,
			  "fill_color_rgba", black_clr,
			  "text", pism,
			  /* "text", cislo, */
			  NULL);
    gnome_canvas_item_new(gnome_canvas_root(board_canvas),
			  gnome_canvas_text_get_type(),
			  "x", (double) VEL_OKRAJ_DESKY + 
			                (i-1)*VEL_KAMENE + VEL_KAMENE/2,
			  "y", (double) VEL_OKRAJ_DESKY + VEL_DESKA_VYSKA + VEL_KAMENE/2,
			  "anchor", GTK_ANCHOR_CENTER,
			  "font", POPIS_FONT,
			  "fill_color_rgba", black_clr,
			  "text", pism,
			  /* "text", cislo, */
			  NULL);
  }/* end for */
  
  /* PRO RACK */ 
  /* draw vertical lines */
  for(i=0;i<=MAX_PISMEN_PRIHRADKA;i++) {
    draw_a_line(gnome_canvas_root(rack_canvas),
          i*VEL_KAMENE,
	  0,
          i*VEL_KAMENE,
          VEL_KAMENE,
          "black");
  }
  /* draw horizontal lines */
    draw_a_line(gnome_canvas_root(rack_canvas),
          0,
          0,
          MAX_PISMEN_PRIHRADKA*VEL_KAMENE,
          0,
          "black");
    draw_a_line(gnome_canvas_root(rack_canvas),
          0,
          VEL_KAMENE,
          MAX_PISMEN_PRIHRADKA*VEL_KAMENE,
	  VEL_KAMENE,
          "black");

}
/* -------------------------------------------------------------------------- */

/* Vykresli poten desku bez kamen */
GLOBAL void draw_background(void)
{
  int x, y;
  guint32 barva;
  char text[10];
  GnomeCanvasItem *item;

  /* Zru board, bude reinicializovn */
  if(boardgroup)
    gtk_object_destroy(GTK_OBJECT(boardgroup));
  /* Tot pro rack */
  if (rack_group)
    gtk_object_destroy(GTK_OBJECT(rack_group));
 
  /* make a new group for the items on the board */
  item = gnome_canvas_item_new(gnome_canvas_root(board_canvas),
             gnome_canvas_group_get_type(),
             "x",(double) VEL_OKRAJ_DESKY,
             "y",(double) VEL_OKRAJ_DESKY,
             NULL);
  
  boardgroup = GNOME_CANVAS_GROUP(item);
  
  /* make a new group for the items on the board */
  item = gnome_canvas_item_new(gnome_canvas_root(rack_canvas),
             gnome_canvas_group_get_type(),
             "x",(double) 0,
             "y",(double) 0,
             NULL);
  
  rack_group = GNOME_CANVAS_GROUP(item);
  
    for (x=0; x<POC_KAMENU_SIRKA;x++)
        for (y=0; y<POC_KAMENU_VYSKA;y++)
	{
	    set_empty_tile_properties(x, y, text, &barva);
	    
	    vytvor_policko(boardgroup, &board_grid[x][y], 
	             	   x, y, barva, EMPTY_WORD, EMPTY_TILE);
	}	    		                                    	      

    for (x=0; x<MAX_PISMEN_PRIHRADKA;x++) { /* rack je przdn => lut */
        vytvor_policko(rack_group, &rack_grid[x][0], 
		       x, 0, yellow_clr, EMPTY_WORD, EMPTY_TILE);
    }

    /* V pihrdkch je pusto */
    for (x=0; x<MAX_PISMEN_PRIHRADKA; x++) {
        rack1[x].znak = rack2[x].znak = EMPTY_TILE;
        rack1[x].hodnota = rack2[x].hodnota = EMPTY_TILE;
    }


}/* end draw_background() */


/* -------------------------------------------------------------------------- */
/* Zobraz popisek na prave stran k jednotlivm bonusovm
 * polkm.
*/
LOCAL void draw_bonus_canvas(void) {
   
    
   char str[50] = ""; 

  /* 1. pole */ 
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
            gnome_canvas_rect_get_type(),
            "x1",(double) 0,
            "y1",(double) 0,
            "x2",(double) VEL_BONUS_POLE,
            "y2",(double) VEL_BONUS_POLE,
            "fill_color_rgba", cyan_clr, 
	    "outline_color_rgba", black_clr,
            NULL);
  /* 2. pole */ 
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
            gnome_canvas_rect_get_type(),
            "x1",(double) 0,
            "y1",(double) VEL_BONUS_POLE+(VEL_BONUS_POLE/3),
            "x2",(double) VEL_BONUS_POLE,
            "y2",(double) 2*VEL_BONUS_POLE+(VEL_BONUS_POLE/3),
            "fill_color_rgba", blue_clr, 
	    "outline_color_rgba", black_clr,
            NULL);

  /* 3. pole */ 
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
            gnome_canvas_rect_get_type(),
            "x1",(double) 0,
            "y1",(double) 2*VEL_BONUS_POLE+(2*VEL_BONUS_POLE/3),
            "x2",(double) VEL_BONUS_POLE,
            "y2",(double) 3*VEL_BONUS_POLE+(2*VEL_BONUS_POLE/3),
            "fill_color_rgba", pink_clr, 
	    "outline_color_rgba", black_clr,
            NULL);
  /* 4. pole */ 
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
            gnome_canvas_rect_get_type(),
            "x1",(double) 0,
            "y1",(double) 3*VEL_BONUS_POLE+(3*VEL_BONUS_POLE/3),
            "x2",(double) VEL_BONUS_POLE,
            "y2",(double) 4*VEL_BONUS_POLE+(3*VEL_BONUS_POLE/3),
            "fill_color_rgba", red_clr, 
	    "outline_color_rgba", black_clr,
            NULL);
 
  /* 1. popis */ 
  sprintf(str, "%d", PISMX2);
  strcat(str, "X ");
  strcat(str, TPISMENO);
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
	  gnome_canvas_text_get_type(),
	  "x", (double) 2*VEL_BONUS_POLE,
	  "y", (double) VEL_BONUS_POLE/2,
	  "anchor", GTK_ANCHOR_WEST,
	  "fill_color_rgba", black_clr,
          "font", BONUS_FONT,
	  "text", str,
	  NULL);
  
  /* 2. popis */ 
  sprintf(str, "%d", PISMX3);
  strcat(str, "X ");
  strcat(str, TPISMENO);
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
	  gnome_canvas_text_get_type(),
	  "x", (double) 2*VEL_BONUS_POLE,
          "y",(double) VEL_BONUS_POLE+(VEL_BONUS_POLE/3)+VEL_BONUS_POLE/2,
	  "anchor", GTK_ANCHOR_WEST,
	  "fill_color_rgba", black_clr,
          "font", BONUS_FONT,
	  "text", str,
	  NULL);
  
  /* 3. popis */ 
  sprintf(str, "%d", SLOVOX2);
  strcat(str, "X ");
  strcat(str, TSLOVO);
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
	  gnome_canvas_text_get_type(),
	  "x", (double) 2*VEL_BONUS_POLE,
          "y",(double) 2*VEL_BONUS_POLE+(2*VEL_BONUS_POLE/3)+VEL_BONUS_POLE/2,
	  "anchor", GTK_ANCHOR_WEST,
	  "fill_color_rgba", black_clr,
          "font", BONUS_FONT,
	  "text", str,
	  NULL);
  
  /* 4. popis */ 
  sprintf(str, "%d", SLOVOX3);
  strcat(str, "X ");
  strcat(str, TSLOVO);
  gnome_canvas_item_new(gnome_canvas_root(bonus_canvas),
	  gnome_canvas_text_get_type(),
	  "x", (double) 2*VEL_BONUS_POLE,
          "y",(double) 3*VEL_BONUS_POLE+(3*VEL_BONUS_POLE/3)+VEL_BONUS_POLE/2,
	  "anchor", GTK_ANCHOR_WEST,
	  "fill_color_rgba", black_clr,
          "font", BONUS_FONT,
	  "text", str,
	  NULL);
  
}/* end of draw_bonus_canvas() */

/* -------------------------------------------------------------------------- */

/* Vykresli pihrdku */
GLOBAL void draw_rack(void)
{
    int i;
    guint32 obarva;
    guint32 tbarva;
    char hodn[5] = "";
    char pism[2] = " \0";
    skamen *rack;

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
    {
        rack = (player == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */

        if ( (rack[i].znak == EMPTY_TILE) ||
             (rack_is_placed_on_board(i) == TRUE) ) {
            /* Je pole v racku przdn nebo u na desce? */
            strcpy(pism, "");        /* Pak neobsahuje znak ani nic */
            strcpy(hodn, "");
        }
        else {                                    /* Neprzdn pole */
            pism[0] = toupper(rack[i].znak); /* Vytvome 'etzec' */
            sprintf(hodn, "%d", rack[i].hodnota); /* Mme i hodnotu */
        }

        obarva = (rack_click[i] == TRUE) ? black_clr : yellow_clr;
        tbarva = (rack_click[i] == TRUE) ? yellow_clr : black_clr;

        gnome_canvas_item_set(rack_grid[i][0].obdelnik,
                              "fill_color_rgba", obarva,
                               NULL);
        gnome_canvas_item_set(rack_grid[i][0].pismeno,
                              "x", (double) VEL_KAMENE-POFFX,
                              "y", (double) VEL_KAMENE-POFFY,
                              "font", KAMEN_FONT,
                              "fill_color_rgba", tbarva,
                              "text", pism,
                               NULL);
        gnome_canvas_item_set(rack_grid[i][0].hodnota,
                              "x", (double) VEL_KAMENE-HOFFX,
                              "y", (double) VEL_KAMENE-HOFFY,
                              "font", HODNOTA_FONT,
                              "text", hodn,
                              "fill_color_rgba", tbarva,
                               NULL);
    }/* end for */

}/* end of draw_rack() */

/* -------------------------------------------------------------------------- */

/* "Znecitliv" dleit widgety */
GLOBAL void gui_okno_znehybni_widgety(void) {

    /* Nzvy jmen je nyn mono mnit */
    gtk_entry_set_editable(GTK_ENTRY(player1_name), TRUE);
    gtk_entry_set_editable(GTK_ENTRY(player2_name), TRUE);

    /* Tlatka mohou pijmat udlosti, hra zan */
    gtk_widget_set_sensitive(GTK_WIDGET(done_button), FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(pass_button), FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(change_button), FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(evaluate_button), FALSE);
    
    /* Checkboxy pro vbr potae funguj */
    gtk_widget_set_sensitive(GTK_WIDGET(cbox1), TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(cbox2), TRUE);

}/* end of gui_okno_znehybni_widgety() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE hlavni_okno.c */
