#include<stdio.h>
#include<ctype.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "cross.h"
#include "vacek.h"
#include "tahy_gui.h"
#include "tahy_gen.h"
#include "tahy_seznam.h"
#include "prihradka.h"
#include "deska.h"
#include "skore.h"
#include "gui_okno.h"
#include "gui_deska.h"
#include "konverze.h"
#include "hra.h"

/* ------------------ DEKLARACE LOCALNCH PROMNNCH ------------------------ */

LOCAL guint con_id1, con_id2;	/* Budeme blokovat signly */
LOCAL int lastx, lasty, lwhat;  /* Pozice vybranho kamene z racku na desce */
LOCAL boolean vyber_on_off;	/* Monost poloen tahu */
LOCAL int pomoc_row;            /* Tah z pomoc_clistu */
LOCAL int poloz_tah = 1;	/* Pro aktualizaci seznamu tah */
LOCAL int ptah = -1;		/* Pro potn voln help_button_callbacku */
LOCAL unsigned char cbox_prep = 0; /* Pepna pro checkbox handlery */

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */
GLOBAL int done_button_handler(GtkWidget *widget, gpointer data);
GLOBAL int change_button_handler(GtkWidget *widget, gpointer data);
GLOBAL int evaluate_button_handler(GtkWidget *widget, gpointer data);
GLOBAL int pass_button_handler(GtkWidget *widget, gpointer data);
GLOBAL int help_button_handler(GtkWidget *widget, gpointer data);
GLOBAL int checkbox_button_handler(GtkWidget *widget, gpointer data);
GLOBAL int poloz_button_handler( GtkWidget *widget, gpointer data);
GLOBAL int board_event_handler( GnomeCanvas *c, GdkEvent *event, gpointer data);
GLOBAL int rack_event_handler( GnomeCanvas *c, GdkEvent *event, gpointer data);
GLOBAL void pomoc_clist_callback(GtkWidget *w, gint row, gint column,
                                 GdkEventButton *event, gpointer data);
GLOBAL void set_help_handler_counter(int pocet);
GLOBAL void gui_ovladace_poloz_tah(int tah); 
GLOBAL void gui_ovladace_poloz_tah_pocitace(int tah); 
GLOBAL void gui_ovladace_ziskej_konexe(guint id1, guint id2);
GLOBAL gint gui_ovladace_cheat_callback(void);
GLOBAL void gui_ovladace_obtiznost_callback(GtkToggleButton *b, gpointer data);
GLOBAL void gui_ovladace_todo_okno(void);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

LOCAL void gui_ovladace_set_checkbox_status(void);
LOCAL char gui_ovladace_vyber_pismeno(int which);
LOCAL void gui_ovladace_zpracuj_zoliky(void);

/* -------------------------------------------------------------------------- */
/* --------------- HANDLER PRO TLATKO 'VYM KAMENY' ---------------------- */
/* -------------------------------------------------------------------------- */

GLOBAL int change_button_handler( GtkWidget *widget, gpointer data) {

    if (game_mode == STOP_MODE || game_mode == CHANGE_MODE)
	return(TRUE);

    /* M jen, je-li co */
    if (vacek_pocet_zbylych_kamenu() == 0) {
	show_warning_window(GTK_WINDOW(app), 
		"Ve vku ji nejsou kameny pro vmnu!");
	return(TRUE);
    }
    
    /* Indikuj, e budeme mnit */
    show_info_window(GTK_WINDOW(app), INFO_SELECT_TILES);
    
    /* Jsou-li kameny z racku na desce, vra je do racku */
    rack_return_played_tiles_home();
  
    game_mode = CHANGE_MODE;

    return(TRUE);

}/* end of change_button_handler() */

/* -------------------------------------------------------------------------- */
/* ----------------- HANDLER PRO tlatko 'polo na desku' ------------------ */
/* -------------------------------------------------------------------------- */

/* Umon/znemon  odebrn/pravu dku v clistu */
GLOBAL void pomoc_clist_callback(GtkWidget *w, gint row, gint column,
                                GdkEventButton *event, gpointer data) {

    /* Unselect dku - znemoni odebrn/pravu */
    if ((int) data == 1)
        vyber_on_off = FALSE;
    else {
        vyber_on_off = TRUE;
        pomoc_row = row;
    }

}/* end of pomoc_clist_callback() */

/* -------------------------------------------------------------------------- */

GLOBAL int poloz_button_handler( GtkWidget *widget, gpointer data) {


    /* Volej, jen kdy je to vhodn */
    if (game_mode != PLAY_MODE)
        return(TRUE);

    /* Nen-li vybrno slovo k poloen */
    if (vyber_on_off == FALSE) {
        show_warning_window(GTK_WINDOW(app), "Nic nen vybrno!");
        return(TRUE);
    }

    /* Me se stt, e v dalm tahu kliknu na 'Polo na desku' a 
     * v seznamu budou tahy pro minul kolo.
    */

    /* Neprovdj nic, pokud stisknuto v tomt tahu vckrt  */
    if (turn > poloz_tah) {
	show_warning_window(GTK_WINDOW(app), 
	"Seznam nen aktuln!\nKliknte na 'Najdi slova' pro aktualizaci.");
	return(TRUE);
    }
  
    /* Vra vechny nov poloen kameny do pihrdky */
    rack_return_played_tiles_home();

    /* Budeme volat i pro tah potae */ 

    gui_ovladace_poloz_tah(pomoc_row); 

    return(TRUE);

}/* end of poloz_button_handler() */

/* -------------------------------------------------------------------------- */

/* Polo na desku tah ze seznamu tah (verze hr = lovk) */
GLOBAL void gui_ovladace_poloz_tah(int tah) {

    skamen *rack;
    Tah *t;
    int j, what;
    int x, y;
    unsigned char z;
    char znak;
    char hodnota[10] = "";
    char pismeno[2] = "";
	    
    /* Vyber ten sprvn rack */
    rack = (player == HRAC1) ? rack1 : rack2;

    t = (Tah *) malloc (sizeof(Tah));

    *t = tahy_seznam_dej_polozku(pomoc_row);
    
    /* Umstme vechny kameny z tahu na desku */
    for(j=0;j<t->klen;j++) {
	
	x = (t->k[j].x) - 1; y = (t->k[j].y) - 1;

	z = t->k[j].z;	

	/* U olka chceme jeho zstupn znak */
	znak = index2znak(z & ~JOKERBIT);

	/* Najdi pozici znaku v pihrdce */
	what = rack_najdi_vyskyt(z);

        if (z & JOKERBIT) {
            pismeno[0] = toupper(znak); pismeno[1] = '\0';
            sprintf(hodnota, "%d", rack[what].hodnota);
        }
	
	/* U neolka jen zam pole */
        exchange_properties(&board_grid[y][x], &rack_grid[what][0]);

	/* Barevn odlime psmeno zastupujc olka */
	if (z & JOKERBIT)
	    board_draw_field(y, x, yellow_clr, red_clr, pismeno, hodnota);
	
        rack_empty_tile(what);    /* Vyprzdn pslun pole v racku */
        rack_set_placed_on_board(what, TRUE);    /* Kmen je na desce */
        rack_set_placed_tiles_coords(what, y, x, what);     /* Kde? */
        board_set_field_vacant(x, y, FALSE); /* Polko obsazeno */
        rack_unclick(what);         /* Zru oznaen vybranho kamenu */
	
	/* Viz ne */
	if (z & JOKERBIT)
	    board_set_letter_at_coords(x, y, znak);

    }/* end for (j) */

    /* istota - pl zdrav :) */
    g_free((gpointer) t);
    
}/* end gui_ovladace_poloz_tah() */

/* -------------------------------------------------------------------------- */

/* Polo na desku tah ze seznamu tah (verze hr = pota) */
/* U verze pota nesm bt vidt jeho pihrdka */
GLOBAL void gui_ovladace_poloz_tah_pocitace(int tah) {

    skamen *rack;
    Tah *t;
    int j, what;
    int x, y;
    unsigned char z;
    char znak;
    char hodnota[10] = "";
    char pismeno[2] = "";

    /* Vyber ten sprvn rack */
    rack = (player == HRAC1) ? rack1 : rack2;

    t = (Tah *) malloc (sizeof(Tah));

    /* Zatm bereme ten nejlep mon (0t pozice v seznamu) */
    *t = tahy_seznam_dej_polozku(tah);

    /* Umstme vechny kameny z tahu na desku */
    for(j=0;j<t->klen;j++) {
	
	x = (t->k[j].x) - 1; y = (t->k[j].y) - 1;

	z = t->k[j].z;

       	/* U olka chceme jeho zstupn znak */
	znak = index2znak(z & ~JOKERBIT);

	/* Najdi pozici znaku v pihrdce */
	what = rack_najdi_vyskyt(z);

	if (z & JOKERBIT) {
	    pismeno[0] = toupper(znak); pismeno[1] = '\0';
	    sprintf(hodnota, "%d", rack[what].hodnota);
	}
	else {
	    
	    /* Vysosme sprvn psmeno a hodnotu */
	    pismeno[0] = toupper(rack[what].znak); pismeno[1] = '\0';
	    sprintf(hodnota, "%d", rack[what].hodnota);
	}/* end else */

	/* Plcni ho na desku */	
	if (z & JOKERBIT)	
	    board_draw_field(y, x, yellow_clr, black_clr, pismeno, hodnota); 
	else
	    board_draw_field(y, x, yellow_clr, red_clr, pismeno, hodnota); 
		
        rack_set_placed_on_board(what, TRUE);    /* Kmen je na desce */
        rack_set_placed_tiles_coords(what, y, x, what);     /* Kde? */
        board_set_field_vacant(x, y, FALSE); /* Polko obsazeno */
        rack_unclick(what);         /* Zru oznaen vybranho kamenu */

	/* Toto nm pome odliit ppad, kdy olkov kmen umsovn
	 * run z pihrdky a kdy je vybrn tah ze seznamu. V ppad
	 * seznamu bude znak zastupujc olka umstn do board[][],
	 * a nen nutn zobrazovat okno s vbrem zastupujcho psmene.
	*/
	if (z & JOKERBIT)
	    board_set_letter_at_coords(x, y, znak);
		
    }/* end for (j) */

    /* istota - pl zdrav :) */
    g_free((gpointer) t);
    
}/* end gui_ovladace_poloz_tah() */


/* -------------------------------------------------------------------------- */
/* ----------------------- HANDLER PRO checkbox 'PC' ------------------------ */
/* -------------------------------------------------------------------------- */

/* Jako data handler dostv 1 nebo 2, podle zatrenho checboxu. Me bt
 * zatrhl jen jeden anebo dn. Mlo by to fungovat jako 2 radio buttony
 * s monost "nezakliknut" nieho.
*/
GLOBAL int checkbox_button1_handler(GtkWidget *widget, gpointer data) {

    cbox_prep ^= 1;

    /* Druhej byl zakliknut, kdy se kliklo na tento */
    /* Aktivn bude tedy tento. */
    if (cbox_prep & 3)
	cbox_prep &= 1;	/* Vynuluj bit toho druhho */

    gui_ovladace_set_checkbox_status();

    return(TRUE);

}/* end of checkbox_button1_handler() */

/* -------------------------------------------------------------------------- */

GLOBAL int checkbox_button2_handler(GtkWidget *widget, gpointer data) {

    cbox_prep ^= 2;	

    /* Druhej byl zakliknut, kdy se kliklo na tento */
    /* Aktivn bude tedy tento. */
    if (cbox_prep & 3)
	cbox_prep &= 2; /* Vynuluj bit toho druhho */

    gui_ovladace_set_checkbox_status();

    return(TRUE);

}/* end of checkbox_button2_handler() */

/* -------------------------------------------------------------------------- */
/* ------------------ HANDLER PRO tlatko 'NAJDI SLOVA' -------------------- */
/* -------------------------------------------------------------------------- */

/* Tato funkce je tu kvli tto situaci: Spust se nov hra, vygeneruje
 * poprv seznam tah. V promnn ptah bude '1' (1. tah), a turn == 1.
 * Pokud dojde k Naten hry prv te, help_button_handler by tedy nic do
 * oknka nezapsal (test ptah == turn). Proto je poteba inicializovat ptah
 * znovu na -1.
*/ 
GLOBAL void set_help_handler_counter(int pocet) {

    ptah = pocet;

}/* end of set_help_handler_counter() */

/* -------------------------------------------------------------------------- */

GLOBAL int help_button_handler( GtkWidget *widget, gpointer data) {

    /* Volej, jen kdy je to vhodn */
    if (game_mode != PLAY_MODE)
	return(TRUE);

    if ( hra_dej_stav_podvadeni() == FALSE ) {
	show_info_window(GTK_WINDOW(app), 
		"'Podvdn' doasn zablokovno.\n Zapnout jej"
		" mete v menu Nstroje.");
	return(TRUE);
    }
    
    /* Neprovdj nic, pokud stisknuto v tomt tahu vckrt  */
    if (ptah != turn) {
	zapis_seznam_tahu_do_tabulky();
	ptah = turn;
	poloz_tah = turn;
    }

    return(TRUE);

}/* end of help_button_handler() */

/* -------------------------------------------------------------------------- */
/* -------------------- HANDLER PRO tlatko 'PASS' ------------------------- */
/* -------------------------------------------------------------------------- */

/* PASS znamen vzdn se tahu, vtinou se pouv v ppadech, kdy
 * hr nedoke utvoit slovo. Po 4 po sob nsledujcch PASSech je
 * hra ukonena (kad hr provede 2x po sob PASS */
GLOBAL int pass_button_handler(GtkWidget *widget, gpointer data ) {

    /* A na desce nezstane dn kameny */
    rack_return_played_tiles_home();

    /* Jen pokud hrajeme */
    if (game_mode != PLAY_MODE)
	return(TRUE);
    
    hra_proved_pass();

    if (player == computer)
	hra_proved_hru_pocitace();

    return(TRUE);
    
}/* end of pass_button_handler() */

/* -------------------------------------------------------------------------- */
/* ------------------ HANDLER PRO tlatko 'SPOTI BODY' -------------------- */
/* -------------------------------------------------------------------------- */

GLOBAL int evaluate_button_handler(GtkWidget *widget, gpointer data) {

    int i, r, body;
    char message[100] = "";		/* Na hlku s neplatnm slovem */

    char *s = NULL;
    char s_x[5] = "";
    char s_y[5] = "";
    unsigned char x = POC_KAMENU_SIRKA;
    unsigned char y = POC_KAMENU_VYSKA;
    unsigned char MID_X;
    unsigned char MID_Y;
    tpozice pom;
    torientace o;
    skamen *rack; 

    /* (bugfix) - pi GAME OVER to tu me spadnout :-) */
    if ( (game_mode != PLAY_MODE) )
	return(TRUE);
    
    MID_X = (x % 2) ? (x/2)+1 : (x/2);
    MID_Y = (y % 2) ? (y/2)+1 : (y/2);
     
    sprintf(s_x, "%d", MID_X);
    s_y[0] = MID_Y + 'A' - 1; s_y[1] = '\0';

    /* Nic nedlej, pokud nejsou na desce dn nov kameny */
    if (game_mode == PLAY_MODE && rack_is_something_placed() == FALSE) {
	show_warning_window(GTK_WINDOW(app), 
				"Nejsou umstny dn nov kameny!");
	return(TRUE);
    }
	
    /* Zjisti chybu v umstn kamen */
    switch(move_is_placement_valid()) {
	
	case 2: s = g_strconcat(WARN_PLACEMENT_MID, " (", s_x, s_y, ")", NULL);
		show_warning_window(GTK_WINDOW(app), s); 
		g_free((gpointer) s);
		return(TRUE);
		break;
	case 3: show_warning_window(GTK_WINDOW(app), WARN_PLACEMENT_SCR); 
		return(TRUE);
		break;
	case 4: show_warning_window(GTK_WINDOW(app), WARN_PLACEMENT_ADJ); 
		return(TRUE);
		break;
	case 5: show_warning_window(GTK_WINDOW(app), WARN_PLACEMENT_NCONT);
		return(TRUE);
		break;
	default: 
		break;
    }

    /* Vybafni okna, pokud jsou olci na desce */
    gui_ovladace_zpracuj_zoliky();
    

    printf("SKORE PRO %s TAH\n", (horizontal) ? "HORIZONTAL" : "VERTICAL");
    if ((r=tahy_is_move_valid((horizontal) ? HORIZONTAL : VERTICAL)) != TRUE) {

	if (r==FALSE) 	/* Neplatn slovo */
	    strcat(message, (const char *) TEXT_WORD);
	else 		/* r==2 -> neplatn vertikln slovo */
	    strcat(message, (const char *) TEXT_PERPENDICULAR);
	    
	    strcat(message, (const char *) " '");
	    strcat(message, nenalezeno);
	    strcat(message, (const char *) "' ");
	    strcat(message, (const char *) TEXT_IS_INVALID);
	
	show_warning_window(GTK_WINDOW(app), message);
	return(TRUE);
    }
    
    /* Zskej nejlevj psmeno ze slova, kter jsme umstili */
    pom = tahy_nejlevejsi_pismeno();

    /* Spoti, kolik bod jsme za nj dostali */    
    o = (horizontal) ? ZD : SD;
    body = tahy_spocitej_body(player, pom, o);

    sprintf(s_x, "%d", body);
    strcpy(message, "Body za tento tah: ");
    strcat(message, s_x);

    /* lus Julius :-) */
    show_info_window(GTK_WINDOW(app), message);

    rack = (player == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */

    /* Dleit zleitost! Nutno vrtit zstupn psmeno
     * na otaznk, aby pi stisku 'HOTOVO' mohl uivatel
     * opt vybrat zstupn psmeno pro olka.
    */
    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++) {

	if (rack_is_placed_on_board(i) == TRUE) {

	    if (rack[i].znak == JOKERCHAR) {
		
		x = rack_placed_tiles_coords[i].x;
		y = rack_placed_tiles_coords[i].y;

		/* Run i 'Polo na desku'? */
		if (board_get_letter_at_coords(x, y) != JOKERCHAR) 
		    board_set_letter_at_coords(x, y, JOKERCHAR);
		
	    }/* end if ... JOKERCHAR */

	}/* end if ... placed == TRUE */
	    
    }/* end for (i) */

    return(TRUE);

} /* end of evaluate_button_handler() */

/* -------------------------------------------------------------------------- */
/* ------------------ HANDLER PRO tlatko 'HOTOVO' ------------------------- */
/* -------------------------------------------------------------------------- */

GLOBAL int done_button_handler(GtkWidget *widget, gpointer data ) {

    int r;
    char message[100] = "";		/* Na hlku s neplatnm slovem */

    char *s = NULL;
    char s_x[5] = "";
    char s_y[5] = "";
    unsigned char x = POC_KAMENU_SIRKA;
    unsigned char y = POC_KAMENU_VYSKA;
    unsigned char MID_X;
    unsigned char MID_Y;

   
    /* (bugfix) - pi GAME OVER to tu me spadnout :-) */
    if ( (game_mode != PLAY_MODE) && (game_mode != CHANGE_MODE) )
	return(TRUE);
    
    MID_X = (x % 2) ? (x/2)+1 : (x/2);
    MID_Y = (y % 2) ? (y/2)+1 : (y/2);
     
    sprintf(s_x, "%d", MID_X);
    s_y[0] = MID_Y + 'A' - 1; s_y[1] = '\0';

    /* Je-li nco oznaeno v PLAY_MODE reimu, nepokrauj */ 
    if ( (game_mode == PLAY_MODE) && 
	 (board_is_tile_clicked() == TRUE || 
	  rack_is_any_tile_clicked() == TRUE) ) 
	return(TRUE);
    

    /* Provdme PASS tah (vzvme se tahu) */
    if (game_mode == PLAY_MODE && rack_is_something_placed() == FALSE) {
	show_info_window(GTK_WINDOW(app), "Proveden PASS (vzdn se tahu).");
	hra_proved_pass();

	if (player == computer)
	    hra_proved_hru_pocitace();
	    
	return(TRUE);

    }/* end if PASS */
	
    /* Provdme vmnu? */
    if (game_mode == CHANGE_MODE) {

	/* Nic nebylo vymnno, chpe se jako PASS */
	if (rack_how_many_exchange() == 0) {
	    s = g_strconcat(
		INFO_NO_EXCHANGE_MADE, "\n(chpe se jako PASS)", NULL);
	    show_info_window(GTK_WINDOW(app), s);
	    g_free((gpointer) s);

	    hra_proved_pass();
	}
	else
	    hra_proved_vymenu();


	/* Jsme hotovi */
	game_mode = PLAY_MODE;

	if (player == computer)
	    hra_proved_hru_pocitace();
	
	return(TRUE);

    }/* end if (CHANGE_MODE) */


    /* Zjisti chybu v umstn kamen */
    switch(move_is_placement_valid()) {
	
	case 2: s = g_strconcat(WARN_PLACEMENT_MID, " (", s_x, s_y, ")", NULL);
		show_warning_window(GTK_WINDOW(app), s); 
		g_free((gpointer) s);
		return(TRUE);
		break;
	case 3: show_warning_window(GTK_WINDOW(app), WARN_PLACEMENT_SCR); 
		return(TRUE);
		break;
	case 4: show_warning_window(GTK_WINDOW(app), WARN_PLACEMENT_ADJ); 
		return(TRUE);
		break;
	case 5: show_warning_window(GTK_WINDOW(app), WARN_PLACEMENT_NCONT);
		return(TRUE);
		break;
	default: 
		break;
    }

    /* Vybafni okna, pokud jsou olci na desce */
    gui_ovladace_zpracuj_zoliky();

    printf("PROVADME %s TAH\n", (horizontal) ? "HORIZONTAL" : "VERTICAL");
    if ((r=tahy_is_move_valid((horizontal) ? HORIZONTAL : VERTICAL)) != TRUE) {

	if (r==FALSE) 	/* Neplatn slovo */
	    strcat(message, (const char *) TEXT_WORD);
	else 		/* r==2 -> neplatn vertikln slovo */
	    strcat(message, (const char *) TEXT_PERPENDICULAR);
	    
	    strcat(message, (const char *) " '");
	    strcat(message, nenalezeno);
	    strcat(message, (const char *) "' ");
	    strcat(message, (const char *) TEXT_IS_INVALID);
	
	show_warning_window(GTK_WINDOW(app), message);
	return(TRUE);
    }
    
    hra_proved_tah();			/* Dan kameny odehrej a nati nov */ 

    if (player == computer)
	hra_proved_hru_pocitace();
    
    return (TRUE);                      /* Hotovo */
    
}/* end of done_button_handler() */


/* -------------------------------------------------------------------------- */
/* ---------- HLAVN HANDLER PRO OVLDN PRCE S KAMENY NA DESCE ----------- */
/* -------------------------------------------------------------------------- */

GLOBAL int board_event_handler( GnomeCanvas *c, GdkEvent *event, gpointer data)
{
  gint x, y;
  int what;
  char pism[5];
  char hodn[10];
 
  if (game_mode == STOP_MODE || game_mode == CHANGE_MODE) 
      return(FALSE);

  /* we ignore all events except for BUTTON_PRESS */
  if(event->type != GDK_BUTTON_PRESS)
    return(FALSE);
  
  /* Pravm tlatkem vracme umstn kameny zpt do racku */  
  if (event->button.button == RIGHT_BUTTON) {
      rack_return_played_tiles_home();
      return(TRUE);
  }
  
  /* check if it's outside our range */
  if(event->button.x < VEL_OKRAJ_DESKY ||
     event->button.x > (VEL_OKRAJ_DESKY + VEL_KAMENE*POC_KAMENU_SIRKA)-1 ||
     event->button.y < VEL_OKRAJ_DESKY ||
     event->button.y > (VEL_OKRAJ_DESKY + VEL_KAMENE*POC_KAMENU_VYSKA)-1)
    return FALSE;
  
  x = (event->button.y - VEL_OKRAJ_DESKY) / VEL_KAMENE;
  y = (event->button.x - VEL_OKRAJ_DESKY) / VEL_KAMENE;

    if ( (game_mode == PLAY_MODE)) {
	if (rack_is_any_tile_clicked() == TRUE) {
	                                       /* Mme oznaen pole v racku? */
		what = rack_game_what_clicked();  /* Kter pole bylo oznaeno */
	    if (board_is_field_vacant(x, y) == TRUE) {      /* Je pole voln? */
    		copy_properties(board_grid[y][x], rack_grid[what][0]);
		rack_empty_tile(what);    /* Vyprzdn pslun pole v racku */
    		rack_set_placed_on_board(what, TRUE);    /* Kmen je na desce */
		rack_set_placed_tiles_coords(what, y, x, what);       /* Kde? */
		board_set_field_vacant(x, y, FALSE); /* Polko obsazeno */
		rack_unclick(what);	    /* Zru oznaen vybranho kamenu */
	    }
	}
	else { /* rack_is_any_tile_clicked() == FALSE */
	    if (board_is_it_tile_from_rack(x, y) == TRUE) {/* Pesun psmene? */
		if (board_is_tile_clicked() == FALSE) {  /* Vybrali jsme ji? */
		    
		    /* Zde oetme situaci, kdy je na ploe olk s ji
		     * zastupujcm psmenem na kameni a ten chceme pemstit.
		     * Musme tedy zmnit psmeno na kameni na '?' a na dan 
		     * msto v board[][] umstit znak '?'.
		    */

		    if (board_is_tile_joker(x, y) == TRUE) {
			board_set_letter_at_coords(x, y, JOKERCHAR);
			pism[0] = JOKERCHAR; pism[1] = '\0';
			sprintf(hodn, "%d", 
				skore_vrat_hodnotu(znak2index(JOKERCHAR)));
			board_draw_field(y, x, yellow_clr, black_clr, 
					 pism, hodn);
		    }/* end if .. joker */
		    
		    board_set_tile_clicked(TRUE);     /* S tmto budeme hbat */
		    lastx = x; lasty = y;                  /* Info pro pesun */
		    
		    /* Zjistme, kter psmeno z racku pemsujeme */
		    lwhat = rack_which_tile_at_coords(lastx, lasty);
		    board_set_tile_active(y, x);     /* Ozna kmen */
		}
		else { /* Ji jsme vybrali, oetme stav x=lastx, y=lasty */
		    if (x==lastx && y==lasty) {
			board_set_tile_rect_color(x, y, yellow_clr);
			board_set_tile_clicked(FALSE);        /* Pesun hotov */
		    }
		}
	    } /* board_is_it_tile_from_rack(x, y) == TRUE */
	    else {        /* Kliknuto na polko, kter nen psmenem z racku */
		if (board_is_tile_clicked() == TRUE) {     /* U mme vybrno */
		    if (board_is_field_vacant(x, y) == TRUE) { /* A je volno? */
			exchange_properties(&board_grid[y][x], 
				            &board_grid[lasty][lastx]);
			board_revert_tile_to_empty(lasty, lastx);
			                                     /* Obnov przdn */
		        /* Nastavme danmu psmenu z racku nov [x,y] */
			rack_set_placed_tiles_coords(lwhat, y, x, lwhat);
			board_set_field_vacant(lastx, lasty, TRUE); 
			board_set_field_vacant(x, y, FALSE);
			board_set_tile_clicked(FALSE);        /* Pesun hotov */
		    }
			
		}
	    }
		
	}

    draw_rack();		/* A aktualizuj rack */
    }
    
    return FALSE;

}/* end of board_event_handler() */

/* -------------------------------------------------------------------------- */
/* ---------- HLAVN HANDLER PRO OVLDN PRCE S KAMENY V RACKU ------------ */
/* -------------------------------------------------------------------------- */
GLOBAL int rack_event_handler( GnomeCanvas *c, GdkEvent *event, gpointer data)
{
    int x,y;
    skamen *rack;

  if (game_mode == STOP_MODE)   /* Jet nehrajeme */
      return(FALSE);

  /* we ignore all events except for BUTTON_PRESS */
  if(event->type != GDK_BUTTON_PRESS)
    return(FALSE);
  
  x = (event->button.x) / VEL_KAMENE;
  y = (event->button.y) / VEL_KAMENE;
  
  rack = (player == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */

  if (game_mode == CHANGE_MODE) { /* Pi vmn je mono vybrat vce kamen */
      if (rack[x].znak != EMPTY_TILE) { /* Nevybrej przdn pole */
	printf("Mnm %d\n", x);
	rack_click[x] = (rack_click[x] == TRUE) ? FALSE : TRUE;
      }
  }
  
  else {     /* == PLAY_MODE */

      if (board_is_tile_clicked() == FALSE) { /* Neprovd se pesun na desce */
	  
	  if (rack_is_any_tile_clicked() == FALSE) { 
                                             /* dn psmeno zatm nevybrno */
	      if (rack_is_placed_on_board(x) == TRUE)
		  rack_click[x] = FALSE;
	      else
		  rack_click[x] = TRUE;
	  }
	  else { /* rack_is_any_tile_clicked() == TRUE - U je vybrn kmen */
	      y = rack_game_what_clicked(); /* Kter to je? */
	      /* Tent, i jin? Tent=odzna, Jin=ponechej beze zmny */
	      rack_click[x] = (x == y) ? FALSE : rack_click[x];
	  }
      }/*end board_is_tile_clicked() == FALSE */
      else { /* Provdme pesun na z desky do racku */
	  exchange_properties(&rack_grid[lwhat][0], &board_grid[lasty][lastx]);
	  board_revert_tile_to_empty(lasty, lastx);  /* Uvolni msto na desce */
	  board_set_field_vacant(lastx, lasty, TRUE); /* Pozice na desce FREE */
	  board_set_tile_clicked(FALSE);               /* Pesun do racku OK */
          rack_set_placed_tiles_coords(lwhat, 
		                       EMPTY_TILE, EMPTY_TILE, EMPTY_TILE); 
	                                               /* Jsme zpt v racku */
	  rack_set_placed_on_board(lwhat, FALSE);
      }
	  
  } /* == PLAY_MODE */
      
  
  
    draw_rack();

    return FALSE;

}/* end of rack_event_handler() */

/* -------------------------------------------------------------------------- */

/* Zobraz dialog (combo) vbr psmene pro olka. 'which'
 * udv pozici toho olka v pihrdce.
*/
LOCAL char gui_ovladace_vyber_pismeno(int which) {

    GtkWidget *dialog;
    GtkWidget *label;
    GtkWidget *combo;
    GList *letters = NULL;
    char *str;
    char *pis;
    char znak;
    
    char s_x[5];
    char s_y[5];
    char *zprava = NULL;

    int reply;
    int i, x, y;

    x = rack_placed_tiles_coords[which].x;
    y = rack_placed_tiles_coords[which].y;

    /* Budeme vypisovat, za kterho olka se vybr psmeno */
    sprintf(s_x, "%d", x+1);
    s_y[0] = y + (int) 'A';
    s_y[1] = '\0';

    printf("V Board[%d][%d] je '%c'\n", x+1, y+1, 
	    board_get_letter_at_coords(x, y));


    zprava = g_strconcat("Zvolte zastupujc psmeno pro olka\n",
			 "na pozici (", s_x, ",", s_y, ").", NULL);

    /* Pidme do comba psmena, bez olka samozejm */
    for(i=0;i<MAX_VEL_ABECEDY-2;i++) {
	str = (char *) malloc (2*sizeof(char));
        str[0] = ABECEDA[i]; str[1] = '\0';
        letters = g_list_append(letters, (gpointer) str);
    }/* end for(i) */

    dialog = gnome_dialog_new(N_("Vyberte zastupujc psmeno."),
                            GNOME_STOCK_BUTTON_OK,
                            NULL);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(app));
    gtk_window_set_title(GTK_WINDOW(dialog), "Vyberte zastupujc psmeno.");

    label = gtk_label_new(zprava);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
            label, FALSE, FALSE, 0);

    combo = gtk_combo_new();
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
            combo, FALSE, FALSE, 0);
    gtk_widget_set_usize(combo, 40, 20);
    gtk_entry_set_max_length(GTK_ENTRY(GTK_COMBO(combo)->entry), 1);
    gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(combo)->entry), FALSE);
    gtk_combo_set_popdown_strings(GTK_COMBO(combo), letters);

    /* Zobraz dialog */
    gtk_widget_show_all(dialog);

    /* Stisknuto 'OK' nebo 'kek v okn' */
    reply = gnome_dialog_run(GNOME_DIALOG(dialog));

    if (reply == GNOME_OK) {
	pis = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo)->entry));	
	znak = pis[0];
	gtk_widget_destroy(dialog);
    }
    else {
	znak = 'a';
    }

    g_list_free(letters);

    g_free((gpointer) zprava);

    return(znak);

}/* end of gui_ovladace_vyber_pismeno() */

/* -------------------------------------------------------------------------- */

/* Piad kadmu olku prv poloenmu na desce psmeno */
LOCAL void gui_ovladace_zpracuj_zoliky(void) {

    skamen *rack; 
    int i, x, y;
    char znak;

    rack = (player == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */

    /* Projdi pes vechny kameny, najdi ty, co jsou
     * na desce a z nich ty, co jsou olkem a pro ty
     * zavolej dialog s vbrem psmene
    */

    /* Navc je zde jet speciln test pro zjitn,
     * zda je olk umstn run i byly kameny poloeny
     * na desku tlatkem 'Polo na desku'. V prvnm ppad
     * je na pslunm mst v board[][] umstn '?' a v druhm
     * u zastupujc psmeno. Podle toho se rozpozn, zda se m
     * nabdnout okno s vbrem zastupujcho psmene.
    */
    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++) {
	if (rack_is_placed_on_board(i) == TRUE)
	    if (rack[i].znak == JOKERCHAR) {
		
		x = rack_placed_tiles_coords[i].x;
		y = rack_placed_tiles_coords[i].y;

		/* Run i 'Polo na desku'? */
		if (board_get_letter_at_coords(x, y) != JOKERCHAR) {
		    printf("Psmeno '%c' (olk) na [%d,%d]\n",
			    board_get_letter_at_coords(x, y), x+1, y+1);
		}
		else {	    
		    znak = gui_ovladace_vyber_pismeno(i);
		    /* Nahra znak v board[][] zvolenm */
		    board_set_letter_at_coords(x, y, znak);
		}

	    }/* end if ... JOKERCHAR */
	    
    }/* end for (i) */
	   
}/* end of gui_ovladace_zpracuj_zoliky() */

/* -------------------------------------------------------------------------- */

LOCAL void gui_ovladace_set_checkbox_status(void) {

    gtk_signal_handler_block(GTK_OBJECT(cbox1), con_id1);
    gtk_signal_handler_block(GTK_OBJECT(cbox2), con_id2);
    
    /* Zapni prvnho, vypni druhho */
    if (cbox_prep == 1) {
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cbox1), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cbox2), FALSE);
    }
    /* Naopak */
    if (cbox_prep == 2) {
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cbox2), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cbox1), FALSE);
    }
    gtk_signal_handler_unblock(GTK_OBJECT(cbox1), con_id1);
    gtk_signal_handler_unblock(GTK_OBJECT(cbox2), con_id2);

    /* Pepna, kter z hr je pota */
    switch(cbox_prep) {
	case 0: computer = 2; break;
	case 1: computer = 0; break;
	case 2: computer = 1; break;
    }

}/* end of gui_ovladace_set_checkbox_status() */

/* -------------------------------------------------------------------------- */

/* Zsk sla spojen pro oba checkboxy, pro poteby blokovn
 * signlu jimi emitovanch.
*/
GLOBAL void gui_ovladace_ziskej_konexe(guint id1, guint id2) {

    con_id1 = id1;
    con_id2 = id2;

}/* end of gui_ovladace_ziskej_konexe() */

/* -------------------------------------------------------------------------- */

/* Ovlada pro toggle button 'Povolit hledn slov' */
GLOBAL gint gui_ovladace_cheat_callback(void) {

    boolean stav;
    boolean pom;
    
    stav = hra_dej_stav_podvadeni();

    pom = (stav == TRUE) ? FALSE : TRUE;

    printf("'Podvdn' na  %s\n", (pom==TRUE) ? "ON" : "OFF");

    hra_nastav_podvadeni(pom);
    
    return(TRUE);

}/* end of gui_ovladace_cheat_callback() */

/* -------------------------------------------------------------------------- */

/* Nastav obtnost hry */
GLOBAL void gui_ovladace_obtiznost_callback(GtkToggleButton *b, gpointer data) {

    obtiznost_hry = (int) data;

}/* end of gui_ovladace_obtiznost_callback() */

/* -------------------------------------------------------------------------- */

/* Vykresl informativn okno - ToDo - zatm neimplementovno */
GLOBAL void gui_ovladace_todo_okno(void) {

    show_info_window(GTK_WINDOW(app), "ToDo - zatm neimplementovno!");

}/* end of gui_ovladace_todo_okno() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE ovladace.c */
