#include<ctype.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "vacek.h"
#include "prihradka.h"
#include "gui_deska.h"
#include "gui_okno.h"


LOCAL void nastav_policko_prihradky(gui_policko *p, char *znak, char *hodnota);
GLOBAL void gui_zobraz_prihradky(void);

/* -------------------------------------------------------------------------- */
/* ------------------------- OKNO S PIHRDKAMI HR ----------------------- */
/* -------------------------------------------------------------------------- */

LOCAL void nastav_policko_prihradky(gui_policko *p, char *znak, char *hodnota) {

    gnome_canvas_item_set(p->obdelnik,
	"fill_color_rgba", yellow_clr,
	NULL);   

    gnome_canvas_item_set(p->pismeno,
	"x", (double) VEL_KAMENE-POFFX,
	"y", (double) VEL_KAMENE-POFFY,
	"font", KAMEN_FONT,
	"fill_color_rgba", black_clr,
	"text", znak,
        NULL);   
    
    gnome_canvas_item_set(p->hodnota,
	"x", (double) VEL_KAMENE-HOFFX,
	"y", (double) VEL_KAMENE-HOFFY,
	"font", HODNOTA_FONT,
	"text", hodnota,
	"fill_color_rgba", black_clr,
        NULL);   

}/* end of nastav_policko_prihradky() */

/* -------------------------------------------------------------------------- */

/* Zobraz okno s pihrdkami */
GLOBAL void gui_zobraz_prihradky(void) {
    
    int i, j, k;

    gchar p1name[50] = "";
    gchar p2name[50] = "";
    gchar c[2] = "0\0";
    gchar h[5] = "0\0";
  
    GtkWidget *wc;
    GnomeCanvasGroup *group = NULL;
    GnomeCanvas *canvas;
    GnomeCanvasItem *item;
    
    GtkWidget *label;
    GtkWidget *vbox;
    GtkWidget *okno;

    /* Struktury pro vykreslen pihrdek */
    gui_policko p1[MAX_ROZMER];
    gui_policko p2[MAX_ROZMER];
    
    /* Jmna hr */
    strcpy(p1name, gtk_entry_get_text(GTK_ENTRY(player1_name)));
    strcpy(p2name, gtk_entry_get_text(GTK_ENTRY(player2_name)));
    
    okno = gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_window_set_position(GTK_WINDOW(okno), 
			    (GtkWindowPosition) GTK_WIN_POS_CENTER);
    gtk_window_set_title(GTK_WINDOW(okno), "Pihrdky hr");
    gtk_window_set_default_size(GTK_WINDOW(okno), 
	    (2+MAX_PISMEN_PRIHRADKA)*VEL_KAMENE,
	    VEL_OKRAJ_DESKY+(3*VEL_KAMENE));
    gtk_window_set_policy(GTK_WINDOW(okno), FALSE, TRUE, FALSE);
    gtk_window_set_modal(GTK_WINDOW(okno), TRUE);
   
    vbox = gtk_vbox_new(FALSE, 5); 
    
    label = gtk_label_new("Pihrdky hr");
    gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 5);

    gtk_widget_push_visual(gdk_imlib_get_visual());
    gtk_widget_push_colormap(gdk_imlib_get_colormap());
    wc = gnome_canvas_new(); 
    gtk_widget_pop_visual();
    gtk_widget_pop_colormap();

    canvas = GNOME_CANVAS(wc);
    
    /* Nastav viditelnou st a velikost */
    gnome_canvas_set_scroll_region(canvas, 0.0, 0.0,
			     (5+MAX_PISMEN_PRIHRADKA)*VEL_KAMENE, 3*VEL_KAMENE);
    gtk_widget_set_usize(wc, (5+MAX_PISMEN_PRIHRADKA)*VEL_KAMENE, 3*VEL_KAMENE);

    /* vytvo  'group' na canvasu */
    item = gnome_canvas_item_new(gnome_canvas_root(canvas),
	   gnome_canvas_group_get_type(),
		"x",(double) (4*VEL_KAMENE),
		"y",(double) 0,
		NULL);

    group = GNOME_CANVAS_GROUP(item);
  
    for(i=0;i<=MAX_PISMEN_PRIHRADKA;i++) {
	draw_a_line(gnome_canvas_root(canvas),
	(4+i)*VEL_KAMENE, 0, (4+i)*VEL_KAMENE, VEL_KAMENE, "black");
	draw_a_line(gnome_canvas_root(canvas),
	(4+i)*VEL_KAMENE, VEL_KAMENE, (4+i)*VEL_KAMENE, 2*VEL_KAMENE, "black");
    }
  
    draw_a_line(gnome_canvas_root(canvas),
    (4*VEL_KAMENE), 0,  (4+MAX_PISMEN_PRIHRADKA)*VEL_KAMENE, 0, 
	"black");
    draw_a_line(gnome_canvas_root(canvas),
    (4*VEL_KAMENE), VEL_KAMENE, (4+MAX_PISMEN_PRIHRADKA)*VEL_KAMENE, VEL_KAMENE,
	"black");
    draw_a_line(gnome_canvas_root(canvas),
    (4*VEL_KAMENE), 2*VEL_KAMENE, 
    (4+MAX_PISMEN_PRIHRADKA)*VEL_KAMENE, 2*VEL_KAMENE,
	"black");


    gnome_canvas_item_new(gnome_canvas_root(canvas),
	gnome_canvas_text_get_type(),
	    "x", (double) VEL_KAMENE/2,
            "y", (double) VEL_KAMENE/2,
            "anchor", GTK_ANCHOR_WEST,
            "font", BONUS_FONT,
            "fill_color_rgba", black_clr,
            "text", p1name,
            NULL);
    
    gnome_canvas_item_new(gnome_canvas_root(canvas),
	gnome_canvas_text_get_type(),
	    "x", (double) VEL_KAMENE/2,
            "y", (double) VEL_KAMENE + VEL_KAMENE/2,
            "anchor", GTK_ANCHOR_WEST,
            "font", BONUS_FONT,
            "fill_color_rgba", black_clr,
            "text", p2name,
            NULL);


    /* Vytvo 'groups' pro kad polko v pihrdce */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	vytvor_policko(group, 
		&p1[i], i, 0, yellow_clr, EMPTY_WORD, EMPTY_TILE);
	vytvor_policko(group, 
		&p2[i], i, 1, yellow_clr, EMPTY_WORD, EMPTY_TILE);
    }/* end for */

    /* A napl pole pslunmi hodnotami */
    for(i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	
	j = rack1[i].znak;
	k = rack1[i].hodnota;
	c[0] = (j == EMPTY_TILE) ? ' ' : toupper(j); c[1] = '\0';
	
	if (j != EMPTY_TILE)
	    sprintf(h, "%d", k);
	else
	    strcpy(h, "");
	
	nastav_policko_prihradky(&p1[i], c, h); 
	
	j = rack2[i].znak;
	k = rack2[i].hodnota;
	c[0] = (j == EMPTY_TILE) ? ' ' : toupper(j); c[1] = '\0';
	
	if (j != EMPTY_TILE)
	    sprintf(h, "%d", k);
	else
	    strcpy(h, "");
	
	nastav_policko_prihradky(&p2[i], c, h); 

    }/* end for */
    
    gtk_box_pack_start(GTK_BOX(vbox), wc, FALSE, FALSE, 5);
    gtk_container_add(GTK_CONTAINER(okno), vbox);
    gtk_widget_show_all(okno);

  
}/* end of gui_zobraz_prihradky() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_prihradky.c */
