#include<stdlib.h>
#include<ctype.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "gui_okno.h"
#include "gui_deska.h"
#include "automat.h"
#include "cesty.h"
#include "slovniky.h"
#include "util.h"
#include "hra.h"

/* --------------------- DEFINICE GLOBALNCH PROMNNCH --------------------- */

/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

LOCAL GtkWidget *dialog; 

LOCAL boolean vybrano = FALSE;	   /* TRUE = vybrn slovnk */
LOCAL boolean nacten_slovnik = FALSE; /* TRUE = probhlo nacti_automat() */
LOCAL int selected_row;		   /* Vybran dek v dict_clistu */

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void gui_slovniky_vyber_slovnik(void);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

LOCAL void gui_slovniky_napln_okno(GtkWidget *clist); 
LOCAL int  dict_delete_event_callback(GtkWidget *w, gpointer data);
LOCAL void dict_pouzit_button_callback(GtkWidget *w, gpointer data);
LOCAL void dict_clist_callback(GtkWidget *w, gint row, gint column,
                               GdkEventButton *event, gpointer data);

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* Pi snaze o uzaven okna pi vbru slovnku bude automaticky
 * nahrn standardn slovnk pro Scrabble. Dej o tom vdt oknem.
*/
LOCAL int  dict_delete_event_callback(GtkWidget *w, gpointer data) {
    
    show_info_window(GTK_WINDOW(app), 
	    "Pouije se standardn slovnk pro Scrabble.");

    nacti_automat(STD_SLOVNIK_CESTA);

    ext_slovnik = FALSE;

    nacten_slovnik = TRUE;

    strcpy(akt_slovnik_cesta, STD_SLOVNIK_CESTA);

    return(FALSE);	/* Obsluha bude pokraovat dle */
    
}/* end of dict_delete_event_callback() */

/* -------------------------------------------------------------------------- */

/* Napln clist nalezenmi slovnky */
LOCAL void gui_slovniky_napln_okno(GtkWidget *clist) {
    
    int i;
    char *radek[1];
    char path[2*DMAX] = "";
    char *cesta = NULL;
    char *popis = NULL;

    /* 1. v poad bude standardn slovnk pro Scrabble */
    popis = slovniky_ziskej_popis(STD_SLOVNIK_INF_CESTA);
    radek[0] = popis;
    gtk_clist_append(GTK_CLIST(clist), radek);
    g_free((gpointer) popis);	/* Nutno provst */
   
    /* Dal pak definovan konfigurac */ 
    for(i=0;i<slovniky_dej_pocet();i++) {

	cesta = slovniky_dej_slovnik(i);
	printf("cesta %d = %s\n", i, cesta);

	strcpy(path, "");
	strcat(path, cesta);
	strcat(path, ".inf");
	
	popis = slovniky_ziskej_popis(path); 

	/* Chyb-li soubor .inf nebo .inf je przdn */
	/* Do Clistu zobrazme jen cestu */
	if (popis != NULL) {
	   radek[0] = popis;
	   gtk_clist_append(GTK_CLIST(clist), radek);
	   g_free((gpointer) popis);
	}
	else {	/* Chyb info soubor */
	   strcpy(path, "");
	   strcat(path, cesta);
	   strcat(path, ": [Chyb popis]");
	   radek[0] = path;
	   gtk_clist_append(GTK_CLIST(clist), radek);
	}
	       
    }/* end for (i) */

}/* end of gui_slovniky_napln_okno() */

/* -------------------------------------------------------------------------- */

/* Buttonek zahls chybu, pokud nen nic vybrno */
/* Jinak napln promnnou ext_slovnik a akt_slovnik_cesta */
LOCAL void dict_pouzit_button_callback(GtkWidget *w, gpointer data) {

    char *cesta;

    if (vybrano == FALSE) 
	show_warning_window(GTK_WINDOW(data), "Muste vybrat slovnk pro hru.");
    else {

	/* 1. v seznamu je vdy standardn slovnk pro Scrabble */
	if (selected_row == 0) {
	    nacti_automat(STD_SLOVNIK_CESTA);
	    ext_slovnik = FALSE;
	    strcpy(akt_slovnik_cesta, STD_SLOVNIK_CESTA);
	    gtk_label_set_text(GTK_LABEL(slovnik_status), 
		    " Slovnk: Standardn ");
	}
	else {
	    cesta = slovniky_dej_slovnik(selected_row-1);
	    nacti_automat(cesta);
	    ext_slovnik = TRUE;
	    strcpy(akt_slovnik_cesta, cesta);
	    gtk_label_set_text(GTK_LABEL(slovnik_status), 
		    " Slovnk: Extern ");
	}

	nacten_slovnik = TRUE;	
	gtk_widget_destroy(dialog);
	
    }/* end else (vybrano == TRUE) */

}/* end of dict_pouzit_button_callback() */

/* -------------------------------------------------------------------------- */

/* Umon/znemon  odebrn/pravu dku v clistu */
LOCAL void dict_clist_callback(GtkWidget *w, gint row, gint column,
                               GdkEventButton *event, gpointer data) {

    /* Unselect dku - znemon vybrn */
    if ((int) data == 1)
	vybrano = FALSE;
    else {
	vybrano = TRUE;
	selected_row = row;
    }

}/* end of dict_clist_callback() */

/* -------------------------------------------------------------------------- */
/* --------------------- OKNO SE SEZNAMEM SLOVNK -------------------------- */
/* -------------------------------------------------------------------------- */

/* Zobraz okno s jednotlivmi nastavenmi */
GLOBAL void gui_slovniky_vyber_slovnik(void) {

    GtkWidget *frame;
    GtkWidget *button;
    GtkWidget *hsep;
    GtkWidget *vbox;
    GtkWidget *scroll_okno;
    GtkWidget *dict_clist;

    int reply;
  
    /* Dialog bez OK/CANCEL */ 
    dialog = gnome_dialog_new(_("Vbr slovnku pro hru."), NULL);
    gtk_signal_connect (GTK_OBJECT(dialog), "delete_event",
                        GTK_SIGNAL_FUNC(dict_delete_event_callback), NULL);
	
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(app));
    
    frame = gtk_frame_new("Vyberte slovnk pro hru.");
    gtk_container_set_border_width(GTK_CONTAINER (frame), 5);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), 
				    frame, FALSE, FALSE, 0);

    /* V nm clist a button */
    vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), vbox);
	
    scroll_okno = gtk_scrolled_window_new(NULL, NULL);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_okno),
                                   GTK_POLICY_NEVER, GTK_POLICY_NEVER);
    gtk_box_pack_start(GTK_BOX(vbox), scroll_okno, FALSE, FALSE, 0);

    dict_clist = gtk_clist_new_with_titles(1, NULL); 
    gtk_clist_set_shadow_type(GTK_CLIST(dict_clist), GTK_SHADOW_ETCHED_OUT);
    gtk_clist_set_column_width(GTK_CLIST(dict_clist), 0, 500);
    gtk_container_add(GTK_CONTAINER(scroll_okno), dict_clist);
         
    gui_slovniky_napln_okno(dict_clist); 

    gtk_signal_connect(GTK_OBJECT(dict_clist), "select-row",
             GTK_SIGNAL_FUNC(dict_clist_callback), (gpointer) 0);
    gtk_signal_connect(GTK_OBJECT(dict_clist), "unselect-row",
             GTK_SIGNAL_FUNC(dict_clist_callback), (gpointer) 1);

    hsep = gtk_hseparator_new();
    gtk_box_pack_start(GTK_BOX(vbox), hsep, FALSE, FALSE, 0);

    button = gtk_button_new_with_label("Pout");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(dict_pouzit_button_callback), 
		       (gpointer) dialog);
    gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);

    gtk_widget_show_all(dialog);

    reply = gnome_dialog_run(GNOME_DIALOG(dialog));

    /* Stisknuto ESCAPE */
    if (nacten_slovnik == FALSE)
	dict_delete_event_callback(NULL, NULL);

}/* end of gui_slovniky_vyber_slovnik() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_slovnik.c */
