#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "gui_okno.h"
#include "gui_deska.h"

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL boolean gui_util_validni_pole(GtkEntry *text_pole);
GLOBAL void gui_util_invalid_okno(GtkWindow *okno, char *hlaska);

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* Zkontroluje, zda je dan textov pole neprzdn a obsahuje-li slo */
/* Vrac TRUE=OK, jinak FALSE */
GLOBAL boolean gui_util_validni_pole(GtkEntry *text_pole) {

    char *text;
    int i;

    /* Zskej text z textovho pole */
    text = gtk_editable_get_chars(GTK_EDITABLE(text_pole), 0, -1);

    /* Przdn textov pole je chybn */
    if ( (strcmp(text, "")) == 0)
	return(FALSE);

    /* Najdeme-li v etzci psmeno i
     * jin znak ne slice, vrtme FALSE.
    */
    for (i=0;i<strlen(text);i++)
	if ( (text[i] < '0') || (text[i] > '9') ) 
	    return(FALSE);

    return(TRUE);
    
}/* end of gui_util_validni_pole() */

/* -------------------------------------------------------------------------- */

/* Zobraz okno s informac, e textov pole je neplatn
 * (neobsahuje pouze slice nebo je przdn)
*/
GLOBAL void gui_util_invalid_okno(GtkWindow *okno, char *hlaska) {

    show_warning_window(okno, hlaska);

}/* end of gui_util_invalid_okno() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_util.c */
