#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<string.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "vacek.h"
#include "prihradka.h"
#include "skore.h"

#define TRUE                            1
#define FALSE                           0

/* ------------------------ DEFINICE LOCALNCH TYP ------------------------- */

/* --------------------- DEKLARACE GLOBALNCH PROMNNCH -------------------- */

/* --------------------- DEKLARACE LOCALNCH PROMNNCH --------------------- */

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void logovani_nastav_std_nazev(void);
GLOBAL boolean logovani_vytvor_soubor(char *nazev, int pocitac, int akt_hrac);
GLOBAL boolean logovani_zapis_zas_skore(void);
GLOBAL boolean logovani_zapis_vysledek(int s1, int s2);
GLOBAL boolean logovani_zapis_odehrany_tah(int tah, int hrac, char typ,
                                           int body, int ori, int x, int y, 
                                           char *slovo);

/* -------------------------------------------------------------------------- */

/* Nastav globln promnnou LOGOVANI_SOUBOR na 
 * 'scarabeus-DD-MM-RRRR-HH-MM.log'
*/
GLOBAL void logovani_nastav_std_nazev(void) {

    time_t cas;
    struct tm *t_cas;

    int den, mesic, rok;
    int hodina, minuta;
    char nula[10];
    char datum[MAX_ROZMER];
    char *home = NULL;
    char cesta[DMAX];

    home = getenv("HOME");
    time(&cas);
    t_cas = localtime(&cas);

    strcpy(LOGOVANI_SOUBOR, "");
    strcpy(cesta, "");
    strcat(cesta, home);
    strcat(cesta, "/.scarabeus/scarabeus-");
    

    strcpy(datum, "");

    /* den */ 
    den = t_cas->tm_mday;
    if (den < 10) {
	nula[0] = '0';
	nula[1] = (char) den + '0';
	nula[2] = '\0';
	strcat(datum, nula);
    }
    else {
	sprintf(nula, "%d", den);
	strcat(datum, nula);
    }
    
    strcat(datum, "-");

    /* msc */
    mesic = (t_cas->tm_mon) + 1;
    if (mesic < 10) {
	nula[0] = '0';
	nula[1] = (char) mesic + '0';
	nula[2] = '\0';
	strcat(datum, nula);
    }
    else {
	sprintf(nula, "%d", mesic);
	strcat(datum, nula);
    }
    
    strcat(datum, "-");
    
    /* rok */
    rok = 1900 + (t_cas->tm_year);
    sprintf(nula, "%d", rok);
    strcat(datum, nula);
    
    strcat(datum, "-");

    /* hodina */
    hodina = t_cas->tm_hour;
    if (hodina < 10) {
	nula[0] = '0';
	nula[1] = (char) hodina + '0';
	nula[2] = '\0';
	strcat(datum, nula);
    }
    else {
	sprintf(nula, "%d", hodina);
	strcat(datum, nula);
    }

    strcat(datum, "-");

    /* minuta */
    minuta = t_cas->tm_min;
    if (minuta < 10) {
	nula[0] = '0';
	nula[1] = (char) minuta + '0';
	nula[2] = '\0';
	strcat(datum, nula);
    }
    else {
	sprintf(nula, "%d", minuta);
	strcat(datum, nula);
    }

    strcat(cesta, datum);
    strcat(cesta, ".log");

    strcat(LOGOVANI_SOUBOR, cesta);    

}/* end of logovani_nastav_std_nazev() */

/* -------------------------------------------------------------------------- */

/* Oteve soubor pro zpis a ihned jej zave (vytvo przdn)
 * Pi chyb nastav promnnou 'logovat_prubeh' na FALSE!!!
*/
GLOBAL boolean logovani_vytvor_soubor(char *nazev, int pocitac, int akt_hrac) {

    FILE *soubor;

    if ((soubor = fopen(nazev, "w")) == NULL) {
	logovat_prubeh = FALSE;
	return(FALSE);
    }


    /* Zapeme info:
     * 1. - Kter hr je pota (0/1/2)
     * 2. - Kdo zanal
     * 3. - Rozmry desky
     * 4. - Poet kamen v zsobnku
     * 5. - etzec se sadou psmen
     * 6. - 2P, 3P, 2S, 3S (hodnoty prmi)
     * 7. - etzec 2P
     * 8. - etzec 3P
     * 8. - etzec 2S
     * 8. - etzec 3S
    */
    fprintf(soubor, "Pota: %d\n", pocitac);
    fprintf(soubor, "Zanal: %d\n", akt_hrac);
    fprintf(soubor, "Rozmry: %dx%d\n", 
		    akt.POC_KAMENU_SIRKA, akt.POC_KAMENU_VYSKA);
    fprintf(soubor, "Velikost zsobnku: %d\n", akt.MAX_PISMEN_PRIHRADKA);
    fprintf(soubor, "Sada psmen: %s\n", akt.SADA_PISMEN);
    fprintf(soubor, "Hodnoty prmi: 2P=%d,3P=%d,2S=%d,3S=%d\n", 
		    akt.PISMX2, akt.PISMX3, akt.SLOVOX2, akt.SLOVOX3);
    fprintf(soubor, "Umstn 2P: %s\n", akt.PISMENO2POLE);
    fprintf(soubor, "Umstn 3P: %s\n", akt.PISMENO3POLE);
    fprintf(soubor, "Umstn 2S: %s\n", akt.SLOVO2POLE);
    fprintf(soubor, "Umstn 3S: %s\n", akt.SLOVO3POLE);

    fclose(soubor);
    
    return(TRUE);
    
	    
}/* end of logovani_vytvor_soubor() */

/* -------------------------------------------------------------------------- */

/* Zape do logovacho souboru obsah zsobnku 
 * a skre obou hr.
*/
GLOBAL boolean logovani_zapis_zas_skore(void) {

    int i, j;
    char zasobnik[MAX_ROZMER];

    FILE *soubor;

    if ((soubor = fopen(LOGOVANI_SOUBOR, "a")) == NULL) {
	logovat_prubeh = FALSE;
	return(FALSE);
    }
    
    j = 0;
    /* Zsobnk prvnho hre */
    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	if (rack1[i].znak != EMPTY_TILE)
	    zasobnik[j++] = rack1[i].znak;
    zasobnik[j] = '\0';
    fprintf(soubor, "<%s> ", zasobnik);
    
    j = 0;
    /* Zsobnk druhho hre */
    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	if (rack2[i].znak != EMPTY_TILE)
	    zasobnik[j++] = rack2[i].znak;
    zasobnik[j] = '\0';
    fprintf(soubor, "<%s> ", zasobnik);

    /* Skre hre .1 */
    fprintf(soubor, "[%d] ", skore_h1);

    /* Skre hre .2 */
    fprintf(soubor, "[%d]\n", skore_h2);

    fclose(soubor);

    return(TRUE);

}/* end of logovani_zapis_zas_skore() */

/* -------------------------------------------------------------------------- */

/* Zape odehran tah a vrt TRUE/FALSE pi spchu/chyb */
GLOBAL boolean logovani_zapis_odehrany_tah(int tah, int hrac, char typ,
                                           int body, int ori, int x, int y, 
                                           char *slovo) {
    
    int i, j;
    char zasobnik[MAX_ROZMER];
    skamen *rack;

    FILE *soubor;

    rack = (hrac == HRAC1) ? rack1 : rack2;

    j = 0;
    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	if (rack[i].znak != EMPTY_TILE)
	    zasobnik[j++] = rack[i].znak;
    zasobnik[j] = '\0';

    if ((soubor = fopen(LOGOVANI_SOUBOR, "a")) == NULL) {
	logovat_prubeh = FALSE;
	return(FALSE);
    }

    fprintf(soubor, "%d %d <%s> %c %d %d %d %d <%s>\n", 
	    tah, hrac, zasobnik, typ, body, ori, x, y, slovo);

    fclose(soubor);

    return(TRUE);
    
}/* end of logovani_zapis_odehrany_tah() */

/* -------------------------------------------------------------------------- */

/* Zape vsledek hry */
GLOBAL boolean logovani_zapis_vysledek(int s1, int s2) {

    FILE *soubor;

    if ((soubor = fopen(LOGOVANI_SOUBOR, "a")) == NULL) {
	logovat_prubeh = FALSE;
	return(FALSE);
    }

    fprintf(soubor, "--Vsledek %d:%d\n", s1, s2);

    fclose(soubor);

    return(TRUE);

}/* end of logovani_zapis_vysledek() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE logovani.c */
