#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "vacek.h"
#include "deska.h"
#include "cross.h"
#include "automat.h"
#include "tahy_gui.h"
#include "prihradka.h"
#include "hra.h"

#define TRUE                            1
#define FALSE                           0

/* --------------------- DEFINICE GLOBALNCH PROMNNCH --------------------- */

GLOBAL int horizontal;          /* dku nebo sloupci? */

/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

LOCAL tpozice mostleft;		 /* Pozice nejlevjho psmene v novm slov */
LOCAL torientace mostlefto;	 /* V dan orientaci */
LOCAL int row;                  /* Ve kterm dku provedeno umstn kamen */

/* ---------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC --------------- */

GLOBAL boolean tahy_is_move_valid(torientace o);
GLOBAL void tahy_generuj_tah(int hrac);
GLOBAL tpozice tahy_nejlevejsi_pismeno(void);

GLOBAL int move_is_placement_valid(void);
GLOBAL boolean move_are_placed_tiles_adjacent(void);
GLOBAL boolean move_are_placed_tiles_contiguous(int horiz);



/* -------------------------------------------------------------------------- */
/* ------------------------ DEFINICE GLOBALNCH FUNKC ---------------------- */
/* -------------------------------------------------------------------------- */

/* -------------------------------------------------------------------------- */

/* Otestuje platnost tahu a v ppad neplatnosti slova jej vrac
 * v poli nenalezeno (definovan v deska.h (scarabeus.c) 
 * Vrac: TRUE - OK
 *        FALSE - ERROR 
 *        2 - Nkter kolm slovo je neplatn
 *        Navc se pln etzec 'nenalezeno[]' chybnm slovem a
 *        odehravane[] s tmt obsahem, akort ped psmenem zastupujc
 *        olka bude uvedena '*'.
*/
GLOBAL int tahy_is_move_valid(torientace o) {

    int i, k, l;
    char znak;
    tpozice p, le;
    Slovo test;

    test.n = 0;			/* Nulov dlka testovanho slova */
    k = 0;			/* Naplnme pole 'nenalezeno[]' */
    l = 0;			/* pro odehravane[] */
    

    /* Nejprve vezmeme njak prv odehran kmen a nalezneme zatek
     * slova, na kterm se tento kmen podl. Postupujeme ke konci tohoto
     * slova a pro kad kmen, kter jsme prv umstili z pihrdky,
     * zkontrolujeme, zda pat do cross-set mnoiny.
     *
     * Nakonec zkontrolujeme cel slovo.
    */

    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	if (rack_placed_tiles_coords[i].which != EMPTY_TILE) {
	    p.x = rack_placed_tiles_coords[i].x+1;
	    p.y = rack_placed_tiles_coords[i].y+1;
	    break;
	}
    
    /* Nyn je v 'p' souadnice njakho prv odehranho kamene */
    for(le=p; JEPISMENO(le); le=PRED(le,o)) ;
    le=ZA(le, o);

    /* Dleit piazen! Pro ukldn do tabulky s prbhem hry */
    mostleft = le;
    mostlefto = o;

    k = l = 0;
    strcpy(odehravane, "");    

    /* Te jsme na prvnm psmenu slova, budeme postupovat doprava */
    for(; JEPISMENO(le); le=ZA(le,o)) {

	/* Tvome slovo */
	printf("[le.x, le.y] = [%d,%d] ('%c') - ", le.x, le.y, 
					    board[le.x][le.y].znak);

	/* Vyzna, e jde o olka */ 
	    if (board_is_tile_joker(le.x-1, le.y-1) == TRUE) {
		printf("JE!\n");
		odehravane[l++] = '*';
		odehravane[l++] = PISMENO(le);
	    }
	    else {
		printf("NEN!\n");
		odehravane[l++] = PISMENO(le);
	    }
	    
	    test.c[test.n++] = znak = PISMENO(le);	 
	    nenalezeno[k++] = toupper(PISMENO(le));
	
	/* Zkontrolujeme cross-set jen pro nov kameny */
	if (board_is_it_tile_from_rack(le.x-1, le.y-1) == TRUE) {

#ifdef TAHY_GUI_DEBUG	    
	    printf("Testuji '%c' (%d) pro [%d,%d] - ", znak, o, le.x, le.y);
#endif

	    /* Mus patit do cross-set mnoiny */
	    if (je_v_cross_set(le, KOLMO(o), znak) == FALSE) {

#ifdef TAHY_GUI_DEBUG
		printf("[ERROR]\n");
#endif

		k = 0;
		strcpy(nenalezeno, "");

		/* Najdeme zatek chybnho kolmho slova */
		for(; JEPISMENO(le); le=PRED(le, KOLMO(o))) ;
		le=ZA(le, KOLMO(o));
		
		/* A pokraujeme na druh konec slova */
		for(; JEPISMENO(le); le=ZA(le, KOLMO(o)))
			nenalezeno[k++] = toupper(PISMENO(le));
		
		nenalezeno[k] = '\0';	/* Nechceme segfault :-) */

		return(2);
	    
	    }/* end if */
	    
#ifdef TAHY_GUI_DEBUG	    
	    printf("[OK]\n");
#endif
	            
	}/* end if */

    }/* end for */
    
    /* Korektn ukonme slova */
    test.c[test.n] = '\0'; nenalezeno[k] = '\0'; odehravane[l] = '\0';

    printf("odehravane = '%s'\n", odehravane);
    printf("nenalezeno = '%s'\n", nenalezeno);
    
#ifdef TAHY_GUI_DEBUG
    printf("Testuji slovo '%s' - ", test.c);
#endif

    if (!je_slovo(pocatecni_stav, &test)) {
#ifdef TAHY_GUI_DEBUG
	printf("[ERROR]\n");
#endif
	return(FALSE);
    }
#ifdef TAHY_GUI_DEBUG
    printf("[OK]\n");
#endif
    
    return(TRUE);

}/* end of tahy_is_move_valid() */

/* -------------------------------------------------------------------------- */

/* Vrt pozici nejlevjho psmena slova, kter vzniklo poloenm
 * naich kamen.
*/ 
GLOBAL tpozice tahy_nejlevejsi_pismeno(void) {

    tpozice pom;

    pom.x = (mostlefto == ZD) ? mostleft.x : mostleft.y;
    pom.y = (mostlefto == ZD) ? mostleft.y : mostleft.x;

    return(pom);
}

/* -------------------------------------------------------------------------- */
/* Zkontroluje, zda umstn kameny z racku "soused" s libovolnm ji
 * odehranm kamenem. Jde-li o prvn tah, sousednost je implicitn splnna.
*/
GLOBAL boolean move_are_placed_tiles_adjacent(void) {

    int i, x, y, which;
    boolean status = FALSE;

    if (mid_wanted == TRUE) /* Nen pedchoz tah => 
                               nejsou odehran kameny => OK */
        return(TRUE);

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
        if (rack_placed_tiles_coords[i].which != EMPTY_TILE) {
            x = rack_placed_tiles_coords[i].x;
            y = rack_placed_tiles_coords[i].y;
            which = rack_which_tile_at_coords(x, y);

            printf("testuji pilehlost kamene [%d,%d]\n", x+1, y+1);
            if (board_is_tile_adjacent(x, y) == TRUE)
                status = TRUE;
        }
    }/* end for */

    return(status);

}/* end of move_are_placed_tiles_adjacent() */


/* -------------------------------------------------------------------------- */

/* Otestuje, zda jsou vechny odehran kameny soust jednoho slova,
 * tzn. nen mezi nimi mezera.
 * Vrac: TRUE - OK
 *        FALSE - ERROR
*/
GLOBAL boolean move_are_placed_tiles_contiguous(int horiz) {

    int i, radek, sloupec;
    int minr = POC_KAMENU_VYSKA+1,
        maxr = 0,
        mins = POC_KAMENU_SIRKA+1,
        maxs = 0;
    int x, y;

    /* Pro vechny odehran kameny */
    for(i=0; i<MAX_PISMEN_PRIHRADKA; i++) {

        if (rack_placed_tiles_coords[i].which != EMPTY_TILE) {

            /* Hledme min/max dek a sloupec odehranch kamen */
            if (rack_placed_tiles_coords[i].x < minr)
                minr = rack_placed_tiles_coords[i].x;
            if (rack_placed_tiles_coords[i].x > maxr)
                maxr = rack_placed_tiles_coords[i].x;
           if (rack_placed_tiles_coords[i].y < mins)
                mins = rack_placed_tiles_coords[i].y;
            if (rack_placed_tiles_coords[i].y > maxs)
                maxs = rack_placed_tiles_coords[i].y;

        }/* end if */

    }/* end for */

    printf("min = [%d,%d], max = [%d,%d]\n", minr+1,mins+1,maxr+1,maxs+1);

    /* Vertikln tah, zam orientaci */
    if (!horiz) {
        mins = minr;
        minr = maxs;
        maxs = maxr;
        maxr = minr;
    }

    /* Projdi od v ad od minima do maxima pro danou orientaci a 
     * pokud naraz na przdn pole, odehran kameny netvo jedno
     * slovo a vra chybov stav.
    */
    radek = minr;
    for (sloupec = mins; sloupec <= maxs; sloupec++) {

        x = (horiz) ? radek : sloupec;
        y = (horiz) ? sloupec : radek;

        if (board_is_field_vacant(x, y) == TRUE) {
            printf("Mezera na [%d,%d]!\n", x+1,y+1);
            return (FALSE);
        }
    }

    return(TRUE);

}/* end of move_are_placed_tiles_contiguous() */

/* -------------------------------------------------------------------------- */

/* Zkontroluje, zda se umstn kameny z racku nachz v jednom
 * sloupci i dku. Nen-li dn kmen z racku umstn na desce,
 * jde o platn rozmstn.
 * Vrac: TRUE => OK
 *        2    => Kameny neprochz stedovm polkem
 *        3    => Kameny nejsou ve stejnm dku / sloupci
 *        4    => Kameny nesoused s odehranmi kameny
 *        5    => Kameny se nepodl na jednom slov (je mezi nimi mezera)
*/
GLOBAL int move_is_placement_valid(void) {

    int lastx, lasty, aktx, akty, i;
    int first;
    boolean statusx, statusy;             /* Zkontrolujeme x a pak y */
    boolean statusz;                      /* Prvn tah mus prochzet stedem */

    unsigned char MID_X, MID_Y;
    
    MID_X = POC_KAMENU_SIRKA/2; MID_Y = POC_KAMENU_VYSKA/2;

    statusz = FALSE;             /* Pedpokldme nesplnn */
    if (mid_wanted == TRUE) {
        for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
            if (rack_placed_tiles_coords[i].x == MID_X && 
                rack_placed_tiles_coords[i].y == MID_Y)
                    statusz = TRUE;                   /* Jsme OK */
        if (statusz == FALSE) {
            printf("Stedov pole neobsazeno!\n");
            return(2);
        }
    }/* end if */


    if (rack_is_something_placed() == FALSE) /* Nic nen umstno = OK */
        return(TRUE);

    /* Jsou vechny x-ov stejn? */
    statusx = TRUE;  /* Pedpokldme, e ano */
    first = 0; /* Nali jsme u alespo jeden umstn? */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
        if (statusx == FALSE)
            break;  /* Dl neteba testovat */
        if (rack_placed_tiles_coords[i].which == EMPTY_TILE)
            continue;                       /* Zajmaj ns jen umstn */
        else {      /* Jde o umstn kmen */
            first++;
            aktx = rack_placed_tiles_coords[i].x;
            if (first == 1)
                lastx = aktx;
            else
                if (lastx != aktx) {
                    statusx = FALSE;
                    continue;
                }
        }/* end else */
    }/* end for */

    /* Jsou vechny y-ov stejn? */
    statusy = TRUE;  /* Pedpokldme, e ano */
    first = 0; /* Nali jsme u alespo jeden umstn? */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
        if (statusy == FALSE)
            break;  /* Dl neteba testovat */
        if (rack_placed_tiles_coords[i].which == EMPTY_TILE)
            continue;                       /* Zajmaj ns jen umstn */
        else {      /* Jde o umstn kmen */
            first++;
            akty = rack_placed_tiles_coords[i].y;
            if (first == 1)
                lasty = akty;
            else
                if (lasty != akty) {
                    statusy = FALSE;
		    continue;
                }
        }/* end else */
    }/* end for */

    if (statusx == FALSE && statusy == FALSE)
        return(3);   /* Nele v jednom dku/sloupci, pilehlost netestuj */

    /* Nastav pznak pro testovn platnosti zahranho slova */
    /* POZOR! Je-li umstn jen jeden kmen, tak pro nj plat,
     * e je jak horizontal, tak vertical! Nutno oetit!!!
    */

    if (statusx == TRUE && statusy == TRUE) {
        /* Poloili jsme jen 1 kmen, podvej se doleva a doprava,
         * pokud je v sousedstv kmen -=> horizontln tah, jinak
         * jsme provedli vertikln.
        */

        /* aktx a akty jsou pi poloen jen jednoho kamene
         * prv jeho souadnice.
        */

        if ( (board[aktx+1][akty+2].znak != EMPTY_TILE) ||
             (board[aktx+1][akty].znak != EMPTY_TILE) )

            horizontal = TRUE;
        else
            horizontal = FALSE;
    }
    else
        horizontal = (statusx == TRUE) ? TRUE : FALSE;

    /* Nastav 'dek', ve kterm jsou umstny kameny */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
        if (rack_placed_tiles_coords[i].which != EMPTY_TILE) {
            row = (horizontal == TRUE) ?
            rack_placed_tiles_coords[i].x : rack_placed_tiles_coords[i].y;
            break;
        }


    /* Alespo jeden pokldan kmen mus sousedit s */
    /* libovolnm odehranm kamenem */
    if (move_are_placed_tiles_adjacent() == FALSE)
        return(4);

    /* Mezi kameny nesm bt mezera, mus existovat slovo, na kterm
     * se vechny podlej (pravidlo ASu).
    */
    if (move_are_placed_tiles_contiguous(horizontal) == FALSE)
        return(5);

    return(TRUE);

}/* end of move_is_placement_valid() */

/* -------------------------------------------------------------------------- */


/* -------------------------------------------------------------------------- */
/* ------------------------ DEFINICE LOCALNCH FUNKC ----------------------- */
/* -------------------------------------------------------------------------- */
