#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "vacek.h"
#include "deska.h"
#include "prihradka.h"


/* ---------------------------------------------------------------------------*/

/* Vek je implementovn takto: Nejprve se nate sada kamen do pole 
 * 'sada_kamenu' a vygeneruje se pole nhodnch index do tohoto pole
 * reprezentujc jednotliv kameny. Kadmu kameni (psmeni) se tak piad
 * jeho poad tahu z vku. Toto poad se mn s kadou vmnou hracch
 * kamen (resp. jen poad dosud neodehranch kamen). 
*/
/* ---------------------------------------------------------------------------*/


#define	TRUE	1
#define	FALSE   0


/*	      ---------------- GLOBALNI DEFINICE ----------------             */

GLOBAL skamen sada_kamenu[MAX_POCET_KAMENU]; /* pole se sadou psmen pro hru */
GLOBAL scetnost sada_cetnosti[MAX_POCET_KAMENU];    /* struktura s etnostmi */
GLOBAL svacek vacek[MAX_POCET_KAMENU];	   /* pole s nhodnm poadm psmen */

/*	      ----------------  LOKALNI DEFINICE ----------------             */
LOCAL int prihr_hr1[MAX_ROZMER];/* pole s po. v pihrdce hre1*/
LOCAL int prihr_hr2[MAX_ROZMER];/* pole s po. v pihrdce hre2 */
LOCAL int prihr_vym[MAX_ROZMER];/* pole s indexy 0-6, kter mnme */
LOCAL int pocet_ruznych_kamenu;  	  /* Kolik eho je */
LOCAL unsigned int sada_pocet_kamenu;	  /* celkem kamen pro hru */
LOCAL unsigned int zbytek;		  /* kolik kamen zbv ve vku */
LOCAL unsigned int ukvacek = 0;		  /* pozice tah z vku */


/* ---------------------------------------------------------------------------*/
		/* pln funkn prototypy GLOBALnch funkc */
/* ---------------------------------------------------------------------------*/

GLOBAL void nacti_sadu_kamenu(char *sada);
GLOBAL void vacek_inicializace_po_load(int pocet_kamenu, char *sada);
GLOBAL void vacek_nastav_pozici_ve_vacku(int pozice);
GLOBAL void zobraz_prihradku(int hrac);
GLOBAL int vacek_pocet_zbylych_kamenu(void);
GLOBAL int vacek_pocet_ruznych_kamenu(void);
GLOBAL int vacek_dej_pozici_ve_vacku(void);
GLOBAL int vacek_pocet_kamenu(void);
GLOBAL int vacek_vymen_kameny(int hrac);
GLOBAL int vacek_hrej_kameny(int hrac);

/* ---------------------------------------------------------------------------*/
		/* pln funkn prototypy LOCALnch funkc */
/* ---------------------------------------------------------------------------*/

LOCAL void vytvor_vacek_kamenu(int pocet_kamenu);
LOCAL void nastav_menitelny (int poradi, int status);
LOCAL void vymen_poradi(int co, int cim);
LOCAL void prihr_to_rack(int *prihradka, skamen *rack);
LOCAL void vacek_tahej_kameny(int kolik, int *prihradka);
LOCAL int otestuj_pole_kamenu(unsigned int poradi, unsigned int i);
LOCAL int spocti_kameny_v_racku(int hrac);
LOCAL int vacek_kolik_kamenu_dobrat(int hrac); 

/* ---------------------------------------------------------------------------*/
		        /* Vlastn definice funkc */
/* ---------------------------------------------------------------------------*/

/* nate sadu kamen z externho souboru, ulo jednotliv
 * kameny do sada_kamenu[] a vrt celkov poet kamen
*/
GLOBAL void nacti_sadu_kamenu(char *sada) {


    /* Pi 'hra_nova_hra' nen teba pod st ze souboru */
    static int count = 0;
    static int celkem = 0;
    
    int i=0, j, body, kolik, k;
    char pos[10] = "";
    char znak, pozice;

/* Sadu sta nast jen jednou pi startu aplikace */    
if (count == 0) {

    /* Vyprzdni sadu kamen */
    for(i=0;i<MAX_POCET_KAMENU;i++) {
	sada_kamenu[i].znak = sada_kamenu[i].hodnota = EMPTY_TILE;
	sada_cetnosti[i].znak = sada_cetnosti[i].hodnota = EMPTY_TILE;
	sada_cetnosti[i].pocet = EMPTY_TILE;
    }
    pocet_ruznych_kamenu = 0;
    

    i = pozice = 0;		/* POZOR!!! */
    while(i<strlen(sada)) {
        
	j = 0;
        while(sada[i] != ';')
            pos[j++] = sada[i++];
        pos[j] = '\0';
        i++;

        sscanf(pos, "%c,%d,%d", &znak, &body, &kolik); /* Vysekej hodnoty */

	sada_cetnosti[pocet_ruznych_kamenu].znak = znak;
	sada_cetnosti[pocet_ruznych_kamenu].hodnota = body;
	sada_cetnosti[pocet_ruznych_kamenu++].pocet = kolik;

	celkem += kolik;

	/* kolik = poet kamen s tmto psmenem, vytvo 'kolik' kamen */
	for(k=0; k<kolik; k++) {
	    sada_kamenu[pozice+k].znak = znak;
	    sada_kamenu[pozice+k].hodnota = body;
	}
	    
	pozice += kolik;
	    
    }/* end while */
    
}/* Count == 0 */

    /* Inicializaci vak volej vdy */
    for (i=0; i<MAX_POCET_KAMENU; i++) {
	vacek[i].poradi = EMPTY_TILE;		/* inicializace poad */
	vacek[i].menitelny = TRUE;		/* mniteln */
    }
   
    sada_pocet_kamenu = celkem;			/* nastav poet kamen */
    zbytek = sada_pocet_kamenu;			/* nastav zbytek pro hru */
    ukvacek = 0;				/* jsme na potku */
    
    vytvor_vacek_kamenu(sada_pocet_kamenu);     /* vytvo nhodn poad */
    
    vacek_tahej_kameny(MAX_PISMEN_PRIHRADKA, prihr_hr1);/* naber prvn kameny */
    vacek_tahej_kameny(MAX_PISMEN_PRIHRADKA, prihr_hr2); 
    
    prihr_to_rack(prihr_hr1, rack1);        /* peve do itelnho tvaru */
    prihr_to_rack(prihr_hr2, rack2);

    zobraz_prihradku(HRAC1);                     /* Jen textov */
    zobraz_prihradku(HRAC2);                  /* Jen textov */
    printf("--------------------------------------------------------------\n");

    count++;

}/* end nacti_sadu */

/* ---------------------------------------------------------------------------*/

/* Po nahrn stavu hry u mme pole sada_kamenu[] i vacek[] v pvodnm 
 * stavu. Sta jen naplnit pomocn struktury.
*/
GLOBAL void vacek_inicializace_po_load(int pocet_kamenu, char *sada) {

    int i=0, j, body, kolik;
    char pos[10] = "";
    char znak, pozice;

    /* Vyprzdni etnosti kamen */
    for(i=0;i<MAX_POCET_KAMENU;i++) {
	sada_cetnosti[i].znak = EMPTY_TILE;
	sada_cetnosti[i].hodnota = EMPTY_TILE;
	sada_cetnosti[i].pocet = EMPTY_TILE;
    }

    /* Vytvome nov etnosti */
    pocet_ruznych_kamenu = 0;

    i = pozice = 0;		/* POZOR!!! */
    while(i<strlen(sada)) {
        
	j = 0;
        while(sada[i] != ';')
            pos[j++] = sada[i++];
        pos[j] = '\0';
        i++;

        sscanf(pos, "%c,%d,%d", &znak, &body, &kolik); /* Vysekej hodnoty */

	sada_cetnosti[pocet_ruznych_kamenu].znak = znak;
	sada_cetnosti[pocet_ruznych_kamenu].hodnota = body;
	sada_cetnosti[pocet_ruznych_kamenu++].pocet = kolik;

    }/* end while */
    
    sada_pocet_kamenu = pocet_kamenu;		/* nastav poet kamen */
    zbytek = sada_pocet_kamenu - ukvacek; 	/* nastav zbytek pro hru */
   
    /* Nasypej do pihrdky sprvn poad (=obsah pihrdky) */
    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++) {
       prihr_hr1[i] = vacek[i].poradi;
       prihr_hr2[i] = vacek[i+MAX_PISMEN_PRIHRADKA].poradi;
    }
    
    prihr_to_rack(prihr_hr1, rack1);        /* peve do itelnho tvaru */
    prihr_to_rack(prihr_hr2, rack2);

    zobraz_prihradku(HRAC1);                     /* Jen textov */
    zobraz_prihradku(HRAC2);                  /* Jen textov */

    printf("LOAD----------------------------------------------------------\n");

}/* end of vacek_inicializace_po_load() */

/* ---------------------------------------------------------------------------*/

/* otestuje, zda v poli 'vacek' u nen zastoupen
 * poad 'poradi' - kvli nhodnmu vbru kamenu
*/
LOCAL int otestuj_pole_kamenu(unsigned int poradi, unsigned int i) {

    int k;

    for(k=0; k<i; k++)
	if (vacek[k].poradi == poradi)
	    return(1);
    
    return(0);
    
}/* end otestuj_pole_kamenu() */


/* ---------------------------------------------------------------------------*/

/* do 'vacek[i].poradi' se vlo nhodn poad psmene z sada_kamenu[] */
LOCAL void vytvor_vacek_kamenu(int pocet_kamenu) {

    unsigned int i = 0;
    unsigned int poradi;

    srand((unsigned int) time(NULL));
    poradi = rand() % pocet_kamenu;
    
    /* zamchme poad jen u tch, co je mon */
    /* tzn. u tch, co nejsou ji na hrac desce */
    for (i=0; i<pocet_kamenu; i++)
	if (vacek[i].menitelny == TRUE)
	    vacek[i].poradi = EMPTY_TILE;

    
    i = 0;
    while (i<pocet_kamenu) {
	if (vacek[i].menitelny == TRUE) {
	    if ( (otestuj_pole_kamenu(poradi,i)) == 0 ) {
		vacek[i].poradi = poradi;
		i++;
	    }
	}
	else i++;
	poradi = rand() % pocet_kamenu;

    }/* end while */
    
}/* end vytvor_vacek_kamenu() */


/* ---------------------------------------------------------------------------*/

/* Vrt poet zbylch kamen ve vku */
GLOBAL int vacek_pocet_zbylych_kamenu(void) {

    return(zbytek);
}

/* ---------------------------------------------------------------------------*/

/* Vrt pozici, kde se nachz ukazatel do pole 'vacek[]', kter
 * ukazuje na msto, odkud se budou tahat dal kameny.
*/
GLOBAL int vacek_dej_pozici_ve_vacku(void) {

    return(ukvacek);
}

/* ---------------------------------------------------------------------------*/

/* Nastav pozici ve vacek[] */
GLOBAL void vacek_nastav_pozici_ve_vacku(int pozice) {
    
    ukvacek = pozice;

}/* end of vacek_nastav_pozici_ve_vacku() */

/* ---------------------------------------------------------------------------*/

/* Vrt celkov poet kamen ve vku pro hru */
GLOBAL int vacek_pocet_kamenu(void) {

    return(sada_pocet_kamenu);
}

/* ---------------------------------------------------------------------------*/

/* Vrt poet rznch kamen */
GLOBAL int vacek_pocet_ruznych_kamenu(void) {

    return(pocet_ruznych_kamenu);
}

/* ---------------------------------------------------------------------------*/

/* Kmen je mon "zamchat" */
LOCAL void nastav_menitelny (int poradi, int status) {

    int i;
   
    if (poradi < 0)
	return;

    for (i=0; i<sada_pocet_kamenu; i++) {
	if (vacek[i].poradi == poradi) { 
	    vacek[i].menitelny = status;
	    return;
	}
    }

}/* end nastav_menitelny() */


/* ---------------------------------------------------------------------------*/

/* Vymn vacek[co] za vacek[cim] */
LOCAL void vymen_poradi(int co, int cim) {

    int poradi;
    unsigned char menitelny;

    poradi = vacek[co].poradi;
    menitelny = vacek[co].menitelny;
    vacek[co].poradi = vacek[cim].poradi;
    vacek[cim].poradi = poradi;

}/* end vymen_poradi() */

/* ---------------------------------------------------------------------------*/

/* Vrt poet kamen v odehran pihrdce */
LOCAL int spocti_kameny_v_racku(int hrac) {

    int i=0, kolik=0;

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) 
	if (rack_placed_tiles_coords[i].which == EMPTY_TILE) 
	    kolik++;

    return(kolik);
    
}/* end spocti_kameny_v_racku() */


/* ---------------------------------------------------------------------------*/

/* Vrt poet kamen, kter je poteba dobrat z vku */
/* To se dozv: MAX_PISMEN_PRIHRADKA - |rack_placed_tiles_coords != -1| */
LOCAL int vacek_kolik_kamenu_dobrat(int hrac) {

    int i, kolik = 0;    

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
	if (rack_placed_tiles_coords[i].which == EMPTY_TILE)
	    kolik++;


    return(MAX_PISMEN_PRIHRADKA - kolik);
}

/* -------------------------------------------------------------------------- */

GLOBAL void zobraz_prihradku(int hrac) {

    int i;
    skamen *prihradka;

    prihradka = (hrac == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */
    
    if (hrac == HRAC1)
	printf("Hr1:    ");
    else
	printf("Hr2: ");

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
	if (prihradka[i].znak != EMPTY_TILE)
	    printf("[%c, %d] | ", prihradka[i].znak, prihradka[i].hodnota); 
        else
	    printf("[EMPTY]| ");
	    
    
    printf("\n");

}/* end zobraz_prihradku() */


/* -------------------------------------------------------------------------- */

/* Pevede pihrdku (poad) -> rack (znak, hodnota, r, s) */
LOCAL void prihr_to_rack(int *prihradka, skamen *rack) {

    int i;

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	if (prihradka[i] != EMPTY_TILE) {
	    rack[i].znak = sada_kamenu[prihradka[i]].znak;
	    rack[i].hodnota = sada_kamenu[prihradka[i]].hodnota;
	}
	else {
	    rack[i].znak = EMPTY_TILE;
	    rack[i].hodnota = EMPTY_TILE;
	}
	
    }/* end for */
	
}

/* -------------------------------------------------------------------------- */

LOCAL void vacek_tahej_kameny(int kolik, int *prihradka) {

    int i;

    for (i=0; i<kolik; i++) 
	prihradka[i] = vacek[ukvacek+i].poradi;

    ukvacek += kolik;
    zbytek = sada_pocet_kamenu - ukvacek;

}/* end vacek_tahej_kameny() */

/* -------------------------------------------------------------------------- */

/* Vymn oznaen kameny v racku
 * Vrac: - poet vymnnch kamen
 *        - FALSE - Ve vku ji nejsou dn kameny
*/
GLOBAL int vacek_vymen_kameny(int hrac) {
 
    int i, j, kolik;
    int zmena[MAX_ROZMER];

    kolik = rack_how_many_exchange();

    printf("Budeme mnit %d kamen\n", kolik); 
    
    if (zbytek == 0) {
	printf("Ve vku ji nejsou kameny!!!\n");
	return(FALSE);
    }
    
    /* Resetuj struktury pro ukldn index pro vmnu */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	zmena[i] = EMPTY_TILE;
    }
   
    /* Do kterch mst v racku dobrat kameny? */
    for (i=0, j=0; i<MAX_PISMEN_PRIHRADKA; i++)
	if (rack_click[i] == TRUE)  /* Ta co jsou oznaen */
	    zmena[j++] = i;
	
#ifdef VACEK_DEBUG 
    printf("zmena =");
    for (i=0; i<kolik; i++) 
	printf("[%d],", zmena[i]);
    putchar('\n');
	
    printf("Ukvacek = %d\n", ukvacek); 
#endif
    
    /* Chceme vymnit vc ne je ve vku k dispozici, uprav */	
    if (kolik > zbytek) 
        kolik = zbytek;
    

    /* ------------------------------------*/

    for (i=0; i<kolik; i++) {

#ifdef VACEK_DEBUG	
	printf("Menim poradi (%d,%d)\n",zmena[i],ukvacek+i);
#endif
	
	if (hrac == HRAC1) 
	    prihr_hr1[zmena[i]] = vacek[ukvacek+i].poradi;
	else
	    prihr_hr2[zmena[i]] = vacek[ukvacek+i].poradi;
	
	vymen_poradi(zmena[i]+MAX_PISMEN_PRIHRADKA*(hrac), ukvacek+i);

    }/* end for (i) */
    
    /* nastav vem nemniteln */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	nastav_menitelny(prihr_hr1[i], FALSE);
	nastav_menitelny(prihr_hr2[i], FALSE);
    }

    /* po nvratu je teba zamchat vek */
    vytvor_vacek_kamenu(sada_pocet_kamenu);
    
    /* nastav opet vsem menitelny */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	nastav_menitelny(prihr_hr1[i], TRUE);
	nastav_menitelny(prihr_hr2[i], TRUE);
    }
    
    prihr_to_rack(prihr_hr1, rack1);
    prihr_to_rack(prihr_hr2, rack2);

    zobraz_prihradku(HRAC1);
    zobraz_prihradku(HRAC2);
    printf("--------------------------------------------------------------\n");
    
    printf("-------------------------------------------------------------\n");
    for(i=0; i<sada_pocet_kamenu; i++)
        if (!(vacek[i].menitelny))
	    printf("[%d:%d:%c]", i, vacek[i].poradi, sada_kamenu[i].znak);
    printf("\n-------------------------------------------------------------\n");
    
    return(kolik);
    
}/* end of vacek_vymen_kameny() */

/* -------------------------------------------------------------------------- */

/* Odehrej kameny na desce a do nati jich tolik, kolik jich bylo odehrno. 
 * Vrac: - poet dobranch kamen 
*/

GLOBAL int vacek_hrej_kameny(int hrac) {
    
    int i, j, kolik, pom = 0; 

    /* Kolik zstalo v racku neodehranch kamen? */
    pom = spocti_kameny_v_racku(hrac); 
    
#ifdef VACEK_DEBUG
    printf("v racku hre '%d' zstalo beze zmny %d kamen \n", hrac, pom);
#endif

    /* Resetuj msta, na kter budeme v racku dobrat */
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
	prihr_vym[i] = EMPTY_TILE;
   
    kolik = vacek_kolik_kamenu_dobrat(hrac); 
#ifdef VACEK_DEBUG
    printf("dobereme %d kameny \n", kolik);
#endif
    
    /* Do kterch mst v racku dobrat kameny? */
    for (i=0, j=0; i<MAX_PISMEN_PRIHRADKA; i++)
	if (rack_placed_tiles_coords[i].which != EMPTY_TILE)  
	    /* Ta co jsou neprzn */
	    prihr_vym[j++] = i;
	
    
    if (zbytek < MAX_PISMEN_PRIHRADKA) {
	pom = kolik;
	
	if (kolik > zbytek)
	    kolik = zbytek;
	
	for (i=0; i<kolik; i++) {
	    printf("<7: Hraju menim poradi (%d,%d)\n",
		prihr_vym[i]+MAX_PISMEN_PRIHRADKA*(hrac),ukvacek+i);

	    if (hrac == HRAC1) 
		prihr_hr1[prihr_vym[i]] = vacek[ukvacek+i].poradi;
	    else
		prihr_hr2[prihr_vym[i]] = vacek[ukvacek+i].poradi;
	    
	    vymen_poradi(prihr_vym[i]+MAX_PISMEN_PRIHRADKA*(hrac), ukvacek+i);
	    vacek[ukvacek+i].menitelny = FALSE; 
	}/* i == zbytek */
	
        ukvacek += kolik;

	if (pom > zbytek) {	
	    kolik = pom;
	
	    while (i < kolik) {

		if (hrac == HRAC1) 
		    prihr_hr1[prihr_vym[i]] = EMPTY_TILE;
		else
      		    prihr_hr2[prihr_vym[i]] = EMPTY_TILE;
		
		vacek[prihr_vym[i]+MAX_PISMEN_PRIHRADKA*(hrac)].menitelny = 0;
		i++;
	    }/* end while */
	}/* end if (pom > zbytek)*/

	/* nastav vsem menitelny */
	for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	    nastav_menitelny(prihr_hr1[i], TRUE);
	    nastav_menitelny(prihr_hr2[i], TRUE);
	}

	pom = spocti_kameny_v_racku(hrac);	
    	

    }/* end if zbytek < MAX_PISMEN_PRIHRADKA */
    else { 

	for (i=0; i<kolik; i++) {
	    printf("Hraju menim poradiXXX (%d,%d)\n",
		    prihr_vym[i]+MAX_PISMEN_PRIHRADKA*(hrac),ukvacek+i);

	    if (hrac == HRAC1) 
		prihr_hr1[prihr_vym[i]] = vacek[ukvacek+i].poradi;
	    else
  		prihr_hr2[prihr_vym[i]] = vacek[ukvacek+i].poradi;
	    
	    vymen_poradi(prihr_vym[i]+MAX_PISMEN_PRIHRADKA*(hrac), ukvacek+i);
	    vacek[ukvacek+i].menitelny = FALSE; 

	}/* end for (i) */
    
	/* nastav vsem menitelny */
	for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	    nastav_menitelny(prihr_hr1[i], TRUE);
	    nastav_menitelny(prihr_hr2[i], TRUE);
	}/* end for (i) */
    
	ukvacek += kolik; 
	
    }/* end else */
    
    zbytek = sada_pocet_kamenu - ukvacek;

    prihr_to_rack(prihr_hr1, rack1);
    prihr_to_rack(prihr_hr2, rack2);

    zobraz_prihradku(HRAC1);
    zobraz_prihradku(HRAC2);
    printf("--------------------------------------------------------------\n");
    
    printf("-------------------------------------------------------------\n");
    for(i=0; i<sada_pocet_kamenu; i++)
        if (!(vacek[i].menitelny))
	    printf("[%d:%d:%c]", i, vacek[i].poradi, sada_kamenu[i].znak);
    printf("\n-------------------------------------------------------------\n");

    printf("VACEK VRACI = %d\n", MAX_PISMEN_PRIHRADKA-pom);
    return(MAX_PISMEN_PRIHRADKA - pom);
    
}/* end of vacek_hrej_kameny() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE vacek.c */
